// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/pipeline_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fpipeline_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fpipeline_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/pipeline_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// A service for creating and managing Vertex AI's pipelines. This includes both
// `TrainingPipeline` resources (used for AutoML and custom training) and
// `PipelineJob` resources (used for Vertex AI Pipelines).
class PipelineService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.PipelineService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a TrainingPipeline. A created TrainingPipeline right away will be
    // attempted to be run.
    virtual ::grpc::Status CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>> AsyncCreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>>(AsyncCreateTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>> PrepareAsyncCreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>>(PrepareAsyncCreateTrainingPipelineRaw(context, request, cq));
    }
    // Gets a TrainingPipeline.
    virtual ::grpc::Status GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>> AsyncGetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>>(AsyncGetTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>> PrepareAsyncGetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>>(PrepareAsyncGetTrainingPipelineRaw(context, request, cq));
    }
    // Lists TrainingPipelines in a Location.
    virtual ::grpc::Status ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>> AsyncListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>>(AsyncListTrainingPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>> PrepareAsyncListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>>(PrepareAsyncListTrainingPipelinesRaw(context, request, cq));
    }
    // Deletes a TrainingPipeline.
    virtual ::grpc::Status DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTrainingPipelineRaw(context, request, cq));
    }
    // Cancels a TrainingPipeline.
    // Starts asynchronous cancellation on the TrainingPipeline. The server
    // makes a best effort to cancel the pipeline, but success is not
    // guaranteed. Clients can use
    // [PipelineService.GetTrainingPipeline][google.cloud.aiplatform.v1.PipelineService.GetTrainingPipeline]
    // or other methods to check whether the cancellation succeeded or whether the
    // pipeline completed despite cancellation. On successful cancellation,
    // the TrainingPipeline is not deleted; instead it becomes a pipeline with
    // a
    // [TrainingPipeline.error][google.cloud.aiplatform.v1.TrainingPipeline.error]
    // value with a [google.rpc.Status.code][google.rpc.Status.code] of 1,
    // corresponding to `Code.CANCELLED`, and
    // [TrainingPipeline.state][google.cloud.aiplatform.v1.TrainingPipeline.state]
    // is set to `CANCELLED`.
    virtual ::grpc::Status CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncCancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncCancelTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncCancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncCancelTrainingPipelineRaw(context, request, cq));
    }
    // Creates a PipelineJob. A PipelineJob will run immediately when created.
    virtual ::grpc::Status CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::google::cloud::aiplatform::v1::PipelineJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>> AsyncCreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>>(AsyncCreatePipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>> PrepareAsyncCreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>>(PrepareAsyncCreatePipelineJobRaw(context, request, cq));
    }
    // Gets a PipelineJob.
    virtual ::grpc::Status GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::google::cloud::aiplatform::v1::PipelineJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>> AsyncGetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>>(AsyncGetPipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>> PrepareAsyncGetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>>(PrepareAsyncGetPipelineJobRaw(context, request, cq));
    }
    // Lists PipelineJobs in a Location.
    virtual ::grpc::Status ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>> AsyncListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>>(AsyncListPipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>> PrepareAsyncListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>>(PrepareAsyncListPipelineJobsRaw(context, request, cq));
    }
    // Deletes a PipelineJob.
    virtual ::grpc::Status DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePipelineJobRaw(context, request, cq));
    }
    // Batch deletes PipelineJobs
    // The Operation is atomic. If it fails, none of the PipelineJobs are deleted.
    // If it succeeds, all of the PipelineJobs are deleted.
    virtual ::grpc::Status BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeletePipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeletePipelineJobsRaw(context, request, cq));
    }
    // Cancels a PipelineJob.
    // Starts asynchronous cancellation on the PipelineJob. The server
    // makes a best effort to cancel the pipeline, but success is not
    // guaranteed. Clients can use
    // [PipelineService.GetPipelineJob][google.cloud.aiplatform.v1.PipelineService.GetPipelineJob]
    // or other methods to check whether the cancellation succeeded or whether the
    // pipeline completed despite cancellation. On successful cancellation,
    // the PipelineJob is not deleted; instead it becomes a pipeline with
    // a [PipelineJob.error][google.cloud.aiplatform.v1.PipelineJob.error] value
    // with a [google.rpc.Status.code][google.rpc.Status.code] of 1, corresponding
    // to `Code.CANCELLED`, and
    // [PipelineJob.state][google.cloud.aiplatform.v1.PipelineJob.state] is set to
    // `CANCELLED`.
    virtual ::grpc::Status CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncCancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncCancelPipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncCancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncCancelPipelineJobRaw(context, request, cq));
    }
    // Batch cancel PipelineJobs.
    // Firstly the server will check if all the jobs are in non-terminal states,
    // and skip the jobs that are already terminated.
    // If the operation failed, none of the pipeline jobs are cancelled.
    // The server will poll the states of all the pipeline jobs periodically
    // to check the cancellation status.
    // This operation will return an LRO.
    virtual ::grpc::Status BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchCancelPipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchCancelPipelineJobsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a TrainingPipeline. A created TrainingPipeline right away will be
      // attempted to be run.
      virtual void CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a TrainingPipeline.
      virtual void GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists TrainingPipelines in a Location.
      virtual void ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a TrainingPipeline.
      virtual void DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a TrainingPipeline.
      // Starts asynchronous cancellation on the TrainingPipeline. The server
      // makes a best effort to cancel the pipeline, but success is not
      // guaranteed. Clients can use
      // [PipelineService.GetTrainingPipeline][google.cloud.aiplatform.v1.PipelineService.GetTrainingPipeline]
      // or other methods to check whether the cancellation succeeded or whether the
      // pipeline completed despite cancellation. On successful cancellation,
      // the TrainingPipeline is not deleted; instead it becomes a pipeline with
      // a
      // [TrainingPipeline.error][google.cloud.aiplatform.v1.TrainingPipeline.error]
      // value with a [google.rpc.Status.code][google.rpc.Status.code] of 1,
      // corresponding to `Code.CANCELLED`, and
      // [TrainingPipeline.state][google.cloud.aiplatform.v1.TrainingPipeline.state]
      // is set to `CANCELLED`.
      virtual void CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a PipelineJob. A PipelineJob will run immediately when created.
      virtual void CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a PipelineJob.
      virtual void GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists PipelineJobs in a Location.
      virtual void ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a PipelineJob.
      virtual void DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Batch deletes PipelineJobs
      // The Operation is atomic. If it fails, none of the PipelineJobs are deleted.
      // If it succeeds, all of the PipelineJobs are deleted.
      virtual void BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a PipelineJob.
      // Starts asynchronous cancellation on the PipelineJob. The server
      // makes a best effort to cancel the pipeline, but success is not
      // guaranteed. Clients can use
      // [PipelineService.GetPipelineJob][google.cloud.aiplatform.v1.PipelineService.GetPipelineJob]
      // or other methods to check whether the cancellation succeeded or whether the
      // pipeline completed despite cancellation. On successful cancellation,
      // the PipelineJob is not deleted; instead it becomes a pipeline with
      // a [PipelineJob.error][google.cloud.aiplatform.v1.PipelineJob.error] value
      // with a [google.rpc.Status.code][google.rpc.Status.code] of 1, corresponding
      // to `Code.CANCELLED`, and
      // [PipelineJob.state][google.cloud.aiplatform.v1.PipelineJob.state] is set to
      // `CANCELLED`.
      virtual void CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Batch cancel PipelineJobs.
      // Firstly the server will check if all the jobs are in non-terminal states,
      // and skip the jobs that are already terminated.
      // If the operation failed, none of the pipeline jobs are cancelled.
      // The server will poll the states of all the pipeline jobs periodically
      // to check the cancellation status.
      // This operation will return an LRO.
      virtual void BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>* AsyncCreateTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>* PrepareAsyncCreateTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>* AsyncGetTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::TrainingPipeline>* PrepareAsyncGetTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* AsyncListTrainingPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* PrepareAsyncListTrainingPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncCancelTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncCancelTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>* AsyncCreatePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>* PrepareAsyncCreatePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>* AsyncGetPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PipelineJob>* PrepareAsyncGetPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* AsyncListPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* PrepareAsyncListPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeletePipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeletePipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncCancelPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncCancelPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchCancelPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchCancelPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>> AsyncCreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>>(AsyncCreateTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>> PrepareAsyncCreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>>(PrepareAsyncCreateTrainingPipelineRaw(context, request, cq));
    }
    ::grpc::Status GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>> AsyncGetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>>(AsyncGetTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>> PrepareAsyncGetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>>(PrepareAsyncGetTrainingPipelineRaw(context, request, cq));
    }
    ::grpc::Status ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>> AsyncListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>>(AsyncListTrainingPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>> PrepareAsyncListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>>(PrepareAsyncListTrainingPipelinesRaw(context, request, cq));
    }
    ::grpc::Status DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTrainingPipelineRaw(context, request, cq));
    }
    ::grpc::Status CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncCancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncCancelTrainingPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncCancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncCancelTrainingPipelineRaw(context, request, cq));
    }
    ::grpc::Status CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::google::cloud::aiplatform::v1::PipelineJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>> AsyncCreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>>(AsyncCreatePipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>> PrepareAsyncCreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>>(PrepareAsyncCreatePipelineJobRaw(context, request, cq));
    }
    ::grpc::Status GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::google::cloud::aiplatform::v1::PipelineJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>> AsyncGetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>>(AsyncGetPipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>> PrepareAsyncGetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>>(PrepareAsyncGetPipelineJobRaw(context, request, cq));
    }
    ::grpc::Status ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>> AsyncListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>>(AsyncListPipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>> PrepareAsyncListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>>(PrepareAsyncListPipelineJobsRaw(context, request, cq));
    }
    ::grpc::Status DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePipelineJobRaw(context, request, cq));
    }
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeletePipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeletePipelineJobsRaw(context, request, cq));
    }
    ::grpc::Status CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncCancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncCancelPipelineJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncCancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncCancelPipelineJobRaw(context, request, cq));
    }
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchCancelPipelineJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchCancelPipelineJobsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, std::function<void(::grpc::Status)>) override;
      void CreateTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, std::function<void(::grpc::Status)>) override;
      void GetTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTrainingPipelines(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void CancelTrainingPipeline(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, std::function<void(::grpc::Status)>) override;
      void CreatePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, std::function<void(::grpc::Status)>) override;
      void GetPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeletePipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void CancelPipelineJob(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchCancelPipelineJobs(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>* AsyncCreateTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>* PrepareAsyncCreateTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>* AsyncGetTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::TrainingPipeline>* PrepareAsyncGetTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* AsyncListTrainingPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* PrepareAsyncListTrainingPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncCancelTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncCancelTrainingPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>* AsyncCreatePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>* PrepareAsyncCreatePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>* AsyncGetPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PipelineJob>* PrepareAsyncGetPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* AsyncListPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* PrepareAsyncListPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeletePipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeletePipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncCancelPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncCancelPipelineJobRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchCancelPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchCancelPipelineJobsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTrainingPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTrainingPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTrainingPipelines_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTrainingPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelTrainingPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePipelineJob_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPipelineJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPipelineJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePipelineJob_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeletePipelineJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelPipelineJob_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCancelPipelineJobs_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a TrainingPipeline. A created TrainingPipeline right away will be
    // attempted to be run.
    virtual ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response);
    // Gets a TrainingPipeline.
    virtual ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response);
    // Lists TrainingPipelines in a Location.
    virtual ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response);
    // Deletes a TrainingPipeline.
    virtual ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response);
    // Cancels a TrainingPipeline.
    // Starts asynchronous cancellation on the TrainingPipeline. The server
    // makes a best effort to cancel the pipeline, but success is not
    // guaranteed. Clients can use
    // [PipelineService.GetTrainingPipeline][google.cloud.aiplatform.v1.PipelineService.GetTrainingPipeline]
    // or other methods to check whether the cancellation succeeded or whether the
    // pipeline completed despite cancellation. On successful cancellation,
    // the TrainingPipeline is not deleted; instead it becomes a pipeline with
    // a
    // [TrainingPipeline.error][google.cloud.aiplatform.v1.TrainingPipeline.error]
    // value with a [google.rpc.Status.code][google.rpc.Status.code] of 1,
    // corresponding to `Code.CANCELLED`, and
    // [TrainingPipeline.state][google.cloud.aiplatform.v1.TrainingPipeline.state]
    // is set to `CANCELLED`.
    virtual ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response);
    // Creates a PipelineJob. A PipelineJob will run immediately when created.
    virtual ::grpc::Status CreatePipelineJob(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response);
    // Gets a PipelineJob.
    virtual ::grpc::Status GetPipelineJob(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response);
    // Lists PipelineJobs in a Location.
    virtual ::grpc::Status ListPipelineJobs(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response);
    // Deletes a PipelineJob.
    virtual ::grpc::Status DeletePipelineJob(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response);
    // Batch deletes PipelineJobs
    // The Operation is atomic. If it fails, none of the PipelineJobs are deleted.
    // If it succeeds, all of the PipelineJobs are deleted.
    virtual ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response);
    // Cancels a PipelineJob.
    // Starts asynchronous cancellation on the PipelineJob. The server
    // makes a best effort to cancel the pipeline, but success is not
    // guaranteed. Clients can use
    // [PipelineService.GetPipelineJob][google.cloud.aiplatform.v1.PipelineService.GetPipelineJob]
    // or other methods to check whether the cancellation succeeded or whether the
    // pipeline completed despite cancellation. On successful cancellation,
    // the PipelineJob is not deleted; instead it becomes a pipeline with
    // a [PipelineJob.error][google.cloud.aiplatform.v1.PipelineJob.error] value
    // with a [google.rpc.Status.code][google.rpc.Status.code] of 1, corresponding
    // to `Code.CANCELLED`, and
    // [PipelineJob.state][google.cloud.aiplatform.v1.PipelineJob.state] is set to
    // `CANCELLED`.
    virtual ::grpc::Status CancelPipelineJob(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response);
    // Batch cancel PipelineJobs.
    // Firstly the server will check if all the jobs are in non-terminal states,
    // and skip the jobs that are already terminated.
    // If the operation failed, none of the pipeline jobs are cancelled.
    // The server will poll the states of all the pipeline jobs periodically
    // to check the cancellation status.
    // This operation will return an LRO.
    virtual ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrainingPipeline(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::TrainingPipeline>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrainingPipeline(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::TrainingPipeline>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrainingPipelines(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrainingPipeline(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelTrainingPipeline(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePipelineJob(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::PipelineJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPipelineJob(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::PipelineJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPipelineJobs(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePipelineJob(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeletePipelineJobs(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelPipelineJob(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCancelPipelineJobs(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateTrainingPipeline<WithAsyncMethod_GetTrainingPipeline<WithAsyncMethod_ListTrainingPipelines<WithAsyncMethod_DeleteTrainingPipeline<WithAsyncMethod_CancelTrainingPipeline<WithAsyncMethod_CreatePipelineJob<WithAsyncMethod_GetPipelineJob<WithAsyncMethod_ListPipelineJobs<WithAsyncMethod_DeletePipelineJob<WithAsyncMethod_BatchDeletePipelineJobs<WithAsyncMethod_CancelPipelineJob<WithAsyncMethod_BatchCancelPipelineJobs<Service > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) { return this->CreateTrainingPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTrainingPipeline(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* request, ::google::cloud::aiplatform::v1::TrainingPipeline* response) { return this->GetTrainingPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_GetTrainingPipeline(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* request, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* response) { return this->ListTrainingPipelines(context, request, response); }));}
    void SetMessageAllocatorFor_ListTrainingPipelines(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrainingPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTrainingPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTrainingPipeline(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* request, ::google::protobuf::Empty* response) { return this->CancelTrainingPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_CancelTrainingPipeline(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreatePipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response) { return this->CreatePipelineJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePipelineJob(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CreatePipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreatePipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetPipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* request, ::google::cloud::aiplatform::v1::PipelineJob* response) { return this->GetPipelineJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetPipelineJob(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::GetPipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetPipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListPipelineJobsRequest, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* request, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* response) { return this->ListPipelineJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListPipelineJobs(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListPipelineJobsRequest, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListPipelineJobsRequest, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeletePipelineJobRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* request, ::google::longrunning::Operation* response) { return this->DeletePipelineJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePipelineJob(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::DeletePipelineJobRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeletePipelineJobRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* request, ::google::longrunning::Operation* response) { return this->BatchDeletePipelineJobs(context, request, response); }));}
    void SetMessageAllocatorFor_BatchDeletePipelineJobs(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeletePipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CancelPipelineJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* request, ::google::protobuf::Empty* response) { return this->CancelPipelineJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelPipelineJob(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CancelPipelineJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CancelPipelineJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelPipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* request, ::google::longrunning::Operation* response) { return this->BatchCancelPipelineJobs(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCancelPipelineJobs(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCancelPipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateTrainingPipeline<WithCallbackMethod_GetTrainingPipeline<WithCallbackMethod_ListTrainingPipelines<WithCallbackMethod_DeleteTrainingPipeline<WithCallbackMethod_CancelTrainingPipeline<WithCallbackMethod_CreatePipelineJob<WithCallbackMethod_GetPipelineJob<WithCallbackMethod_ListPipelineJobs<WithCallbackMethod_DeletePipelineJob<WithCallbackMethod_BatchDeletePipelineJobs<WithCallbackMethod_CancelPipelineJob<WithCallbackMethod_BatchCancelPipelineJobs<Service > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrainingPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrainingPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrainingPipelines(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrainingPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelTrainingPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePipelineJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPipelineJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPipelineJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePipelineJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeletePipelineJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelPipelineJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCancelPipelineJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTrainingPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTrainingPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTrainingPipelines(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrainingPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTrainingPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelTrainingPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelTrainingPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePipelineJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPipelineJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPipelineJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePipelineJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchDeletePipelineJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeletePipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelPipelineJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelPipelineJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCancelPipelineJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCancelPipelineJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTrainingPipeline() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>* streamer) {
                       return this->StreamedCreateTrainingPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTrainingPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CreateTrainingPipelineRequest,::google::cloud::aiplatform::v1::TrainingPipeline>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTrainingPipeline() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest, ::google::cloud::aiplatform::v1::TrainingPipeline>* streamer) {
                       return this->StreamedGetTrainingPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest* /*request*/, ::google::cloud::aiplatform::v1::TrainingPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTrainingPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::GetTrainingPipelineRequest,::google::cloud::aiplatform::v1::TrainingPipeline>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTrainingPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTrainingPipelines() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* streamer) {
                       return this->StreamedListTrainingPipelines(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTrainingPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTrainingPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTrainingPipelines(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListTrainingPipelinesRequest,::google::cloud::aiplatform::v1::ListTrainingPipelinesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTrainingPipeline() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTrainingPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTrainingPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::DeleteTrainingPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelTrainingPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelTrainingPipeline() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedCancelTrainingPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelTrainingPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelTrainingPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelTrainingPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CancelTrainingPipelineRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePipelineJob() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CreatePipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CreatePipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>* streamer) {
                       return this->StreamedCreatePipelineJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreatePipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePipelineJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CreatePipelineJobRequest,::google::cloud::aiplatform::v1::PipelineJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPipelineJob() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::GetPipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::GetPipelineJobRequest, ::google::cloud::aiplatform::v1::PipelineJob>* streamer) {
                       return this->StreamedGetPipelineJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetPipelineJobRequest* /*request*/, ::google::cloud::aiplatform::v1::PipelineJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPipelineJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::GetPipelineJobRequest,::google::cloud::aiplatform::v1::PipelineJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPipelineJobs() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListPipelineJobsRequest, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListPipelineJobsRequest, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* streamer) {
                       return this->StreamedListPipelineJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListPipelineJobsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListPipelineJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPipelineJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListPipelineJobsRequest,::google::cloud::aiplatform::v1::ListPipelineJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePipelineJob() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::DeletePipelineJobRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::DeletePipelineJobRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePipelineJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeletePipelineJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePipelineJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::DeletePipelineJobRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeletePipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeletePipelineJobs() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchDeletePipelineJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchDeletePipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeletePipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeletePipelineJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::BatchDeletePipelineJobsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelPipelineJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelPipelineJob() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CancelPipelineJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CancelPipelineJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedCancelPipelineJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelPipelineJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelPipelineJob(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CancelPipelineJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelPipelineJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CancelPipelineJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCancelPipelineJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCancelPipelineJobs() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchCancelPipelineJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCancelPipelineJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCancelPipelineJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCancelPipelineJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::BatchCancelPipelineJobsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateTrainingPipeline<WithStreamedUnaryMethod_GetTrainingPipeline<WithStreamedUnaryMethod_ListTrainingPipelines<WithStreamedUnaryMethod_DeleteTrainingPipeline<WithStreamedUnaryMethod_CancelTrainingPipeline<WithStreamedUnaryMethod_CreatePipelineJob<WithStreamedUnaryMethod_GetPipelineJob<WithStreamedUnaryMethod_ListPipelineJobs<WithStreamedUnaryMethod_DeletePipelineJob<WithStreamedUnaryMethod_BatchDeletePipelineJobs<WithStreamedUnaryMethod_CancelPipelineJob<WithStreamedUnaryMethod_BatchCancelPipelineJobs<Service > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateTrainingPipeline<WithStreamedUnaryMethod_GetTrainingPipeline<WithStreamedUnaryMethod_ListTrainingPipelines<WithStreamedUnaryMethod_DeleteTrainingPipeline<WithStreamedUnaryMethod_CancelTrainingPipeline<WithStreamedUnaryMethod_CreatePipelineJob<WithStreamedUnaryMethod_GetPipelineJob<WithStreamedUnaryMethod_ListPipelineJobs<WithStreamedUnaryMethod_DeletePipelineJob<WithStreamedUnaryMethod_BatchDeletePipelineJobs<WithStreamedUnaryMethod_CancelPipelineJob<WithStreamedUnaryMethod_BatchCancelPipelineJobs<Service > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fpipeline_5fservice_2eproto__INCLUDED
