// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/billing/v1/cloud_catalog.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbilling_2fv1_2fcloud_5fcatalog_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbilling_2fv1_2fcloud_5fcatalog_2eproto__INCLUDED

#include "google/cloud/billing/v1/cloud_catalog.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace billing {
namespace v1 {

// A catalog of Google Cloud Platform services and SKUs.
// Provides pricing information and metadata on Google Cloud Platform services
// and SKUs.
class CloudCatalog final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.billing.v1.CloudCatalog";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all public cloud services.
    virtual ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::google::cloud::billing::v1::ListServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    // Lists all publicly available SKUs for a given cloud service.
    virtual ::grpc::Status ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::google::cloud::billing::v1::ListSkusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>> AsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>>(AsyncListSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>> PrepareAsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>>(PrepareAsyncListSkusRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all public cloud services.
      virtual void ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all publicly available SKUs for a given cloud service.
      virtual void ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>* AsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::v1::ListSkusResponse>* PrepareAsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::google::cloud::billing::v1::ListServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    ::grpc::Status ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::google::cloud::billing::v1::ListSkusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>> AsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>>(AsyncListSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>> PrepareAsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>>(PrepareAsyncListSkusRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServices(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSkus(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>* AsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::v1::ListSkusResponse>* PrepareAsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::billing::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListServices_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSkus_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all public cloud services.
    virtual ::grpc::Status ListServices(::grpc::ServerContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response);
    // Lists all publicly available SKUs for a given cloud service.
    virtual ::grpc::Status ListSkus(::grpc::ServerContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServices() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::google::cloud::billing::v1::ListServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::v1::ListServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSkus() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkus(::grpc::ServerContext* context, ::google::cloud::billing::v1::ListSkusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::v1::ListSkusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListServices<WithAsyncMethod_ListSkus<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::v1::ListServicesRequest, ::google::cloud::billing::v1::ListServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::v1::ListServicesRequest* request, ::google::cloud::billing::v1::ListServicesResponse* response) { return this->ListServices(context, request, response); }));}
    void SetMessageAllocatorFor_ListServices(
        ::grpc::MessageAllocator< ::google::cloud::billing::v1::ListServicesRequest, ::google::cloud::billing::v1::ListServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::v1::ListServicesRequest, ::google::cloud::billing::v1::ListServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSkus() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::v1::ListSkusRequest, ::google::cloud::billing::v1::ListSkusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::v1::ListSkusRequest* request, ::google::cloud::billing::v1::ListSkusResponse* response) { return this->ListSkus(context, request, response); }));}
    void SetMessageAllocatorFor_ListSkus(
        ::grpc::MessageAllocator< ::google::cloud::billing::v1::ListSkusRequest, ::google::cloud::billing::v1::ListSkusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::v1::ListSkusRequest, ::google::cloud::billing::v1::ListSkusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListServices<WithCallbackMethod_ListSkus<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServices() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSkus() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServices() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSkus() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSkus() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSkus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServices() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::v1::ListServicesRequest, ::google::cloud::billing::v1::ListServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::v1::ListServicesRequest, ::google::cloud::billing::v1::ListServicesResponse>* streamer) {
                       return this->StreamedListServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListServicesRequest* /*request*/, ::google::cloud::billing::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::v1::ListServicesRequest,::google::cloud::billing::v1::ListServicesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSkus() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::v1::ListSkusRequest, ::google::cloud::billing::v1::ListSkusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::v1::ListSkusRequest, ::google::cloud::billing::v1::ListSkusResponse>* streamer) {
                       return this->StreamedListSkus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::v1::ListSkusRequest* /*request*/, ::google::cloud::billing::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSkus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::v1::ListSkusRequest,::google::cloud::billing::v1::ListSkusResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_ListSkus<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_ListSkus<Service > > StreamedService;
};

}  // namespace v1
}  // namespace billing
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fbilling_2fv1_2fcloud_5fcatalog_2eproto__INCLUDED
