// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/commerce/consumer/procurement/v1/procurement_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fcommerce_2fconsumer_2fprocurement_2fv1_2fprocurement_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fcommerce_2fconsumer_2fprocurement_2fv1_2fprocurement_5fservice_2eproto__INCLUDED

#include "google/cloud/commerce/consumer/procurement/v1/procurement_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace commerce {
namespace consumer {
namespace procurement {
namespace v1 {

// ConsumerProcurementService allows customers to make purchases of products
// served by the Cloud Commerce platform.
//
//
// When purchases are made, the
// [ConsumerProcurementService][google.cloud.commerce.consumer.procurement.v1.ConsumerProcurementService]
// programs the appropriate backends, including both Google's own
// infrastructure, as well as third-party systems, and to enable billing setup
// for charging for the procured item.
//
class ConsumerProcurementService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.commerce.consumer.procurement.v1.ConsumerProcurementService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new [Order][google.cloud.commerce.consumer.procurement.v1.Order].
    //
    // This API only supports GCP spend-based committed use
    // discounts specified by GCP documentation.
    //
    // The returned long-running operation is in-progress until the backend
    // completes the creation of the resource. Once completed, the order is
    // in
    // [OrderState.ORDER_STATE_ACTIVE][google.cloud.commerce.consumer.procurement.v1.OrderState.ORDER_STATE_ACTIVE].
    // In case of failure, the order resource will be removed.
    virtual ::grpc::Status PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncPlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncPlaceOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncPlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncPlaceOrderRaw(context, request, cq));
    }
    // Returns the requested
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
    virtual ::grpc::Status GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::google::cloud::commerce::consumer::procurement::v1::Order* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>> AsyncGetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>>(AsyncGetOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>> PrepareAsyncGetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>>(PrepareAsyncGetOrderRaw(context, request, cq));
    }
    // Lists [Order][google.cloud.commerce.consumer.procurement.v1.Order]
    // resources that the user has access to, within the scope of the parent
    // resource.
    virtual ::grpc::Status ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>> AsyncListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>>(AsyncListOrdersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>> PrepareAsyncListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>>(PrepareAsyncListOrdersRaw(context, request, cq));
    }
    // Modifies an existing
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
    virtual ::grpc::Status ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncModifyOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncModifyOrderRaw(context, request, cq));
    }
    // Cancels an existing
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order]. Every product
    // procured in the Order will be cancelled.
    virtual ::grpc::Status CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCancelOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCancelOrderRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new [Order][google.cloud.commerce.consumer.procurement.v1.Order].
      //
      // This API only supports GCP spend-based committed use
      // discounts specified by GCP documentation.
      //
      // The returned long-running operation is in-progress until the backend
      // completes the creation of the resource. Once completed, the order is
      // in
      // [OrderState.ORDER_STATE_ACTIVE][google.cloud.commerce.consumer.procurement.v1.OrderState.ORDER_STATE_ACTIVE].
      // In case of failure, the order resource will be removed.
      virtual void PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested
      // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
      virtual void GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [Order][google.cloud.commerce.consumer.procurement.v1.Order]
      // resources that the user has access to, within the scope of the parent
      // resource.
      virtual void ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies an existing
      // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
      virtual void ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels an existing
      // [Order][google.cloud.commerce.consumer.procurement.v1.Order]. Every product
      // procured in the Order will be cancelled.
      virtual void CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncPlaceOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncPlaceOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>* AsyncGetOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::Order>* PrepareAsyncGetOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* AsyncListOrdersRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* PrepareAsyncListOrdersRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncModifyOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncModifyOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCancelOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCancelOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncPlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncPlaceOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncPlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncPlaceOrderRaw(context, request, cq));
    }
    ::grpc::Status GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::google::cloud::commerce::consumer::procurement::v1::Order* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>> AsyncGetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>>(AsyncGetOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>> PrepareAsyncGetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>>(PrepareAsyncGetOrderRaw(context, request, cq));
    }
    ::grpc::Status ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>> AsyncListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>>(AsyncListOrdersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>> PrepareAsyncListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>>(PrepareAsyncListOrdersRaw(context, request, cq));
    }
    ::grpc::Status ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncModifyOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncModifyOrderRaw(context, request, cq));
    }
    ::grpc::Status CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCancelOrderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCancelOrderRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void PlaceOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response, std::function<void(::grpc::Status)>) override;
      void GetOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOrders(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ModifyOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CancelOrder(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncPlaceOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncPlaceOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>* AsyncGetOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::Order>* PrepareAsyncGetOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* AsyncListOrdersRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* PrepareAsyncListOrdersRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncModifyOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncModifyOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCancelOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCancelOrderRaw(::grpc::ClientContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_PlaceOrder_;
    const ::grpc::internal::RpcMethod rpcmethod_GetOrder_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOrders_;
    const ::grpc::internal::RpcMethod rpcmethod_ModifyOrder_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelOrder_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new [Order][google.cloud.commerce.consumer.procurement.v1.Order].
    //
    // This API only supports GCP spend-based committed use
    // discounts specified by GCP documentation.
    //
    // The returned long-running operation is in-progress until the backend
    // completes the creation of the resource. Once completed, the order is
    // in
    // [OrderState.ORDER_STATE_ACTIVE][google.cloud.commerce.consumer.procurement.v1.OrderState.ORDER_STATE_ACTIVE].
    // In case of failure, the order resource will be removed.
    virtual ::grpc::Status PlaceOrder(::grpc::ServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response);
    // Returns the requested
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
    virtual ::grpc::Status GetOrder(::grpc::ServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response);
    // Lists [Order][google.cloud.commerce.consumer.procurement.v1.Order]
    // resources that the user has access to, within the scope of the parent
    // resource.
    virtual ::grpc::Status ListOrders(::grpc::ServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response);
    // Modifies an existing
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order] resource.
    virtual ::grpc::Status ModifyOrder(::grpc::ServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response);
    // Cancels an existing
    // [Order][google.cloud.commerce.consumer.procurement.v1.Order]. Every product
    // procured in the Order will be cancelled.
    virtual ::grpc::Status CancelOrder(::grpc::ServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPlaceOrder(::grpc::ServerContext* context, ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOrder() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOrder(::grpc::ServerContext* context, ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::commerce::consumer::procurement::v1::Order>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOrders() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOrders(::grpc::ServerContext* context, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyOrder(::grpc::ServerContext* context, ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelOrder() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelOrder(::grpc::ServerContext* context, ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_PlaceOrder<WithAsyncMethod_GetOrder<WithAsyncMethod_ListOrders<WithAsyncMethod_ModifyOrder<WithAsyncMethod_CancelOrder<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* request, ::google::longrunning::Operation* response) { return this->PlaceOrder(context, request, response); }));}
    void SetMessageAllocatorFor_PlaceOrder(
        ::grpc::MessageAllocator< ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PlaceOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOrder() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest, ::google::cloud::commerce::consumer::procurement::v1::Order>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* request, ::google::cloud::commerce::consumer::procurement::v1::Order* response) { return this->GetOrder(context, request, response); }));}
    void SetMessageAllocatorFor_GetOrder(
        ::grpc::MessageAllocator< ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest, ::google::cloud::commerce::consumer::procurement::v1::Order>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest, ::google::cloud::commerce::consumer::procurement::v1::Order>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOrders() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* request, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* response) { return this->ListOrders(context, request, response); }));}
    void SetMessageAllocatorFor_ListOrders(
        ::grpc::MessageAllocator< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOrders(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* request, ::google::longrunning::Operation* response) { return this->ModifyOrder(context, request, response); }));}
    void SetMessageAllocatorFor_ModifyOrder(
        ::grpc::MessageAllocator< ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelOrder() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* request, ::google::longrunning::Operation* response) { return this->CancelOrder(context, request, response); }));}
    void SetMessageAllocatorFor_CancelOrder(
        ::grpc::MessageAllocator< ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_PlaceOrder<WithCallbackMethod_GetOrder<WithCallbackMethod_ListOrders<WithCallbackMethod_ModifyOrder<WithCallbackMethod_CancelOrder<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOrder() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOrders() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelOrder() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPlaceOrder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOrder() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOrder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOrders() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOrders(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyOrder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelOrder() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelOrder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PlaceOrder(context, request, response); }));
    }
    ~WithRawCallbackMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PlaceOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOrder() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOrder(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOrders() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOrders(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOrders(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ModifyOrder(context, request, response); }));
    }
    ~WithRawCallbackMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelOrder() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelOrder(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelOrder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PlaceOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PlaceOrder() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedPlaceOrder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PlaceOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PlaceOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPlaceOrder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::commerce::consumer::procurement::v1::PlaceOrderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOrder() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest, ::google::cloud::commerce::consumer::procurement::v1::Order>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest, ::google::cloud::commerce::consumer::procurement::v1::Order>* streamer) {
                       return this->StreamedGetOrder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::Order* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOrder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::commerce::consumer::procurement::v1::GetOrderRequest,::google::cloud::commerce::consumer::procurement::v1::Order>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOrders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOrders() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* streamer) {
                       return this->StreamedListOrders(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOrders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOrders(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest* /*request*/, ::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOrders(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::commerce::consumer::procurement::v1::ListOrdersRequest,::google::cloud::commerce::consumer::procurement::v1::ListOrdersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ModifyOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ModifyOrder() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedModifyOrder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ModifyOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ModifyOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedModifyOrder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::commerce::consumer::procurement::v1::ModifyOrderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelOrder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelOrder() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCancelOrder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelOrder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelOrder(::grpc::ServerContext* /*context*/, const ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelOrder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::commerce::consumer::procurement::v1::CancelOrderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_PlaceOrder<WithStreamedUnaryMethod_GetOrder<WithStreamedUnaryMethod_ListOrders<WithStreamedUnaryMethod_ModifyOrder<WithStreamedUnaryMethod_CancelOrder<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_PlaceOrder<WithStreamedUnaryMethod_GetOrder<WithStreamedUnaryMethod_ListOrders<WithStreamedUnaryMethod_ModifyOrder<WithStreamedUnaryMethod_CancelOrder<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace procurement
}  // namespace consumer
}  // namespace commerce
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fcommerce_2fconsumer_2fprocurement_2fv1_2fprocurement_5fservice_2eproto__INCLUDED
