// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataproc/v1/autoscaling_policies.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataproc_2fv1_2fautoscaling_5fpolicies_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataproc_2fv1_2fautoscaling_5fpolicies_2eproto__INCLUDED

#include "google/cloud/dataproc/v1/autoscaling_policies.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataproc {
namespace v1 {

// The API interface for managing autoscaling policies in the
// Dataproc API.
class AutoscalingPolicyService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataproc.v1.AutoscalingPolicyService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates new autoscaling policy.
    virtual ::grpc::Status CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncCreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncCreateAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncCreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncCreateAutoscalingPolicyRaw(context, request, cq));
    }
    // Updates (replaces) autoscaling policy.
    //
    // Disabled check for update_mask, because all updates will be full
    // replacements.
    virtual ::grpc::Status UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncUpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncUpdateAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncUpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncUpdateAutoscalingPolicyRaw(context, request, cq));
    }
    // Retrieves autoscaling policy.
    virtual ::grpc::Status GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncGetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncGetAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncGetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncGetAutoscalingPolicyRaw(context, request, cq));
    }
    // Lists autoscaling policies in the project.
    virtual ::grpc::Status ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>> AsyncListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>>(AsyncListAutoscalingPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>> PrepareAsyncListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>>(PrepareAsyncListAutoscalingPoliciesRaw(context, request, cq));
    }
    // Deletes an autoscaling policy. It is an error to delete an autoscaling
    // policy that is in use by one or more clusters.
    virtual ::grpc::Status DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAutoscalingPolicyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates new autoscaling policy.
      virtual void CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates (replaces) autoscaling policy.
      //
      // Disabled check for update_mask, because all updates will be full
      // replacements.
      virtual void UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves autoscaling policy.
      virtual void GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists autoscaling policies in the project.
      virtual void ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an autoscaling policy. It is an error to delete an autoscaling
      // policy that is in use by one or more clusters.
      virtual void DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncCreateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncCreateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncUpdateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncUpdateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncGetAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncGetAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* AsyncListAutoscalingPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* PrepareAsyncListAutoscalingPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncCreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncCreateAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncCreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncCreateAutoscalingPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncUpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncUpdateAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncUpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncUpdateAutoscalingPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> AsyncGetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(AsyncGetAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>> PrepareAsyncGetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>>(PrepareAsyncGetAutoscalingPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>> AsyncListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>>(AsyncListAutoscalingPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>> PrepareAsyncListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>>(PrepareAsyncListAutoscalingPoliciesRaw(context, request, cq));
    }
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAutoscalingPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAutoscalingPolicyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) override;
      void CreateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) override;
      void UpdateAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAutoscalingPolicies(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAutoscalingPolicy(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncCreateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncCreateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncUpdateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncUpdateAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* AsyncGetAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::AutoscalingPolicy>* PrepareAsyncGetAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* AsyncListAutoscalingPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* PrepareAsyncListAutoscalingPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAutoscalingPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAutoscalingPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAutoscalingPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAutoscalingPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAutoscalingPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAutoscalingPolicy_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates new autoscaling policy.
    virtual ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response);
    // Updates (replaces) autoscaling policy.
    //
    // Disabled check for update_mask, because all updates will be full
    // replacements.
    virtual ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response);
    // Retrieves autoscaling policy.
    virtual ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response);
    // Lists autoscaling policies in the project.
    virtual ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response);
    // Deletes an autoscaling policy. It is an error to delete an autoscaling
    // policy that is in use by one or more clusters.
    virtual ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAutoscalingPolicy(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::AutoscalingPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutoscalingPolicy(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::AutoscalingPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutoscalingPolicy(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::AutoscalingPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutoscalingPolicies(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAutoscalingPolicy(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateAutoscalingPolicy<WithAsyncMethod_UpdateAutoscalingPolicy<WithAsyncMethod_GetAutoscalingPolicy<WithAsyncMethod_ListAutoscalingPolicies<WithAsyncMethod_DeleteAutoscalingPolicy<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) { return this->CreateAutoscalingPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAutoscalingPolicy(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) { return this->UpdateAutoscalingPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAutoscalingPolicy(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* request, ::google::cloud::dataproc::v1::AutoscalingPolicy* response) { return this->GetAutoscalingPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetAutoscalingPolicy(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* request, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* response) { return this->ListAutoscalingPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListAutoscalingPolicies(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutoscalingPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* request, ::google::protobuf::Empty* response) { return this->DeleteAutoscalingPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAutoscalingPolicy(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateAutoscalingPolicy<WithCallbackMethod_UpdateAutoscalingPolicy<WithCallbackMethod_GetAutoscalingPolicy<WithCallbackMethod_ListAutoscalingPolicies<WithCallbackMethod_DeleteAutoscalingPolicy<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutoscalingPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAutoscalingPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAutoscalingPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAutoscalingPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAutoscalingPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutoscalingPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAutoscalingPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAutoscalingPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* streamer) {
                       return this->StreamedCreateAutoscalingPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest,::google::cloud::dataproc::v1::AutoscalingPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAutoscalingPolicy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* streamer) {
                       return this->StreamedUpdateAutoscalingPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest,::google::cloud::dataproc::v1::AutoscalingPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAutoscalingPolicy() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest, ::google::cloud::dataproc::v1::AutoscalingPolicy>* streamer) {
                       return this->StreamedGetAutoscalingPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest* /*request*/, ::google::cloud::dataproc::v1::AutoscalingPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::GetAutoscalingPolicyRequest,::google::cloud::dataproc::v1::AutoscalingPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAutoscalingPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAutoscalingPolicies() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* streamer) {
                       return this->StreamedListAutoscalingPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAutoscalingPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAutoscalingPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest* /*request*/, ::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAutoscalingPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest,::google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAutoscalingPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAutoscalingPolicy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAutoscalingPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAutoscalingPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAutoscalingPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAutoscalingPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateAutoscalingPolicy<WithStreamedUnaryMethod_UpdateAutoscalingPolicy<WithStreamedUnaryMethod_GetAutoscalingPolicy<WithStreamedUnaryMethod_ListAutoscalingPolicies<WithStreamedUnaryMethod_DeleteAutoscalingPolicy<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateAutoscalingPolicy<WithStreamedUnaryMethod_UpdateAutoscalingPolicy<WithStreamedUnaryMethod_GetAutoscalingPolicy<WithStreamedUnaryMethod_ListAutoscalingPolicies<WithStreamedUnaryMethod_DeleteAutoscalingPolicy<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace dataproc
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataproc_2fv1_2fautoscaling_5fpolicies_2eproto__INCLUDED
