// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/metastore/v1/metastore_federation.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_5ffederation_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_5ffederation_2eproto__INCLUDED

#include "google/cloud/metastore/v1/metastore_federation.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace metastore {
namespace v1 {

// Configures and manages metastore federation services.
// Dataproc Metastore Federation Service allows federating a collection of
// backend metastores like BigQuery, Dataplex Lakes, and other Dataproc
// Metastores. The Federation Service exposes a gRPC URL through which metadata
// from the backend metastores are served at query time.
//
// The Dataproc Metastore Federation API defines the following resource model:
// * The service works with a collection of Google Cloud projects.
// * Each project has a collection of available locations.
// * Each location has a collection of federations.
// * Dataproc Metastore Federations are resources with names of the
// form:
// `projects/{project_number}/locations/{location_id}/federations/{federation_id}`.
class DataprocMetastoreFederation final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.metastore.v1.DataprocMetastoreFederation";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists federations in a project and location.
    virtual ::grpc::Status ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::google::cloud::metastore::v1::ListFederationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>> AsyncListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>>(AsyncListFederationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>> PrepareAsyncListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>>(PrepareAsyncListFederationsRaw(context, request, cq));
    }
    // Gets the details of a single federation.
    virtual ::grpc::Status GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::google::cloud::metastore::v1::Federation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>> AsyncGetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>>(AsyncGetFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>> PrepareAsyncGetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>>(PrepareAsyncGetFederationRaw(context, request, cq));
    }
    // Creates a metastore federation in a project and location.
    virtual ::grpc::Status CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateFederationRaw(context, request, cq));
    }
    // Updates the fields of a federation.
    virtual ::grpc::Status UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateFederationRaw(context, request, cq));
    }
    // Deletes a single federation.
    virtual ::grpc::Status DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFederationRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists federations in a project and location.
      virtual void ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a single federation.
      virtual void GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a metastore federation in a project and location.
      virtual void CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the fields of a federation.
      virtual void UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single federation.
      virtual void DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>* AsyncListFederationsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::ListFederationsResponse>* PrepareAsyncListFederationsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>* AsyncGetFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::metastore::v1::Federation>* PrepareAsyncGetFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::google::cloud::metastore::v1::ListFederationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>> AsyncListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>>(AsyncListFederationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>> PrepareAsyncListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>>(PrepareAsyncListFederationsRaw(context, request, cq));
    }
    ::grpc::Status GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::google::cloud::metastore::v1::Federation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>> AsyncGetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>>(AsyncGetFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>> PrepareAsyncGetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>>(PrepareAsyncGetFederationRaw(context, request, cq));
    }
    ::grpc::Status CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateFederationRaw(context, request, cq));
    }
    ::grpc::Status UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateFederationRaw(context, request, cq));
    }
    ::grpc::Status DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFederationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFederationRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFederations(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response, std::function<void(::grpc::Status)>) override;
      void GetFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFederation(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>* AsyncListFederationsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::ListFederationsResponse>* PrepareAsyncListFederationsRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>* AsyncGetFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::metastore::v1::Federation>* PrepareAsyncGetFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::GetFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFederationRaw(::grpc::ClientContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListFederations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFederation_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFederation_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFederation_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFederation_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists federations in a project and location.
    virtual ::grpc::Status ListFederations(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response);
    // Gets the details of a single federation.
    virtual ::grpc::Status GetFederation(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response);
    // Creates a metastore federation in a project and location.
    virtual ::grpc::Status CreateFederation(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response);
    // Updates the fields of a federation.
    virtual ::grpc::Status UpdateFederation(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single federation.
    virtual ::grpc::Status DeleteFederation(::grpc::ServerContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFederations() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFederations(::grpc::ServerContext* context, ::google::cloud::metastore::v1::ListFederationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::ListFederationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFederation() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFederation(::grpc::ServerContext* context, ::google::cloud::metastore::v1::GetFederationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::metastore::v1::Federation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFederation() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFederation(::grpc::ServerContext* context, ::google::cloud::metastore::v1::CreateFederationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFederation(::grpc::ServerContext* context, ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFederation(::grpc::ServerContext* context, ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListFederations<WithAsyncMethod_GetFederation<WithAsyncMethod_CreateFederation<WithAsyncMethod_UpdateFederation<WithAsyncMethod_DeleteFederation<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFederations() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListFederationsRequest, ::google::cloud::metastore::v1::ListFederationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::ListFederationsRequest* request, ::google::cloud::metastore::v1::ListFederationsResponse* response) { return this->ListFederations(context, request, response); }));}
    void SetMessageAllocatorFor_ListFederations(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::ListFederationsRequest, ::google::cloud::metastore::v1::ListFederationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::ListFederationsRequest, ::google::cloud::metastore::v1::ListFederationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFederations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFederation() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetFederationRequest, ::google::cloud::metastore::v1::Federation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::GetFederationRequest* request, ::google::cloud::metastore::v1::Federation* response) { return this->GetFederation(context, request, response); }));}
    void SetMessageAllocatorFor_GetFederation(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::GetFederationRequest, ::google::cloud::metastore::v1::Federation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::GetFederationRequest, ::google::cloud::metastore::v1::Federation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFederation() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateFederationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::CreateFederationRequest* request, ::google::longrunning::Operation* response) { return this->CreateFederation(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFederation(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::CreateFederationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::CreateFederationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateFederationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::UpdateFederationRequest* request, ::google::longrunning::Operation* response) { return this->UpdateFederation(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFederation(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::UpdateFederationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::UpdateFederationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteFederationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::metastore::v1::DeleteFederationRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFederation(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFederation(
        ::grpc::MessageAllocator< ::google::cloud::metastore::v1::DeleteFederationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::metastore::v1::DeleteFederationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListFederations<WithCallbackMethod_GetFederation<WithCallbackMethod_CreateFederation<WithCallbackMethod_UpdateFederation<WithCallbackMethod_DeleteFederation<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFederations() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFederation() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFederation() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFederations() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFederations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFederation() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFederation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFederation() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFederation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFederation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFederation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFederations() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFederations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFederations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFederation() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFederation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFederation() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFederation(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFederation(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFederation(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFederation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFederations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFederations() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::ListFederationsRequest, ::google::cloud::metastore::v1::ListFederationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::ListFederationsRequest, ::google::cloud::metastore::v1::ListFederationsResponse>* streamer) {
                       return this->StreamedListFederations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFederations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFederations(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::ListFederationsRequest* /*request*/, ::google::cloud::metastore::v1::ListFederationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFederations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::ListFederationsRequest,::google::cloud::metastore::v1::ListFederationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFederation() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::GetFederationRequest, ::google::cloud::metastore::v1::Federation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::GetFederationRequest, ::google::cloud::metastore::v1::Federation>* streamer) {
                       return this->StreamedGetFederation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::GetFederationRequest* /*request*/, ::google::cloud::metastore::v1::Federation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFederation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::GetFederationRequest,::google::cloud::metastore::v1::Federation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFederation() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::CreateFederationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::CreateFederationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateFederation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::CreateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFederation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::CreateFederationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFederation() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::UpdateFederationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::UpdateFederationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateFederation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::UpdateFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFederation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::UpdateFederationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFederation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFederation() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::metastore::v1::DeleteFederationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::metastore::v1::DeleteFederationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFederation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFederation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFederation(::grpc::ServerContext* /*context*/, const ::google::cloud::metastore::v1::DeleteFederationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFederation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::metastore::v1::DeleteFederationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListFederations<WithStreamedUnaryMethod_GetFederation<WithStreamedUnaryMethod_CreateFederation<WithStreamedUnaryMethod_UpdateFederation<WithStreamedUnaryMethod_DeleteFederation<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListFederations<WithStreamedUnaryMethod_GetFederation<WithStreamedUnaryMethod_CreateFederation<WithStreamedUnaryMethod_UpdateFederation<WithStreamedUnaryMethod_DeleteFederation<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace metastore
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fmetastore_2fv1_2fmetastore_5ffederation_2eproto__INCLUDED
