// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networksecurity/v1/network_security.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworksecurity_2fv1_2fnetwork_5fsecurity_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworksecurity_2fv1_2fnetwork_5fsecurity_2eproto__INCLUDED

#include "google/cloud/networksecurity/v1/network_security.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace networksecurity {
namespace v1 {

// Network Security API provides resources to configure authentication and
// authorization policies. Refer to per API resource documentation for more
// information.
class NetworkSecurity final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networksecurity.v1.NetworkSecurity";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists AuthorizationPolicies in a given project and location.
    virtual ::grpc::Status ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>> AsyncListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>>(AsyncListAuthorizationPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>> PrepareAsyncListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>>(PrepareAsyncListAuthorizationPoliciesRaw(context, request, cq));
    }
    // Gets details of a single AuthorizationPolicy.
    virtual ::grpc::Status GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>> AsyncGetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>>(AsyncGetAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>> PrepareAsyncGetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>>(PrepareAsyncGetAuthorizationPolicyRaw(context, request, cq));
    }
    // Creates a new AuthorizationPolicy in a given project and location.
    virtual ::grpc::Status CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAuthorizationPolicyRaw(context, request, cq));
    }
    // Updates the parameters of a single AuthorizationPolicy.
    virtual ::grpc::Status UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAuthorizationPolicyRaw(context, request, cq));
    }
    // Deletes a single AuthorizationPolicy.
    virtual ::grpc::Status DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAuthorizationPolicyRaw(context, request, cq));
    }
    // Lists ServerTlsPolicies in a given project and location.
    virtual ::grpc::Status ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>> AsyncListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>>(AsyncListServerTlsPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>> PrepareAsyncListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>>(PrepareAsyncListServerTlsPoliciesRaw(context, request, cq));
    }
    // Gets details of a single ServerTlsPolicy.
    virtual ::grpc::Status GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>> AsyncGetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>>(AsyncGetServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>> PrepareAsyncGetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>>(PrepareAsyncGetServerTlsPolicyRaw(context, request, cq));
    }
    // Creates a new ServerTlsPolicy in a given project and location.
    virtual ::grpc::Status CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateServerTlsPolicyRaw(context, request, cq));
    }
    // Updates the parameters of a single ServerTlsPolicy.
    virtual ::grpc::Status UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateServerTlsPolicyRaw(context, request, cq));
    }
    // Deletes a single ServerTlsPolicy.
    virtual ::grpc::Status DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteServerTlsPolicyRaw(context, request, cq));
    }
    // Lists ClientTlsPolicies in a given project and location.
    virtual ::grpc::Status ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>> AsyncListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>>(AsyncListClientTlsPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>> PrepareAsyncListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>>(PrepareAsyncListClientTlsPoliciesRaw(context, request, cq));
    }
    // Gets details of a single ClientTlsPolicy.
    virtual ::grpc::Status GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>> AsyncGetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>>(AsyncGetClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>> PrepareAsyncGetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>>(PrepareAsyncGetClientTlsPolicyRaw(context, request, cq));
    }
    // Creates a new ClientTlsPolicy in a given project and location.
    virtual ::grpc::Status CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClientTlsPolicyRaw(context, request, cq));
    }
    // Updates the parameters of a single ClientTlsPolicy.
    virtual ::grpc::Status UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateClientTlsPolicyRaw(context, request, cq));
    }
    // Deletes a single ClientTlsPolicy.
    virtual ::grpc::Status DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClientTlsPolicyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists AuthorizationPolicies in a given project and location.
      virtual void ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single AuthorizationPolicy.
      virtual void GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new AuthorizationPolicy in a given project and location.
      virtual void CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single AuthorizationPolicy.
      virtual void UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single AuthorizationPolicy.
      virtual void DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists ServerTlsPolicies in a given project and location.
      virtual void ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single ServerTlsPolicy.
      virtual void GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new ServerTlsPolicy in a given project and location.
      virtual void CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single ServerTlsPolicy.
      virtual void UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single ServerTlsPolicy.
      virtual void DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists ClientTlsPolicies in a given project and location.
      virtual void ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single ClientTlsPolicy.
      virtual void GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new ClientTlsPolicy in a given project and location.
      virtual void CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single ClientTlsPolicy.
      virtual void UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single ClientTlsPolicy.
      virtual void DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* AsyncListAuthorizationPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* PrepareAsyncListAuthorizationPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>* AsyncGetAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::AuthorizationPolicy>* PrepareAsyncGetAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* AsyncListServerTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* PrepareAsyncListServerTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>* AsyncGetServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ServerTlsPolicy>* PrepareAsyncGetServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* AsyncListClientTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* PrepareAsyncListClientTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>* AsyncGetClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networksecurity::v1::ClientTlsPolicy>* PrepareAsyncGetClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>> AsyncListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>>(AsyncListAuthorizationPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>> PrepareAsyncListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>>(PrepareAsyncListAuthorizationPoliciesRaw(context, request, cq));
    }
    ::grpc::Status GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>> AsyncGetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>>(AsyncGetAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>> PrepareAsyncGetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>>(PrepareAsyncGetAuthorizationPolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAuthorizationPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAuthorizationPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAuthorizationPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAuthorizationPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>> AsyncListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>>(AsyncListServerTlsPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>> PrepareAsyncListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>>(PrepareAsyncListServerTlsPoliciesRaw(context, request, cq));
    }
    ::grpc::Status GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>> AsyncGetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>>(AsyncGetServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>> PrepareAsyncGetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>>(PrepareAsyncGetServerTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateServerTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateServerTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteServerTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteServerTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>> AsyncListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>>(AsyncListClientTlsPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>> PrepareAsyncListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>>(PrepareAsyncListClientTlsPoliciesRaw(context, request, cq));
    }
    ::grpc::Status GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>> AsyncGetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>>(AsyncGetClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>> PrepareAsyncGetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>>(PrepareAsyncGetClientTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClientTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateClientTlsPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClientTlsPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClientTlsPolicyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAuthorizationPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAuthorizationPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServerTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteServerTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClientTlsPolicies(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteClientTlsPolicy(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* AsyncListAuthorizationPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* PrepareAsyncListAuthorizationPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>* AsyncGetAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::AuthorizationPolicy>* PrepareAsyncGetAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAuthorizationPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* AsyncListServerTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* PrepareAsyncListServerTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>* AsyncGetServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ServerTlsPolicy>* PrepareAsyncGetServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteServerTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* AsyncListClientTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* PrepareAsyncListClientTlsPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>* AsyncGetClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networksecurity::v1::ClientTlsPolicy>* PrepareAsyncGetClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClientTlsPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAuthorizationPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAuthorizationPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAuthorizationPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAuthorizationPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAuthorizationPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListServerTlsPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetServerTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateServerTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateServerTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteServerTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListClientTlsPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetClientTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateClientTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateClientTlsPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteClientTlsPolicy_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists AuthorizationPolicies in a given project and location.
    virtual ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response);
    // Gets details of a single AuthorizationPolicy.
    virtual ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response);
    // Creates a new AuthorizationPolicy in a given project and location.
    virtual ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single AuthorizationPolicy.
    virtual ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single AuthorizationPolicy.
    virtual ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response);
    // Lists ServerTlsPolicies in a given project and location.
    virtual ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response);
    // Gets details of a single ServerTlsPolicy.
    virtual ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response);
    // Creates a new ServerTlsPolicy in a given project and location.
    virtual ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single ServerTlsPolicy.
    virtual ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single ServerTlsPolicy.
    virtual ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response);
    // Lists ClientTlsPolicies in a given project and location.
    virtual ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response);
    // Gets details of a single ClientTlsPolicy.
    virtual ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response);
    // Creates a new ClientTlsPolicy in a given project and location.
    virtual ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single ClientTlsPolicy.
    virtual ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single ClientTlsPolicy.
    virtual ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizationPolicies(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAuthorizationPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::AuthorizationPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAuthorizationPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAuthorizationPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAuthorizationPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServerTlsPolicies(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServerTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::ServerTlsPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServerTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateServerTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteServerTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClientTlsPolicies(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClientTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networksecurity::v1::ClientTlsPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClientTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateClientTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteClientTlsPolicy(::grpc::ServerContext* context, ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAuthorizationPolicies<WithAsyncMethod_GetAuthorizationPolicy<WithAsyncMethod_CreateAuthorizationPolicy<WithAsyncMethod_UpdateAuthorizationPolicy<WithAsyncMethod_DeleteAuthorizationPolicy<WithAsyncMethod_ListServerTlsPolicies<WithAsyncMethod_GetServerTlsPolicy<WithAsyncMethod_CreateServerTlsPolicy<WithAsyncMethod_UpdateServerTlsPolicy<WithAsyncMethod_DeleteServerTlsPolicy<WithAsyncMethod_ListClientTlsPolicies<WithAsyncMethod_GetClientTlsPolicy<WithAsyncMethod_CreateClientTlsPolicy<WithAsyncMethod_UpdateClientTlsPolicy<WithAsyncMethod_DeleteClientTlsPolicy<Service > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* response) { return this->ListAuthorizationPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListAuthorizationPolicies(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizationPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest, ::google::cloud::networksecurity::v1::AuthorizationPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* request, ::google::cloud::networksecurity::v1::AuthorizationPolicy* response) { return this->GetAuthorizationPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetAuthorizationPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest, ::google::cloud::networksecurity::v1::AuthorizationPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest, ::google::cloud::networksecurity::v1::AuthorizationPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response) { return this->CreateAuthorizationPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAuthorizationPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAuthorizationPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAuthorizationPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAuthorizationPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAuthorizationPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* response) { return this->ListServerTlsPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListServerTlsPolicies(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServerTlsPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest, ::google::cloud::networksecurity::v1::ServerTlsPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ServerTlsPolicy* response) { return this->GetServerTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetServerTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest, ::google::cloud::networksecurity::v1::ServerTlsPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest, ::google::cloud::networksecurity::v1::ServerTlsPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->CreateServerTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateServerTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateServerTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateServerTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteServerTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteServerTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* request, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* response) { return this->ListClientTlsPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListClientTlsPolicies(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClientTlsPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest, ::google::cloud::networksecurity::v1::ClientTlsPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* request, ::google::cloud::networksecurity::v1::ClientTlsPolicy* response) { return this->GetClientTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetClientTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest, ::google::cloud::networksecurity::v1::ClientTlsPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest, ::google::cloud::networksecurity::v1::ClientTlsPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->CreateClientTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateClientTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateClientTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateClientTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteClientTlsPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteClientTlsPolicy(
        ::grpc::MessageAllocator< ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAuthorizationPolicies<WithCallbackMethod_GetAuthorizationPolicy<WithCallbackMethod_CreateAuthorizationPolicy<WithCallbackMethod_UpdateAuthorizationPolicy<WithCallbackMethod_DeleteAuthorizationPolicy<WithCallbackMethod_ListServerTlsPolicies<WithCallbackMethod_GetServerTlsPolicy<WithCallbackMethod_CreateServerTlsPolicy<WithCallbackMethod_UpdateServerTlsPolicy<WithCallbackMethod_DeleteServerTlsPolicy<WithCallbackMethod_ListClientTlsPolicies<WithCallbackMethod_GetClientTlsPolicy<WithCallbackMethod_CreateClientTlsPolicy<WithCallbackMethod_UpdateClientTlsPolicy<WithCallbackMethod_DeleteClientTlsPolicy<Service > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizationPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServerTlsPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClientTlsPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAuthorizationPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizationPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAuthorizationPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAuthorizationPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAuthorizationPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAuthorizationPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAuthorizationPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServerTlsPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServerTlsPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetServerTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateServerTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateServerTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteServerTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteServerTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClientTlsPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClientTlsPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetClientTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateClientTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateClientTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteClientTlsPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteClientTlsPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAuthorizationPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAuthorizationPolicies() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* streamer) {
                       return this->StreamedListAuthorizationPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAuthorizationPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAuthorizationPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAuthorizationPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::ListAuthorizationPoliciesRequest,::google::cloud::networksecurity::v1::ListAuthorizationPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAuthorizationPolicy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest, ::google::cloud::networksecurity::v1::AuthorizationPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest, ::google::cloud::networksecurity::v1::AuthorizationPolicy>* streamer) {
                       return this->StreamedGetAuthorizationPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::AuthorizationPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::GetAuthorizationPolicyRequest,::google::cloud::networksecurity::v1::AuthorizationPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAuthorizationPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::CreateAuthorizationPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAuthorizationPolicy() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAuthorizationPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::UpdateAuthorizationPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAuthorizationPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAuthorizationPolicy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAuthorizationPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAuthorizationPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAuthorizationPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAuthorizationPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::DeleteAuthorizationPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServerTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServerTlsPolicies() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* streamer) {
                       return this->StreamedListServerTlsPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServerTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServerTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServerTlsPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::ListServerTlsPoliciesRequest,::google::cloud::networksecurity::v1::ListServerTlsPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetServerTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest, ::google::cloud::networksecurity::v1::ServerTlsPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest, ::google::cloud::networksecurity::v1::ServerTlsPolicy>* streamer) {
                       return this->StreamedGetServerTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ServerTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::GetServerTlsPolicyRequest,::google::cloud::networksecurity::v1::ServerTlsPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateServerTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateServerTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::CreateServerTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateServerTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateServerTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::UpdateServerTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteServerTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteServerTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteServerTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteServerTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteServerTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteServerTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::DeleteServerTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClientTlsPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClientTlsPolicies() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* streamer) {
                       return this->StreamedListClientTlsPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClientTlsPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClientTlsPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest* /*request*/, ::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClientTlsPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::ListClientTlsPoliciesRequest,::google::cloud::networksecurity::v1::ListClientTlsPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetClientTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest, ::google::cloud::networksecurity::v1::ClientTlsPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest, ::google::cloud::networksecurity::v1::ClientTlsPolicy>* streamer) {
                       return this->StreamedGetClientTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest* /*request*/, ::google::cloud::networksecurity::v1::ClientTlsPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::GetClientTlsPolicyRequest,::google::cloud::networksecurity::v1::ClientTlsPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateClientTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateClientTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::CreateClientTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateClientTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateClientTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::UpdateClientTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteClientTlsPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteClientTlsPolicy() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteClientTlsPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteClientTlsPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteClientTlsPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteClientTlsPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networksecurity::v1::DeleteClientTlsPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAuthorizationPolicies<WithStreamedUnaryMethod_GetAuthorizationPolicy<WithStreamedUnaryMethod_CreateAuthorizationPolicy<WithStreamedUnaryMethod_UpdateAuthorizationPolicy<WithStreamedUnaryMethod_DeleteAuthorizationPolicy<WithStreamedUnaryMethod_ListServerTlsPolicies<WithStreamedUnaryMethod_GetServerTlsPolicy<WithStreamedUnaryMethod_CreateServerTlsPolicy<WithStreamedUnaryMethod_UpdateServerTlsPolicy<WithStreamedUnaryMethod_DeleteServerTlsPolicy<WithStreamedUnaryMethod_ListClientTlsPolicies<WithStreamedUnaryMethod_GetClientTlsPolicy<WithStreamedUnaryMethod_CreateClientTlsPolicy<WithStreamedUnaryMethod_UpdateClientTlsPolicy<WithStreamedUnaryMethod_DeleteClientTlsPolicy<Service > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAuthorizationPolicies<WithStreamedUnaryMethod_GetAuthorizationPolicy<WithStreamedUnaryMethod_CreateAuthorizationPolicy<WithStreamedUnaryMethod_UpdateAuthorizationPolicy<WithStreamedUnaryMethod_DeleteAuthorizationPolicy<WithStreamedUnaryMethod_ListServerTlsPolicies<WithStreamedUnaryMethod_GetServerTlsPolicy<WithStreamedUnaryMethod_CreateServerTlsPolicy<WithStreamedUnaryMethod_UpdateServerTlsPolicy<WithStreamedUnaryMethod_DeleteServerTlsPolicy<WithStreamedUnaryMethod_ListClientTlsPolicies<WithStreamedUnaryMethod_GetClientTlsPolicy<WithStreamedUnaryMethod_CreateClientTlsPolicy<WithStreamedUnaryMethod_UpdateClientTlsPolicy<WithStreamedUnaryMethod_DeleteClientTlsPolicy<Service > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace networksecurity
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnetworksecurity_2fv1_2fnetwork_5fsecurity_2eproto__INCLUDED
