// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/redis/cluster/v1/cloud_redis_cluster.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED

#include "google/cloud/redis/cluster/v1/cloud_redis_cluster.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace redis {
namespace cluster {
namespace v1 {

// Configures and manages Cloud Memorystore for Redis clusters
//
// Google Cloud Memorystore for Redis Cluster
//
// The `redis.googleapis.com` service implements the Google Cloud Memorystore
// for Redis API and defines the following resource model for managing Redis
// clusters:
// * The service works with a collection of cloud projects, named: `/projects/*`
// * Each project has a collection of available locations, named: `/locations/*`
// * Each location has a collection of Redis clusters, named: `/clusters/*`
// * As such, Redis clusters are resources of the form:
//   `/projects/{project_id}/locations/{location_id}/clusters/{instance_id}`
//
// Note that location_id must be a GCP `region`; for example:
// * `projects/redpepper-1290/locations/us-central1/clusters/my-redis`
class CloudRedisCluster final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.redis.cluster.v1.CloudRedisCluster";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all Redis clusters owned by a project in either the specified
    // location (region) or all locations.
    //
    // The location should have the following format:
    //
    // * `projects/{project_id}/locations/{location_id}`
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    // Gets the details of a specific Redis cluster.
    virtual ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::google::cloud::redis::cluster::v1::Cluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    // Updates the metadata and configuration of a specific Redis cluster.
    //
    // Completed longrunning.Operation will contain the new cluster object
    // in the response field. The returned operation is automatically deleted
    // after a few hours, so there is no need to call DeleteOperation.
    virtual ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    // Deletes a specific Redis cluster. Cluster stops serving and data is
    // deleted.
    virtual ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    // Creates a Redis cluster based on the specified properties.
    // The creation is executed asynchronously and callers may check the returned
    // operation to track its progress. Once the operation is completed the Redis
    // cluster will be fully functional. The completed longrunning.Operation will
    // contain the new cluster object in the response field.
    //
    // The returned operation is automatically deleted after a few hours, so there
    // is no need to call DeleteOperation.
    virtual ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    // Gets the details of certificate authority information for Redis cluster.
    virtual ::grpc::Status GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>> AsyncGetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>>(AsyncGetClusterCertificateAuthorityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>> PrepareAsyncGetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>>(PrepareAsyncGetClusterCertificateAuthorityRaw(context, request, cq));
    }
    // Reschedules upcoming maintenance event.
    virtual ::grpc::Status RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRescheduleClusterMaintenanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRescheduleClusterMaintenanceRaw(context, request, cq));
    }
    // Lists all backup collections owned by a consumer project in either the
    // specified location (region) or all locations.
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>> AsyncListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>>(AsyncListBackupCollectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>> PrepareAsyncListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>>(PrepareAsyncListBackupCollectionsRaw(context, request, cq));
    }
    // Get a backup collection.
    virtual ::grpc::Status GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::google::cloud::redis::cluster::v1::BackupCollection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>> AsyncGetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>>(AsyncGetBackupCollectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>> PrepareAsyncGetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>>(PrepareAsyncGetBackupCollectionRaw(context, request, cq));
    }
    // Lists all backups owned by a backup collection.
    virtual ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    // Gets the details of a specific backup.
    virtual ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::google::cloud::redis::cluster::v1::Backup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    // Deletes a specific backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    // Exports a specific backup to a customer target Cloud Storage URI.
    virtual ::grpc::Status ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportBackupRaw(context, request, cq));
    }
    // Backup Redis Cluster.
    // If this is the first time a backup is being created, a backup collection
    // will be created at the backend, and this backup belongs to this collection.
    // Both collection and backup will have a resource name. Backup will be
    // executed for each shard. A replica (primary if nonHA) will be selected to
    // perform the execution. Backup call will be rejected if there is an ongoing
    // backup or update operation. Be aware that during preview, if the cluster's
    // internal software version is too old, critical update will be performed
    // before actual backup. Once the internal software version is updated to the
    // minimum version required by the backup feature, subsequent backups will not
    // require critical update. After preview, there will be no critical update
    // needed for backup.
    virtual ::grpc::Status BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBackupClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBackupClusterRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all Redis clusters owned by a project in either the specified
      // location (region) or all locations.
      //
      // The location should have the following format:
      //
      // * `projects/{project_id}/locations/{location_id}`
      //
      // If `location_id` is specified as `-` (wildcard), then all regions
      // available to the project are queried, and the results are aggregated.
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific Redis cluster.
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the metadata and configuration of a specific Redis cluster.
      //
      // Completed longrunning.Operation will contain the new cluster object
      // in the response field. The returned operation is automatically deleted
      // after a few hours, so there is no need to call DeleteOperation.
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific Redis cluster. Cluster stops serving and data is
      // deleted.
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Redis cluster based on the specified properties.
      // The creation is executed asynchronously and callers may check the returned
      // operation to track its progress. Once the operation is completed the Redis
      // cluster will be fully functional. The completed longrunning.Operation will
      // contain the new cluster object in the response field.
      //
      // The returned operation is automatically deleted after a few hours, so there
      // is no need to call DeleteOperation.
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of certificate authority information for Redis cluster.
      virtual void GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reschedules upcoming maintenance event.
      virtual void RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all backup collections owned by a consumer project in either the
      // specified location (region) or all locations.
      //
      // If `location_id` is specified as `-` (wildcard), then all regions
      // available to the project are queried, and the results are aggregated.
      virtual void ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a backup collection.
      virtual void GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all backups owned by a backup collection.
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific backup.
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific backup.
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports a specific backup to a customer target Cloud Storage URI.
      virtual void ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Backup Redis Cluster.
      // If this is the first time a backup is being created, a backup collection
      // will be created at the backend, and this backup belongs to this collection.
      // Both collection and backup will have a resource name. Backup will be
      // executed for each shard. A replica (primary if nonHA) will be selected to
      // perform the execution. Backup call will be rejected if there is an ongoing
      // backup or update operation. Be aware that during preview, if the cluster's
      // internal software version is too old, critical update will be performed
      // before actual backup. Once the internal software version is updated to the
      // minimum version required by the backup feature, subsequent backups will not
      // require critical update. After preview, there will be no critical update
      // needed for backup.
      virtual void BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>* AsyncGetClusterCertificateAuthorityRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::CertificateAuthority>* PrepareAsyncGetClusterCertificateAuthorityRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRescheduleClusterMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRescheduleClusterMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* AsyncListBackupCollectionsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* PrepareAsyncListBackupCollectionsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>* AsyncGetBackupCollectionRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::BackupCollection>* PrepareAsyncGetBackupCollectionRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBackupClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBackupClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::google::cloud::redis::cluster::v1::Cluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>> AsyncGetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>>(AsyncGetClusterCertificateAuthorityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>> PrepareAsyncGetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>>(PrepareAsyncGetClusterCertificateAuthorityRaw(context, request, cq));
    }
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRescheduleClusterMaintenanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRescheduleClusterMaintenanceRaw(context, request, cq));
    }
    ::grpc::Status ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>> AsyncListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>>(AsyncListBackupCollectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>> PrepareAsyncListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>>(PrepareAsyncListBackupCollectionsRaw(context, request, cq));
    }
    ::grpc::Status GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::google::cloud::redis::cluster::v1::BackupCollection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>> AsyncGetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>>(AsyncGetBackupCollectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>> PrepareAsyncGetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>>(PrepareAsyncGetBackupCollectionRaw(context, request, cq));
    }
    ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::google::cloud::redis::cluster::v1::Backup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    ::grpc::Status ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportBackupRaw(context, request, cq));
    }
    ::grpc::Status BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBackupClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBackupClusterRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, std::function<void(::grpc::Status)>) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response, std::function<void(::grpc::Status)>) override;
      void GetClusterCertificateAuthority(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RescheduleClusterMaintenance(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBackupCollections(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response, std::function<void(::grpc::Status)>) override;
      void GetBackupCollection(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response, std::function<void(::grpc::Status)>) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportBackup(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BackupCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>* AsyncGetClusterCertificateAuthorityRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::CertificateAuthority>* PrepareAsyncGetClusterCertificateAuthorityRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRescheduleClusterMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRescheduleClusterMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* AsyncListBackupCollectionsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* PrepareAsyncListBackupCollectionsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>* AsyncGetBackupCollectionRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::BackupCollection>* PrepareAsyncGetBackupCollectionRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportBackupRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBackupClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBackupClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_GetClusterCertificateAuthority_;
    const ::grpc::internal::RpcMethod rpcmethod_RescheduleClusterMaintenance_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBackupCollections_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBackupCollection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBackups_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_BackupCluster_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all Redis clusters owned by a project in either the specified
    // location (region) or all locations.
    //
    // The location should have the following format:
    //
    // * `projects/{project_id}/locations/{location_id}`
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListClusters(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response);
    // Gets the details of a specific Redis cluster.
    virtual ::grpc::Status GetCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response);
    // Updates the metadata and configuration of a specific Redis cluster.
    //
    // Completed longrunning.Operation will contain the new cluster object
    // in the response field. The returned operation is automatically deleted
    // after a few hours, so there is no need to call DeleteOperation.
    virtual ::grpc::Status UpdateCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a specific Redis cluster. Cluster stops serving and data is
    // deleted.
    virtual ::grpc::Status DeleteCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response);
    // Creates a Redis cluster based on the specified properties.
    // The creation is executed asynchronously and callers may check the returned
    // operation to track its progress. Once the operation is completed the Redis
    // cluster will be fully functional. The completed longrunning.Operation will
    // contain the new cluster object in the response field.
    //
    // The returned operation is automatically deleted after a few hours, so there
    // is no need to call DeleteOperation.
    virtual ::grpc::Status CreateCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response);
    // Gets the details of certificate authority information for Redis cluster.
    virtual ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response);
    // Reschedules upcoming maintenance event.
    virtual ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response);
    // Lists all backup collections owned by a consumer project in either the
    // specified location (region) or all locations.
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListBackupCollections(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response);
    // Get a backup collection.
    virtual ::grpc::Status GetBackupCollection(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response);
    // Lists all backups owned by a backup collection.
    virtual ::grpc::Status ListBackups(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response);
    // Gets the details of a specific backup.
    virtual ::grpc::Status GetBackup(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response);
    // Deletes a specific backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response);
    // Exports a specific backup to a customer target Cloud Storage URI.
    virtual ::grpc::Status ExportBackup(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response);
    // Backup Redis Cluster.
    // If this is the first time a backup is being created, a backup collection
    // will be created at the backend, and this backup belongs to this collection.
    // Both collection and backup will have a resource name. Backup will be
    // executed for each shard. A replica (primary if nonHA) will be selected to
    // perform the execution. Backup call will be rejected if there is an ongoing
    // backup or update operation. Be aware that during preview, if the cluster's
    // internal software version is too old, critical update will be performed
    // before actual backup. Once the internal software version is updated to the
    // minimum version required by the backup feature, subsequent backups will not
    // require critical update. After preview, there will be no critical update
    // needed for backup.
    virtual ::grpc::Status BackupCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClusters() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::ListClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCluster() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::Cluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCluster() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClusterCertificateAuthority(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::CertificateAuthority>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRescheduleClusterMaintenance(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackupCollections(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackupCollection(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::BackupCollection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBackups() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::ListBackupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBackup() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::Backup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportBackup() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportBackup(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BackupCluster() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBackupCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListClusters<WithAsyncMethod_GetCluster<WithAsyncMethod_UpdateCluster<WithAsyncMethod_DeleteCluster<WithAsyncMethod_CreateCluster<WithAsyncMethod_GetClusterCertificateAuthority<WithAsyncMethod_RescheduleClusterMaintenance<WithAsyncMethod_ListBackupCollections<WithAsyncMethod_GetBackupCollection<WithAsyncMethod_ListBackups<WithAsyncMethod_GetBackup<WithAsyncMethod_DeleteBackup<WithAsyncMethod_ExportBackup<WithAsyncMethod_BackupCluster<Service > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) { return this->ListClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListClusters(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response) { return this->GetCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest, ::google::cloud::redis::cluster::v1::CertificateAuthority>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* request, ::google::cloud::redis::cluster::v1::CertificateAuthority* response) { return this->GetClusterCertificateAuthority(context, request, response); }));}
    void SetMessageAllocatorFor_GetClusterCertificateAuthority(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest, ::google::cloud::redis::cluster::v1::CertificateAuthority>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest, ::google::cloud::redis::cluster::v1::CertificateAuthority>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClusterCertificateAuthority(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* request, ::google::longrunning::Operation* response) { return this->RescheduleClusterMaintenance(context, request, response); }));}
    void SetMessageAllocatorFor_RescheduleClusterMaintenance(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RescheduleClusterMaintenance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* response) { return this->ListBackupCollections(context, request, response); }));}
    void SetMessageAllocatorFor_ListBackupCollections(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackupCollections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest, ::google::cloud::redis::cluster::v1::BackupCollection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* request, ::google::cloud::redis::cluster::v1::BackupCollection* response) { return this->GetBackupCollection(context, request, response); }));}
    void SetMessageAllocatorFor_GetBackupCollection(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest, ::google::cloud::redis::cluster::v1::BackupCollection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest, ::google::cloud::redis::cluster::v1::BackupCollection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackupCollection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListBackupsRequest, ::google::cloud::redis::cluster::v1::ListBackupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* request, ::google::cloud::redis::cluster::v1::ListBackupsResponse* response) { return this->ListBackups(context, request, response); }));}
    void SetMessageAllocatorFor_ListBackups(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::ListBackupsRequest, ::google::cloud::redis::cluster::v1::ListBackupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListBackupsRequest, ::google::cloud::redis::cluster::v1::ListBackupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetBackupRequest, ::google::cloud::redis::cluster::v1::Backup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::GetBackupRequest* request, ::google::cloud::redis::cluster::v1::Backup* response) { return this->GetBackup(context, request, response); }));}
    void SetMessageAllocatorFor_GetBackup(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::GetBackupRequest, ::google::cloud::redis::cluster::v1::Backup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetBackupRequest, ::google::cloud::redis::cluster::v1::Backup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response) { return this->DeleteBackup(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBackup(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::DeleteBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportBackup() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ExportBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* request, ::google::longrunning::Operation* response) { return this->ExportBackup(context, request, response); }));}
    void SetMessageAllocatorFor_ExportBackup(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::ExportBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ExportBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BackupCluster() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::BackupClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* request, ::google::longrunning::Operation* response) { return this->BackupCluster(context, request, response); }));}
    void SetMessageAllocatorFor_BackupCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::BackupClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::BackupClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BackupCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListClusters<WithCallbackMethod_GetCluster<WithCallbackMethod_UpdateCluster<WithCallbackMethod_DeleteCluster<WithCallbackMethod_CreateCluster<WithCallbackMethod_GetClusterCertificateAuthority<WithCallbackMethod_RescheduleClusterMaintenance<WithCallbackMethod_ListBackupCollections<WithCallbackMethod_GetBackupCollection<WithCallbackMethod_ListBackups<WithCallbackMethod_GetBackup<WithCallbackMethod_DeleteBackup<WithCallbackMethod_ExportBackup<WithCallbackMethod_BackupCluster<Service > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClusters() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCluster() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCluster() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBackups() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBackup() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportBackup() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BackupCluster() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClusters() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCluster() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClusterCertificateAuthority(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRescheduleClusterMaintenance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackupCollections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackupCollection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBackups() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBackup() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportBackup() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BackupCluster() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBackupCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetClusterCertificateAuthority(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClusterCertificateAuthority(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RescheduleClusterMaintenance(context, request, response); }));
    }
    ~WithRawCallbackMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RescheduleClusterMaintenance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBackupCollections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackupCollections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBackupCollection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackupCollection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBackups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportBackup() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BackupCluster() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BackupCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BackupCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClusters() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>* streamer) {
                       return this->StreamedListClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::ListClustersRequest,::google::cloud::redis::cluster::v1::ListClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCluster() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>* streamer) {
                       return this->StreamedGetCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::GetClusterRequest,::google::cloud::redis::cluster::v1::Cluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::UpdateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::DeleteClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCluster() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::CreateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetClusterCertificateAuthority : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetClusterCertificateAuthority() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest, ::google::cloud::redis::cluster::v1::CertificateAuthority>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest, ::google::cloud::redis::cluster::v1::CertificateAuthority>* streamer) {
                       return this->StreamedGetClusterCertificateAuthority(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetClusterCertificateAuthority() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetClusterCertificateAuthority(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest* /*request*/, ::google::cloud::redis::cluster::v1::CertificateAuthority* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetClusterCertificateAuthority(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::GetClusterCertificateAuthorityRequest,::google::cloud::redis::cluster::v1::CertificateAuthority>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RescheduleClusterMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RescheduleClusterMaintenance() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRescheduleClusterMaintenance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RescheduleClusterMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RescheduleClusterMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRescheduleClusterMaintenance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::RescheduleClusterMaintenanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBackupCollections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBackupCollections() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* streamer) {
                       return this->StreamedListBackupCollections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBackupCollections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBackupCollections(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBackupCollections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::ListBackupCollectionsRequest,::google::cloud::redis::cluster::v1::ListBackupCollectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBackupCollection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBackupCollection() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest, ::google::cloud::redis::cluster::v1::BackupCollection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest, ::google::cloud::redis::cluster::v1::BackupCollection>* streamer) {
                       return this->StreamedGetBackupCollection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBackupCollection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBackupCollection(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest* /*request*/, ::google::cloud::redis::cluster::v1::BackupCollection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBackupCollection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::GetBackupCollectionRequest,::google::cloud::redis::cluster::v1::BackupCollection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBackups() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::ListBackupsRequest, ::google::cloud::redis::cluster::v1::ListBackupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::ListBackupsRequest, ::google::cloud::redis::cluster::v1::ListBackupsResponse>* streamer) {
                       return this->StreamedListBackups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListBackupsRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBackups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::ListBackupsRequest,::google::cloud::redis::cluster::v1::ListBackupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBackup() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::GetBackupRequest, ::google::cloud::redis::cluster::v1::Backup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::GetBackupRequest, ::google::cloud::redis::cluster::v1::Backup>* streamer) {
                       return this->StreamedGetBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetBackupRequest* /*request*/, ::google::cloud::redis::cluster::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::GetBackupRequest,::google::cloud::redis::cluster::v1::Backup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::DeleteBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::DeleteBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportBackup() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::ExportBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::ExportBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ExportBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::ExportBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BackupCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BackupCluster() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::BackupClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::BackupClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBackupCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BackupCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BackupCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::BackupClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBackupCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::BackupClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_GetClusterCertificateAuthority<WithStreamedUnaryMethod_RescheduleClusterMaintenance<WithStreamedUnaryMethod_ListBackupCollections<WithStreamedUnaryMethod_GetBackupCollection<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_ExportBackup<WithStreamedUnaryMethod_BackupCluster<Service > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_GetClusterCertificateAuthority<WithStreamedUnaryMethod_RescheduleClusterMaintenance<WithStreamedUnaryMethod_ListBackupCollections<WithStreamedUnaryMethod_GetBackupCollection<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_ExportBackup<WithStreamedUnaryMethod_BackupCluster<Service > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace cluster
}  // namespace redis
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED
