// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/resourcemanager/v3/projects.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fresourcemanager_2fv3_2fprojects_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fresourcemanager_2fv3_2fprojects_2eproto__INCLUDED

#include "google/cloud/resourcemanager/v3/projects.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace resourcemanager {
namespace v3 {

// Manages Google Cloud Projects.
class Projects final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.resourcemanager.v3.Projects";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Retrieves the project identified by the specified `name` (for example,
    // `projects/415104041262`).
    //
    // The caller must have `resourcemanager.projects.get` permission
    // for this project.
    virtual ::grpc::Status GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::google::cloud::resourcemanager::v3::Project* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>> AsyncGetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>>(AsyncGetProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>> PrepareAsyncGetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>>(PrepareAsyncGetProjectRaw(context, request, cq));
    }
    // Lists projects that are direct children of the specified folder or
    // organization resource. `list()` provides a strongly consistent view of the
    // projects underneath the specified parent resource. `list()` returns
    // projects sorted based upon the (ascending) lexical ordering of their
    // `display_name`. The caller must have `resourcemanager.projects.list`
    // permission on the identified parent.
    virtual ::grpc::Status ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>> AsyncListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>>(AsyncListProjectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>> PrepareAsyncListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>>(PrepareAsyncListProjectsRaw(context, request, cq));
    }
    // Search for projects that the caller has both `resourcemanager.projects.get`
    // permission on, and also satisfy the specified query.
    //
    // This method returns projects in an unspecified order.
    //
    // This method is eventually consistent with project mutations; this means
    // that a newly created project may not appear in the results or recent
    // updates to an existing project may not be reflected in the results. To
    // retrieve the latest state of a project, use the
    // [GetProject][google.cloud.resourcemanager.v3.Projects.GetProject] method.
    virtual ::grpc::Status SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>> AsyncSearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>>(AsyncSearchProjectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>> PrepareAsyncSearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>>(PrepareAsyncSearchProjectsRaw(context, request, cq));
    }
    // Request that a new project be created. The result is an `Operation` which
    // can be used to track the creation process. This process usually takes a few
    // seconds, but can sometimes take much longer. The tracking `Operation` is
    // automatically deleted after a few hours, so there is no need to call
    // `DeleteOperation`.
    virtual ::grpc::Status CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateProjectRaw(context, request, cq));
    }
    // Updates the `display_name` and labels of the project identified by the
    // specified `name` (for example, `projects/415104041262`). Deleting all
    // labels requires an update mask for labels field.
    //
    // The caller must have `resourcemanager.projects.update` permission for this
    // project.
    virtual ::grpc::Status UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateProjectRaw(context, request, cq));
    }
    // Move a project to another place in your resource hierarchy, under a new
    // resource parent.
    //
    // Returns an operation which can be used to track the process of the project
    // move workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // moved project.
    //
    // The caller must have `resourcemanager.projects.move` permission on the
    // project, on the project's current and proposed new parent.
    //
    // If project has no current parent, or it currently does not have an
    // associated organization resource, you will also need the
    // `resourcemanager.projects.setIamPolicy` permission in the project.
    //
    //
    virtual ::grpc::Status MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncMoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncMoveProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncMoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncMoveProjectRaw(context, request, cq));
    }
    // Marks the project identified by the specified
    // `name` (for example, `projects/415104041262`) for deletion.
    //
    // This method will only affect the project if it has a lifecycle state of
    // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE].
    //
    // This method changes the Project's lifecycle state from
    // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE]
    // to
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Project.State.DELETE_REQUESTED].
    // The deletion starts at an unspecified time,
    // at which point the Project is no longer accessible.
    //
    // Until the deletion completes, you can check the lifecycle state
    // checked by retrieving the project with [GetProject]
    // [google.cloud.resourcemanager.v3.Projects.GetProject],
    // and the project remains visible to [ListProjects]
    // [google.cloud.resourcemanager.v3.Projects.ListProjects].
    // However, you cannot update the project.
    //
    // After the deletion completes, the project is not retrievable by
    // the  [GetProject]
    // [google.cloud.resourcemanager.v3.Projects.GetProject],
    // [ListProjects]
    // [google.cloud.resourcemanager.v3.Projects.ListProjects], and
    // [SearchProjects][google.cloud.resourcemanager.v3.Projects.SearchProjects]
    // methods.
    //
    // This method behaves idempotently, such that deleting a `DELETE_REQUESTED`
    // project will not cause an error, but also won't do anything.
    //
    // The caller must have `resourcemanager.projects.delete` permissions for this
    // project.
    virtual ::grpc::Status DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteProjectRaw(context, request, cq));
    }
    // Restores the project identified by the specified
    // `name` (for example, `projects/415104041262`).
    // You can only use this method for a project that has a lifecycle state of
    // [DELETE_REQUESTED]
    // [Projects.State.DELETE_REQUESTED].
    // After deletion starts, the project cannot be restored.
    //
    // The caller must have `resourcemanager.projects.undelete` permission for
    // this project.
    virtual ::grpc::Status UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeleteProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeleteProjectRaw(context, request, cq));
    }
    // Returns the IAM access control policy for the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
    // Permission is denied if the policy or the resource do not exist.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Sets the IAM access control policy for the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
    //
    // CAUTION: This method will replace the existing policy, and cannot be used
    // to append additional IAM settings.
    //
    // Note: Removing service accounts from policies or changing their roles can
    // render services completely inoperable. It is important to understand how
    // the service account is being used before removing or updating its roles.
    //
    // The following constraints apply when using `setIamPolicy()`:
    //
    // + Project does not support `allUsers` and `allAuthenticatedUsers` as
    // `members` in a `Binding` of a `Policy`.
    //
    // + The owner role can be granted to a `user`, `serviceAccount`, or a group
    // that is part of an organization. For example,
    // group@myownpersonaldomain.com could be added as an owner to a project in
    // the myownpersonaldomain.com organization, but not the examplepetstore.com
    // organization.
    //
    // + Service accounts can be made owners of a project directly
    // without any restrictions. However, to be added as an owner, a user must be
    // invited using the Cloud Platform console and must accept the invitation.
    //
    // + A user cannot be granted the owner role using `setIamPolicy()`. The user
    // must be granted the owner role using the Cloud Platform Console and must
    // explicitly accept the invitation.
    //
    // + Invitations to grant the owner role cannot be sent using
    // `setIamPolicy()`;
    // they must be sent only using the Cloud Platform Console.
    //
    // + If the project is not part of an organization, there must be at least
    // one owner who has accepted the Terms of Service (ToS) agreement in the
    // policy. Calling `setIamPolicy()` to remove the last ToS-accepted owner
    // from the policy will fail. This restriction also applies to legacy
    // projects that no longer have owners who have accepted the ToS. Edits to
    // IAM policies will be rejected until the lack of a ToS-accepting owner is
    // rectified. If the project is part of an organization, you can remove all
    // owners, potentially making the organization inaccessible.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Returns permissions that a caller has on the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123..
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Retrieves the project identified by the specified `name` (for example,
      // `projects/415104041262`).
      //
      // The caller must have `resourcemanager.projects.get` permission
      // for this project.
      virtual void GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists projects that are direct children of the specified folder or
      // organization resource. `list()` provides a strongly consistent view of the
      // projects underneath the specified parent resource. `list()` returns
      // projects sorted based upon the (ascending) lexical ordering of their
      // `display_name`. The caller must have `resourcemanager.projects.list`
      // permission on the identified parent.
      virtual void ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Search for projects that the caller has both `resourcemanager.projects.get`
      // permission on, and also satisfy the specified query.
      //
      // This method returns projects in an unspecified order.
      //
      // This method is eventually consistent with project mutations; this means
      // that a newly created project may not appear in the results or recent
      // updates to an existing project may not be reflected in the results. To
      // retrieve the latest state of a project, use the
      // [GetProject][google.cloud.resourcemanager.v3.Projects.GetProject] method.
      virtual void SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Request that a new project be created. The result is an `Operation` which
      // can be used to track the creation process. This process usually takes a few
      // seconds, but can sometimes take much longer. The tracking `Operation` is
      // automatically deleted after a few hours, so there is no need to call
      // `DeleteOperation`.
      virtual void CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the `display_name` and labels of the project identified by the
      // specified `name` (for example, `projects/415104041262`). Deleting all
      // labels requires an update mask for labels field.
      //
      // The caller must have `resourcemanager.projects.update` permission for this
      // project.
      virtual void UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Move a project to another place in your resource hierarchy, under a new
      // resource parent.
      //
      // Returns an operation which can be used to track the process of the project
      // move workflow.
      // Upon success, the `Operation.response` field will be populated with the
      // moved project.
      //
      // The caller must have `resourcemanager.projects.move` permission on the
      // project, on the project's current and proposed new parent.
      //
      // If project has no current parent, or it currently does not have an
      // associated organization resource, you will also need the
      // `resourcemanager.projects.setIamPolicy` permission in the project.
      //
      //
      virtual void MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks the project identified by the specified
      // `name` (for example, `projects/415104041262`) for deletion.
      //
      // This method will only affect the project if it has a lifecycle state of
      // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE].
      //
      // This method changes the Project's lifecycle state from
      // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE]
      // to
      // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Project.State.DELETE_REQUESTED].
      // The deletion starts at an unspecified time,
      // at which point the Project is no longer accessible.
      //
      // Until the deletion completes, you can check the lifecycle state
      // checked by retrieving the project with [GetProject]
      // [google.cloud.resourcemanager.v3.Projects.GetProject],
      // and the project remains visible to [ListProjects]
      // [google.cloud.resourcemanager.v3.Projects.ListProjects].
      // However, you cannot update the project.
      //
      // After the deletion completes, the project is not retrievable by
      // the  [GetProject]
      // [google.cloud.resourcemanager.v3.Projects.GetProject],
      // [ListProjects]
      // [google.cloud.resourcemanager.v3.Projects.ListProjects], and
      // [SearchProjects][google.cloud.resourcemanager.v3.Projects.SearchProjects]
      // methods.
      //
      // This method behaves idempotently, such that deleting a `DELETE_REQUESTED`
      // project will not cause an error, but also won't do anything.
      //
      // The caller must have `resourcemanager.projects.delete` permissions for this
      // project.
      virtual void DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores the project identified by the specified
      // `name` (for example, `projects/415104041262`).
      // You can only use this method for a project that has a lifecycle state of
      // [DELETE_REQUESTED]
      // [Projects.State.DELETE_REQUESTED].
      // After deletion starts, the project cannot be restored.
      //
      // The caller must have `resourcemanager.projects.undelete` permission for
      // this project.
      virtual void UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the IAM access control policy for the specified project, in the
      // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
      // Permission is denied if the policy or the resource do not exist.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the IAM access control policy for the specified project, in the
      // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
      //
      // CAUTION: This method will replace the existing policy, and cannot be used
      // to append additional IAM settings.
      //
      // Note: Removing service accounts from policies or changing their roles can
      // render services completely inoperable. It is important to understand how
      // the service account is being used before removing or updating its roles.
      //
      // The following constraints apply when using `setIamPolicy()`:
      //
      // + Project does not support `allUsers` and `allAuthenticatedUsers` as
      // `members` in a `Binding` of a `Policy`.
      //
      // + The owner role can be granted to a `user`, `serviceAccount`, or a group
      // that is part of an organization. For example,
      // group@myownpersonaldomain.com could be added as an owner to a project in
      // the myownpersonaldomain.com organization, but not the examplepetstore.com
      // organization.
      //
      // + Service accounts can be made owners of a project directly
      // without any restrictions. However, to be added as an owner, a user must be
      // invited using the Cloud Platform console and must accept the invitation.
      //
      // + A user cannot be granted the owner role using `setIamPolicy()`. The user
      // must be granted the owner role using the Cloud Platform Console and must
      // explicitly accept the invitation.
      //
      // + Invitations to grant the owner role cannot be sent using
      // `setIamPolicy()`;
      // they must be sent only using the Cloud Platform Console.
      //
      // + If the project is not part of an organization, there must be at least
      // one owner who has accepted the Terms of Service (ToS) agreement in the
      // policy. Calling `setIamPolicy()` to remove the last ToS-accepted owner
      // from the policy will fail. This restriction also applies to legacy
      // projects that no longer have owners who have accepted the ToS. Edits to
      // IAM policies will be rejected until the lack of a ToS-accepting owner is
      // rectified. If the project is part of an organization, you can remove all
      // owners, potentially making the organization inaccessible.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns permissions that a caller has on the specified project, in the
      // format `projects/{ProjectIdOrNumber}` e.g. projects/123..
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>* AsyncGetProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Project>* PrepareAsyncGetProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>* AsyncListProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListProjectsResponse>* PrepareAsyncListProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* AsyncSearchProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* PrepareAsyncSearchProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncMoveProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncMoveProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::google::cloud::resourcemanager::v3::Project* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>> AsyncGetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>>(AsyncGetProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>> PrepareAsyncGetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>>(PrepareAsyncGetProjectRaw(context, request, cq));
    }
    ::grpc::Status ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>> AsyncListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>>(AsyncListProjectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>> PrepareAsyncListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>>(PrepareAsyncListProjectsRaw(context, request, cq));
    }
    ::grpc::Status SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>> AsyncSearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>>(AsyncSearchProjectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>> PrepareAsyncSearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>>(PrepareAsyncSearchProjectsRaw(context, request, cq));
    }
    ::grpc::Status CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateProjectRaw(context, request, cq));
    }
    ::grpc::Status UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateProjectRaw(context, request, cq));
    }
    ::grpc::Status MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncMoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncMoveProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncMoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncMoveProjectRaw(context, request, cq));
    }
    ::grpc::Status DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteProjectRaw(context, request, cq));
    }
    ::grpc::Status UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeleteProjectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeleteProjectRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response, std::function<void(::grpc::Status)>) override;
      void GetProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchProjects(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void MoveProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeleteProject(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>* AsyncGetProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Project>* PrepareAsyncGetProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>* AsyncListProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListProjectsResponse>* PrepareAsyncListProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* AsyncSearchProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* PrepareAsyncSearchProjectsRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncMoveProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncMoveProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeleteProjectRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetProject_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProjects_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchProjects_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProject_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProject_;
    const ::grpc::internal::RpcMethod rpcmethod_MoveProject_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProject_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeleteProject_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Retrieves the project identified by the specified `name` (for example,
    // `projects/415104041262`).
    //
    // The caller must have `resourcemanager.projects.get` permission
    // for this project.
    virtual ::grpc::Status GetProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response);
    // Lists projects that are direct children of the specified folder or
    // organization resource. `list()` provides a strongly consistent view of the
    // projects underneath the specified parent resource. `list()` returns
    // projects sorted based upon the (ascending) lexical ordering of their
    // `display_name`. The caller must have `resourcemanager.projects.list`
    // permission on the identified parent.
    virtual ::grpc::Status ListProjects(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response);
    // Search for projects that the caller has both `resourcemanager.projects.get`
    // permission on, and also satisfy the specified query.
    //
    // This method returns projects in an unspecified order.
    //
    // This method is eventually consistent with project mutations; this means
    // that a newly created project may not appear in the results or recent
    // updates to an existing project may not be reflected in the results. To
    // retrieve the latest state of a project, use the
    // [GetProject][google.cloud.resourcemanager.v3.Projects.GetProject] method.
    virtual ::grpc::Status SearchProjects(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response);
    // Request that a new project be created. The result is an `Operation` which
    // can be used to track the creation process. This process usually takes a few
    // seconds, but can sometimes take much longer. The tracking `Operation` is
    // automatically deleted after a few hours, so there is no need to call
    // `DeleteOperation`.
    virtual ::grpc::Status CreateProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response);
    // Updates the `display_name` and labels of the project identified by the
    // specified `name` (for example, `projects/415104041262`). Deleting all
    // labels requires an update mask for labels field.
    //
    // The caller must have `resourcemanager.projects.update` permission for this
    // project.
    virtual ::grpc::Status UpdateProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response);
    // Move a project to another place in your resource hierarchy, under a new
    // resource parent.
    //
    // Returns an operation which can be used to track the process of the project
    // move workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // moved project.
    //
    // The caller must have `resourcemanager.projects.move` permission on the
    // project, on the project's current and proposed new parent.
    //
    // If project has no current parent, or it currently does not have an
    // associated organization resource, you will also need the
    // `resourcemanager.projects.setIamPolicy` permission in the project.
    //
    //
    virtual ::grpc::Status MoveProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response);
    // Marks the project identified by the specified
    // `name` (for example, `projects/415104041262`) for deletion.
    //
    // This method will only affect the project if it has a lifecycle state of
    // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE].
    //
    // This method changes the Project's lifecycle state from
    // [ACTIVE][google.cloud.resourcemanager.v3.Project.State.ACTIVE]
    // to
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Project.State.DELETE_REQUESTED].
    // The deletion starts at an unspecified time,
    // at which point the Project is no longer accessible.
    //
    // Until the deletion completes, you can check the lifecycle state
    // checked by retrieving the project with [GetProject]
    // [google.cloud.resourcemanager.v3.Projects.GetProject],
    // and the project remains visible to [ListProjects]
    // [google.cloud.resourcemanager.v3.Projects.ListProjects].
    // However, you cannot update the project.
    //
    // After the deletion completes, the project is not retrievable by
    // the  [GetProject]
    // [google.cloud.resourcemanager.v3.Projects.GetProject],
    // [ListProjects]
    // [google.cloud.resourcemanager.v3.Projects.ListProjects], and
    // [SearchProjects][google.cloud.resourcemanager.v3.Projects.SearchProjects]
    // methods.
    //
    // This method behaves idempotently, such that deleting a `DELETE_REQUESTED`
    // project will not cause an error, but also won't do anything.
    //
    // The caller must have `resourcemanager.projects.delete` permissions for this
    // project.
    virtual ::grpc::Status DeleteProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response);
    // Restores the project identified by the specified
    // `name` (for example, `projects/415104041262`).
    // You can only use this method for a project that has a lifecycle state of
    // [DELETE_REQUESTED]
    // [Projects.State.DELETE_REQUESTED].
    // After deletion starts, the project cannot be restored.
    //
    // The caller must have `resourcemanager.projects.undelete` permission for
    // this project.
    virtual ::grpc::Status UndeleteProject(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response);
    // Returns the IAM access control policy for the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
    // Permission is denied if the policy or the resource do not exist.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Sets the IAM access control policy for the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123.
    //
    // CAUTION: This method will replace the existing policy, and cannot be used
    // to append additional IAM settings.
    //
    // Note: Removing service accounts from policies or changing their roles can
    // render services completely inoperable. It is important to understand how
    // the service account is being used before removing or updating its roles.
    //
    // The following constraints apply when using `setIamPolicy()`:
    //
    // + Project does not support `allUsers` and `allAuthenticatedUsers` as
    // `members` in a `Binding` of a `Policy`.
    //
    // + The owner role can be granted to a `user`, `serviceAccount`, or a group
    // that is part of an organization. For example,
    // group@myownpersonaldomain.com could be added as an owner to a project in
    // the myownpersonaldomain.com organization, but not the examplepetstore.com
    // organization.
    //
    // + Service accounts can be made owners of a project directly
    // without any restrictions. However, to be added as an owner, a user must be
    // invited using the Cloud Platform console and must accept the invitation.
    //
    // + A user cannot be granted the owner role using `setIamPolicy()`. The user
    // must be granted the owner role using the Cloud Platform Console and must
    // explicitly accept the invitation.
    //
    // + Invitations to grant the owner role cannot be sent using
    // `setIamPolicy()`;
    // they must be sent only using the Cloud Platform Console.
    //
    // + If the project is not part of an organization, there must be at least
    // one owner who has accepted the Terms of Service (ToS) agreement in the
    // policy. Calling `setIamPolicy()` to remove the last ToS-accepted owner
    // from the policy will fail. This restriction also applies to legacy
    // projects that no longer have owners who have accepted the ToS. Edits to
    // IAM policies will be rejected until the lack of a ToS-accepting owner is
    // rectified. If the project is part of an organization, you can remove all
    // owners, potentially making the organization inaccessible.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns permissions that a caller has on the specified project, in the
    // format `projects/{ProjectIdOrNumber}` e.g. projects/123..
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProject() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::Project>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProjects() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProjects(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::ListProjectsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchProjects() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchProjects(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProject() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProject() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MoveProject() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProject() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteProject(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetProject<WithAsyncMethod_ListProjects<WithAsyncMethod_SearchProjects<WithAsyncMethod_CreateProject<WithAsyncMethod_UpdateProject<WithAsyncMethod_MoveProject<WithAsyncMethod_DeleteProject<WithAsyncMethod_UndeleteProject<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_TestIamPermissions<Service > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProject() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::GetProjectRequest, ::google::cloud::resourcemanager::v3::Project>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::GetProjectRequest* request, ::google::cloud::resourcemanager::v3::Project* response) { return this->GetProject(context, request, response); }));}
    void SetMessageAllocatorFor_GetProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::GetProjectRequest, ::google::cloud::resourcemanager::v3::Project>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::GetProjectRequest, ::google::cloud::resourcemanager::v3::Project>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProjects() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListProjectsRequest, ::google::cloud::resourcemanager::v3::ListProjectsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* request, ::google::cloud::resourcemanager::v3::ListProjectsResponse* response) { return this->ListProjects(context, request, response); }));}
    void SetMessageAllocatorFor_ListProjects(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::ListProjectsRequest, ::google::cloud::resourcemanager::v3::ListProjectsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListProjectsRequest, ::google::cloud::resourcemanager::v3::ListProjectsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProjects(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchProjects() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::SearchProjectsRequest, ::google::cloud::resourcemanager::v3::SearchProjectsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* request, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* response) { return this->SearchProjects(context, request, response); }));}
    void SetMessageAllocatorFor_SearchProjects(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::SearchProjectsRequest, ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::SearchProjectsRequest, ::google::cloud::resourcemanager::v3::SearchProjectsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchProjects(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProject() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateProjectRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* request, ::google::longrunning::Operation* response) { return this->CreateProject(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::CreateProjectRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateProjectRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProject() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UpdateProjectRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* request, ::google::longrunning::Operation* response) { return this->UpdateProject(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::UpdateProjectRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UpdateProjectRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MoveProject() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::MoveProjectRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* request, ::google::longrunning::Operation* response) { return this->MoveProject(context, request, response); }));}
    void SetMessageAllocatorFor_MoveProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::MoveProjectRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::MoveProjectRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProject() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteProjectRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* request, ::google::longrunning::Operation* response) { return this->DeleteProject(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::DeleteProjectRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteProjectRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UndeleteProjectRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* request, ::google::longrunning::Operation* response) { return this->UndeleteProject(context, request, response); }));}
    void SetMessageAllocatorFor_UndeleteProject(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::UndeleteProjectRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UndeleteProjectRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteProject(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetProject<WithCallbackMethod_ListProjects<WithCallbackMethod_SearchProjects<WithCallbackMethod_CreateProject<WithCallbackMethod_UpdateProject<WithCallbackMethod_MoveProject<WithCallbackMethod_DeleteProject<WithCallbackMethod_UndeleteProject<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_TestIamPermissions<Service > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProject() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProjects() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchProjects() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProject() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProject() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MoveProject() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProject() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProject() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProjects() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProjects(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchProjects() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchProjects(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProject() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProject() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MoveProject() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProject() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteProject(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProject() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProjects() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProjects(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProjects(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchProjects() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchProjects(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchProjects(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProject() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProject() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MoveProject() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MoveProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProject() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeleteProject(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteProject(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProject() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::GetProjectRequest, ::google::cloud::resourcemanager::v3::Project>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::GetProjectRequest, ::google::cloud::resourcemanager::v3::Project>* streamer) {
                       return this->StreamedGetProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetProjectRequest* /*request*/, ::google::cloud::resourcemanager::v3::Project* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::GetProjectRequest,::google::cloud::resourcemanager::v3::Project>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProjects() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::ListProjectsRequest, ::google::cloud::resourcemanager::v3::ListProjectsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::ListProjectsRequest, ::google::cloud::resourcemanager::v3::ListProjectsResponse>* streamer) {
                       return this->StreamedListProjects(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProjects(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::ListProjectsRequest,::google::cloud::resourcemanager::v3::ListProjectsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchProjects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchProjects() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::SearchProjectsRequest, ::google::cloud::resourcemanager::v3::SearchProjectsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::SearchProjectsRequest, ::google::cloud::resourcemanager::v3::SearchProjectsResponse>* streamer) {
                       return this->StreamedSearchProjects(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchProjects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchProjects(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchProjectsRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchProjectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchProjects(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::SearchProjectsRequest,::google::cloud::resourcemanager::v3::SearchProjectsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProject() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::CreateProjectRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::CreateProjectRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::CreateProjectRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProject() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::UpdateProjectRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::UpdateProjectRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::UpdateProjectRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MoveProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MoveProject() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::MoveProjectRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::MoveProjectRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedMoveProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MoveProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MoveProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMoveProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::MoveProjectRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProject() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::DeleteProjectRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::DeleteProjectRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::DeleteProjectRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeleteProject : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeleteProject() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::UndeleteProjectRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::UndeleteProjectRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeleteProject(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeleteProject() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeleteProject(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteProjectRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeleteProject(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::UndeleteProjectRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetProject<WithStreamedUnaryMethod_ListProjects<WithStreamedUnaryMethod_SearchProjects<WithStreamedUnaryMethod_CreateProject<WithStreamedUnaryMethod_UpdateProject<WithStreamedUnaryMethod_MoveProject<WithStreamedUnaryMethod_DeleteProject<WithStreamedUnaryMethod_UndeleteProject<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetProject<WithStreamedUnaryMethod_ListProjects<WithStreamedUnaryMethod_SearchProjects<WithStreamedUnaryMethod_CreateProject<WithStreamedUnaryMethod_UpdateProject<WithStreamedUnaryMethod_MoveProject<WithStreamedUnaryMethod_DeleteProject<WithStreamedUnaryMethod_UndeleteProject<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedService;
};

}  // namespace v3
}  // namespace resourcemanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fresourcemanager_2fv3_2fprojects_2eproto__INCLUDED
