// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/retail/v2/catalog_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fretail_2fv2_2fcatalog_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fretail_2fv2_2fcatalog_5fservice_2eproto__INCLUDED

#include "google/cloud/retail/v2/catalog_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace retail {
namespace v2 {

// Service for managing catalog configuration.
class CatalogService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.retail.v2.CatalogService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all the [Catalog][google.cloud.retail.v2.Catalog]s associated with
    // the project.
    virtual ::grpc::Status ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::google::cloud::retail::v2::ListCatalogsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>> AsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>>(AsyncListCatalogsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>> PrepareAsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>>(PrepareAsyncListCatalogsRaw(context, request, cq));
    }
    // Updates the [Catalog][google.cloud.retail.v2.Catalog]s.
    virtual ::grpc::Status UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::google::cloud::retail::v2::Catalog* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>> AsyncUpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>>(AsyncUpdateCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>> PrepareAsyncUpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>>(PrepareAsyncUpdateCatalogRaw(context, request, cq));
    }
    // Set a specified branch id as default branch. API methods such as
    // [SearchService.Search][google.cloud.retail.v2.SearchService.Search],
    // [ProductService.GetProduct][google.cloud.retail.v2.ProductService.GetProduct],
    // [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
    // will treat requests using "default_branch" to the actual branch id set as
    // default.
    //
    // For example, if `projects/*/locations/*/catalogs/*/branches/1` is set as
    // default, setting
    // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // `projects/*/locations/*/catalogs/*/branches/default_branch` is equivalent
    // to setting
    // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // `projects/*/locations/*/catalogs/*/branches/1`.
    //
    // Using multiple branches can be useful when developers would like
    // to have a staging branch to test and verify for future usage. When it
    // becomes ready, developers switch on the staging branch using this API while
    // keeping using `projects/*/locations/*/catalogs/*/branches/default_branch`
    // as [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // route the traffic to this staging branch.
    //
    // CAUTION: If you have live predict/search traffic, switching the default
    // branch could potentially cause outages if the ID space of the new branch is
    // very different from the old one.
    //
    // More specifically:
    //
    // * PredictionService will only return product IDs from branch {newBranch}.
    // * SearchService will only return product IDs from branch {newBranch}
    //   (if branch is not explicitly set).
    // * UserEventService will only join events with products from branch
    //   {newBranch}.
    virtual ::grpc::Status SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncSetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncSetDefaultBranchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncSetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncSetDefaultBranchRaw(context, request, cq));
    }
    // Get which branch is currently default branch set by
    // [CatalogService.SetDefaultBranch][google.cloud.retail.v2.CatalogService.SetDefaultBranch]
    // method under a specified parent catalog.
    virtual ::grpc::Status GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>> AsyncGetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>>(AsyncGetDefaultBranchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>> PrepareAsyncGetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>>(PrepareAsyncGetDefaultBranchRaw(context, request, cq));
    }
    // Gets a [CompletionConfig][google.cloud.retail.v2.CompletionConfig].
    virtual ::grpc::Status GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::google::cloud::retail::v2::CompletionConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>> AsyncGetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>>(AsyncGetCompletionConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>> PrepareAsyncGetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>>(PrepareAsyncGetCompletionConfigRaw(context, request, cq));
    }
    // Updates the [CompletionConfig][google.cloud.retail.v2.CompletionConfig]s.
    virtual ::grpc::Status UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::google::cloud::retail::v2::CompletionConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>> AsyncUpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>>(AsyncUpdateCompletionConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>> PrepareAsyncUpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>>(PrepareAsyncUpdateCompletionConfigRaw(context, request, cq));
    }
    // Gets an [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    virtual ::grpc::Status GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> AsyncGetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(AsyncGetAttributesConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncGetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncGetAttributesConfigRaw(context, request, cq));
    }
    // Updates the [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // The catalog attributes in the request will be updated in the catalog, or
    // inserted if they do not exist. Existing catalog attributes not included in
    // the request will remain unchanged. Attributes that are assigned to
    // products, but do not exist at the catalog level, are always included in the
    // response. The product attribute is assigned default values for missing
    // catalog attribute fields, e.g., searchable and dynamic facetable options.
    virtual ::grpc::Status UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> AsyncUpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(AsyncUpdateAttributesConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncUpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncUpdateAttributesConfigRaw(context, request, cq));
    }
    // Adds the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to add
    // already exists, an ALREADY_EXISTS error is returned.
    virtual ::grpc::Status AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> AsyncAddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(AsyncAddCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncAddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncAddCatalogAttributeRaw(context, request, cq));
    }
    // Removes the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] from the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
    // remove does not exist, a NOT_FOUND error is returned.
    virtual ::grpc::Status RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> AsyncRemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(AsyncRemoveCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncRemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncRemoveCatalogAttributeRaw(context, request, cq));
    }
    // Replaces the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] in the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig] by updating the
    // catalog attribute with the same
    // [CatalogAttribute.key][google.cloud.retail.v2.CatalogAttribute.key].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
    // replace does not exist, a NOT_FOUND error is returned.
    virtual ::grpc::Status ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> AsyncReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(AsyncReplaceCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncReplaceCatalogAttributeRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all the [Catalog][google.cloud.retail.v2.Catalog]s associated with
      // the project.
      virtual void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the [Catalog][google.cloud.retail.v2.Catalog]s.
      virtual void UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Set a specified branch id as default branch. API methods such as
      // [SearchService.Search][google.cloud.retail.v2.SearchService.Search],
      // [ProductService.GetProduct][google.cloud.retail.v2.ProductService.GetProduct],
      // [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
      // will treat requests using "default_branch" to the actual branch id set as
      // default.
      //
      // For example, if `projects/*/locations/*/catalogs/*/branches/1` is set as
      // default, setting
      // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
      // `projects/*/locations/*/catalogs/*/branches/default_branch` is equivalent
      // to setting
      // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
      // `projects/*/locations/*/catalogs/*/branches/1`.
      //
      // Using multiple branches can be useful when developers would like
      // to have a staging branch to test and verify for future usage. When it
      // becomes ready, developers switch on the staging branch using this API while
      // keeping using `projects/*/locations/*/catalogs/*/branches/default_branch`
      // as [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
      // route the traffic to this staging branch.
      //
      // CAUTION: If you have live predict/search traffic, switching the default
      // branch could potentially cause outages if the ID space of the new branch is
      // very different from the old one.
      //
      // More specifically:
      //
      // * PredictionService will only return product IDs from branch {newBranch}.
      // * SearchService will only return product IDs from branch {newBranch}
      //   (if branch is not explicitly set).
      // * UserEventService will only join events with products from branch
      //   {newBranch}.
      virtual void SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get which branch is currently default branch set by
      // [CatalogService.SetDefaultBranch][google.cloud.retail.v2.CatalogService.SetDefaultBranch]
      // method under a specified parent catalog.
      virtual void GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a [CompletionConfig][google.cloud.retail.v2.CompletionConfig].
      virtual void GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the [CompletionConfig][google.cloud.retail.v2.CompletionConfig]s.
      virtual void UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
      virtual void GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
      //
      // The catalog attributes in the request will be updated in the catalog, or
      // inserted if they do not exist. Existing catalog attributes not included in
      // the request will remain unchanged. Attributes that are assigned to
      // products, but do not exist at the catalog level, are always included in the
      // response. The product attribute is assigned default values for missing
      // catalog attribute fields, e.g., searchable and dynamic facetable options.
      virtual void UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds the specified
      // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to the
      // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
      //
      // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to add
      // already exists, an ALREADY_EXISTS error is returned.
      virtual void AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes the specified
      // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] from the
      // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
      //
      // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
      // remove does not exist, a NOT_FOUND error is returned.
      virtual void RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Replaces the specified
      // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] in the
      // [AttributesConfig][google.cloud.retail.v2.AttributesConfig] by updating the
      // catalog attribute with the same
      // [CatalogAttribute.key][google.cloud.retail.v2.CatalogAttribute.key].
      //
      // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
      // replace does not exist, a NOT_FOUND error is returned.
      virtual void ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>* AsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListCatalogsResponse>* PrepareAsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>* AsyncUpdateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Catalog>* PrepareAsyncUpdateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncSetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncSetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>* AsyncGetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::GetDefaultBranchResponse>* PrepareAsyncGetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>* AsyncGetCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>* PrepareAsyncGetCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>* AsyncUpdateCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompletionConfig>* PrepareAsyncUpdateCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* AsyncGetAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncGetAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* AsyncUpdateAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncUpdateAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* AsyncAddCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncAddCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* AsyncRemoveCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncRemoveCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* AsyncReplaceCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncReplaceCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::google::cloud::retail::v2::ListCatalogsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>> AsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>>(AsyncListCatalogsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>> PrepareAsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>>(PrepareAsyncListCatalogsRaw(context, request, cq));
    }
    ::grpc::Status UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::google::cloud::retail::v2::Catalog* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>> AsyncUpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>>(AsyncUpdateCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>> PrepareAsyncUpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>>(PrepareAsyncUpdateCatalogRaw(context, request, cq));
    }
    ::grpc::Status SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncSetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncSetDefaultBranchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncSetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncSetDefaultBranchRaw(context, request, cq));
    }
    ::grpc::Status GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>> AsyncGetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>>(AsyncGetDefaultBranchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>> PrepareAsyncGetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>>(PrepareAsyncGetDefaultBranchRaw(context, request, cq));
    }
    ::grpc::Status GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::google::cloud::retail::v2::CompletionConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>> AsyncGetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>>(AsyncGetCompletionConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>> PrepareAsyncGetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>>(PrepareAsyncGetCompletionConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::google::cloud::retail::v2::CompletionConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>> AsyncUpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>>(AsyncUpdateCompletionConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>> PrepareAsyncUpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>>(PrepareAsyncUpdateCompletionConfigRaw(context, request, cq));
    }
    ::grpc::Status GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> AsyncGetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(AsyncGetAttributesConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncGetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncGetAttributesConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> AsyncUpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(AsyncUpdateAttributesConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncUpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncUpdateAttributesConfigRaw(context, request, cq));
    }
    ::grpc::Status AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> AsyncAddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(AsyncAddCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncAddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncAddCatalogAttributeRaw(context, request, cq));
    }
    ::grpc::Status RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> AsyncRemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(AsyncRemoveCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncRemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncRemoveCatalogAttributeRaw(context, request, cq));
    }
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::google::cloud::retail::v2::AttributesConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> AsyncReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(AsyncReplaceCatalogAttributeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>> PrepareAsyncReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>>(PrepareAsyncReplaceCatalogAttributeRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response, std::function<void(::grpc::Status)>) override;
      void UpdateCatalog(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void SetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response, std::function<void(::grpc::Status)>) override;
      void GetDefaultBranch(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, std::function<void(::grpc::Status)>) override;
      void GetCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateCompletionConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) override;
      void GetAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateAttributesConfig(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) override;
      void AddCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) override;
      void RemoveCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, std::function<void(::grpc::Status)>) override;
      void ReplaceCatalogAttribute(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>* AsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListCatalogsResponse>* PrepareAsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>* AsyncUpdateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Catalog>* PrepareAsyncUpdateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncSetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncSetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>* AsyncGetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::GetDefaultBranchResponse>* PrepareAsyncGetDefaultBranchRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>* AsyncGetCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>* PrepareAsyncGetCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>* AsyncUpdateCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompletionConfig>* PrepareAsyncUpdateCompletionConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* AsyncGetAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncGetAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* AsyncUpdateAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncUpdateAttributesConfigRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* AsyncAddCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncAddCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* AsyncRemoveCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncRemoveCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* AsyncReplaceCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::AttributesConfig>* PrepareAsyncReplaceCatalogAttributeRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListCatalogs_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCatalog_;
    const ::grpc::internal::RpcMethod rpcmethod_SetDefaultBranch_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDefaultBranch_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCompletionConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCompletionConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAttributesConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAttributesConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_AddCatalogAttribute_;
    const ::grpc::internal::RpcMethod rpcmethod_RemoveCatalogAttribute_;
    const ::grpc::internal::RpcMethod rpcmethod_ReplaceCatalogAttribute_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all the [Catalog][google.cloud.retail.v2.Catalog]s associated with
    // the project.
    virtual ::grpc::Status ListCatalogs(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response);
    // Updates the [Catalog][google.cloud.retail.v2.Catalog]s.
    virtual ::grpc::Status UpdateCatalog(::grpc::ServerContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response);
    // Set a specified branch id as default branch. API methods such as
    // [SearchService.Search][google.cloud.retail.v2.SearchService.Search],
    // [ProductService.GetProduct][google.cloud.retail.v2.ProductService.GetProduct],
    // [ProductService.ListProducts][google.cloud.retail.v2.ProductService.ListProducts]
    // will treat requests using "default_branch" to the actual branch id set as
    // default.
    //
    // For example, if `projects/*/locations/*/catalogs/*/branches/1` is set as
    // default, setting
    // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // `projects/*/locations/*/catalogs/*/branches/default_branch` is equivalent
    // to setting
    // [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // `projects/*/locations/*/catalogs/*/branches/1`.
    //
    // Using multiple branches can be useful when developers would like
    // to have a staging branch to test and verify for future usage. When it
    // becomes ready, developers switch on the staging branch using this API while
    // keeping using `projects/*/locations/*/catalogs/*/branches/default_branch`
    // as [SearchRequest.branch][google.cloud.retail.v2.SearchRequest.branch] to
    // route the traffic to this staging branch.
    //
    // CAUTION: If you have live predict/search traffic, switching the default
    // branch could potentially cause outages if the ID space of the new branch is
    // very different from the old one.
    //
    // More specifically:
    //
    // * PredictionService will only return product IDs from branch {newBranch}.
    // * SearchService will only return product IDs from branch {newBranch}
    //   (if branch is not explicitly set).
    // * UserEventService will only join events with products from branch
    //   {newBranch}.
    virtual ::grpc::Status SetDefaultBranch(::grpc::ServerContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response);
    // Get which branch is currently default branch set by
    // [CatalogService.SetDefaultBranch][google.cloud.retail.v2.CatalogService.SetDefaultBranch]
    // method under a specified parent catalog.
    virtual ::grpc::Status GetDefaultBranch(::grpc::ServerContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response);
    // Gets a [CompletionConfig][google.cloud.retail.v2.CompletionConfig].
    virtual ::grpc::Status GetCompletionConfig(::grpc::ServerContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response);
    // Updates the [CompletionConfig][google.cloud.retail.v2.CompletionConfig]s.
    virtual ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response);
    // Gets an [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    virtual ::grpc::Status GetAttributesConfig(::grpc::ServerContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response);
    // Updates the [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // The catalog attributes in the request will be updated in the catalog, or
    // inserted if they do not exist. Existing catalog attributes not included in
    // the request will remain unchanged. Attributes that are assigned to
    // products, but do not exist at the catalog level, are always included in the
    // response. The product attribute is assigned default values for missing
    // catalog attribute fields, e.g., searchable and dynamic facetable options.
    virtual ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response);
    // Adds the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to add
    // already exists, an ALREADY_EXISTS error is returned.
    virtual ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response);
    // Removes the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] from the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
    // remove does not exist, a NOT_FOUND error is returned.
    virtual ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response);
    // Replaces the specified
    // [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] in the
    // [AttributesConfig][google.cloud.retail.v2.AttributesConfig] by updating the
    // catalog attribute with the same
    // [CatalogAttribute.key][google.cloud.retail.v2.CatalogAttribute.key].
    //
    // If the [CatalogAttribute][google.cloud.retail.v2.CatalogAttribute] to
    // replace does not exist, a NOT_FOUND error is returned.
    virtual ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCatalogs(::grpc::ServerContext* context, ::google::cloud::retail::v2::ListCatalogsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::ListCatalogsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCatalog(::grpc::ServerContext* context, ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::Catalog>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetDefaultBranch(::grpc::ServerContext* context, ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDefaultBranch(::grpc::ServerContext* context, ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::GetDefaultBranchResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCompletionConfig(::grpc::ServerContext* context, ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::CompletionConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCompletionConfig(::grpc::ServerContext* context, ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::CompletionConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttributesConfig(::grpc::ServerContext* context, ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::AttributesConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAttributesConfig(::grpc::ServerContext* context, ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::AttributesConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddCatalogAttribute(::grpc::ServerContext* context, ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::AttributesConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveCatalogAttribute(::grpc::ServerContext* context, ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::AttributesConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReplaceCatalogAttribute(::grpc::ServerContext* context, ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::AttributesConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListCatalogs<WithAsyncMethod_UpdateCatalog<WithAsyncMethod_SetDefaultBranch<WithAsyncMethod_GetDefaultBranch<WithAsyncMethod_GetCompletionConfig<WithAsyncMethod_UpdateCompletionConfig<WithAsyncMethod_GetAttributesConfig<WithAsyncMethod_UpdateAttributesConfig<WithAsyncMethod_AddCatalogAttribute<WithAsyncMethod_RemoveCatalogAttribute<WithAsyncMethod_ReplaceCatalogAttribute<Service > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ListCatalogsRequest, ::google::cloud::retail::v2::ListCatalogsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ListCatalogsRequest* request, ::google::cloud::retail::v2::ListCatalogsResponse* response) { return this->ListCatalogs(context, request, response); }));}
    void SetMessageAllocatorFor_ListCatalogs(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ListCatalogsRequest, ::google::cloud::retail::v2::ListCatalogsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ListCatalogsRequest, ::google::cloud::retail::v2::ListCatalogsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCatalogs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateCatalogRequest, ::google::cloud::retail::v2::Catalog>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::UpdateCatalogRequest* request, ::google::cloud::retail::v2::Catalog* response) { return this->UpdateCatalog(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCatalog(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::UpdateCatalogRequest, ::google::cloud::retail::v2::Catalog>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateCatalogRequest, ::google::cloud::retail::v2::Catalog>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::SetDefaultBranchRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::SetDefaultBranchRequest* request, ::google::protobuf::Empty* response) { return this->SetDefaultBranch(context, request, response); }));}
    void SetMessageAllocatorFor_SetDefaultBranch(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::SetDefaultBranchRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::SetDefaultBranchRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetDefaultBranch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetDefaultBranchRequest, ::google::cloud::retail::v2::GetDefaultBranchResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::GetDefaultBranchRequest* request, ::google::cloud::retail::v2::GetDefaultBranchResponse* response) { return this->GetDefaultBranch(context, request, response); }));}
    void SetMessageAllocatorFor_GetDefaultBranch(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::GetDefaultBranchRequest, ::google::cloud::retail::v2::GetDefaultBranchResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetDefaultBranchRequest, ::google::cloud::retail::v2::GetDefaultBranchResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDefaultBranch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::GetCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response) { return this->GetCompletionConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetCompletionConfig(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::GetCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCompletionConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* request, ::google::cloud::retail::v2::CompletionConfig* response) { return this->UpdateCompletionConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCompletionConfig(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::UpdateCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCompletionConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::GetAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response) { return this->GetAttributesConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetAttributesConfig(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::GetAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttributesConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* request, ::google::cloud::retail::v2::AttributesConfig* response) { return this->UpdateAttributesConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAttributesConfig(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::UpdateAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAttributesConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::AddCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response) { return this->AddCatalogAttribute(context, request, response); }));}
    void SetMessageAllocatorFor_AddCatalogAttribute(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::AddCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::AddCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::RemoveCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response) { return this->RemoveCatalogAttribute(context, request, response); }));}
    void SetMessageAllocatorFor_RemoveCatalogAttribute(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::RemoveCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::RemoveCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* request, ::google::cloud::retail::v2::AttributesConfig* response) { return this->ReplaceCatalogAttribute(context, request, response); }));}
    void SetMessageAllocatorFor_ReplaceCatalogAttribute(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReplaceCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListCatalogs<WithCallbackMethod_UpdateCatalog<WithCallbackMethod_SetDefaultBranch<WithCallbackMethod_GetDefaultBranch<WithCallbackMethod_GetCompletionConfig<WithCallbackMethod_UpdateCompletionConfig<WithCallbackMethod_GetAttributesConfig<WithCallbackMethod_UpdateAttributesConfig<WithCallbackMethod_AddCatalogAttribute<WithCallbackMethod_RemoveCatalogAttribute<WithCallbackMethod_ReplaceCatalogAttribute<Service > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCatalogs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCatalog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetDefaultBranch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDefaultBranch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCompletionConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCompletionConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttributesConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAttributesConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddCatalogAttribute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveCatalogAttribute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReplaceCatalogAttribute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCatalogs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCatalogs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCatalog(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetDefaultBranch(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetDefaultBranch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDefaultBranch(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDefaultBranch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCompletionConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCompletionConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCompletionConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCompletionConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAttributesConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttributesConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAttributesConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAttributesConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddCatalogAttribute(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RemoveCatalogAttribute(context, request, response); }));
    }
    ~WithRawCallbackMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReplaceCatalogAttribute(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReplaceCatalogAttribute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ListCatalogsRequest, ::google::cloud::retail::v2::ListCatalogsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ListCatalogsRequest, ::google::cloud::retail::v2::ListCatalogsResponse>* streamer) {
                       return this->StreamedListCatalogs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListCatalogsRequest* /*request*/, ::google::cloud::retail::v2::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCatalogs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ListCatalogsRequest,::google::cloud::retail::v2::ListCatalogsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCatalog() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::UpdateCatalogRequest, ::google::cloud::retail::v2::Catalog>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::UpdateCatalogRequest, ::google::cloud::retail::v2::Catalog>* streamer) {
                       return this->StreamedUpdateCatalog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCatalogRequest* /*request*/, ::google::cloud::retail::v2::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCatalog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::UpdateCatalogRequest,::google::cloud::retail::v2::Catalog>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetDefaultBranch() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::SetDefaultBranchRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::SetDefaultBranchRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedSetDefaultBranch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::SetDefaultBranchRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetDefaultBranch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::SetDefaultBranchRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDefaultBranch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDefaultBranch() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::GetDefaultBranchRequest, ::google::cloud::retail::v2::GetDefaultBranchResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::GetDefaultBranchRequest, ::google::cloud::retail::v2::GetDefaultBranchResponse>* streamer) {
                       return this->StreamedGetDefaultBranch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDefaultBranch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDefaultBranch(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetDefaultBranchRequest* /*request*/, ::google::cloud::retail::v2::GetDefaultBranchResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDefaultBranch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::GetDefaultBranchRequest,::google::cloud::retail::v2::GetDefaultBranchResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCompletionConfig() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::GetCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::GetCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>* streamer) {
                       return this->StreamedGetCompletionConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCompletionConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::GetCompletionConfigRequest,::google::cloud::retail::v2::CompletionConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCompletionConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCompletionConfig() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::UpdateCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::UpdateCompletionConfigRequest, ::google::cloud::retail::v2::CompletionConfig>* streamer) {
                       return this->StreamedUpdateCompletionConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCompletionConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCompletionConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateCompletionConfigRequest* /*request*/, ::google::cloud::retail::v2::CompletionConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCompletionConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::UpdateCompletionConfigRequest,::google::cloud::retail::v2::CompletionConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAttributesConfig() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::GetAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::GetAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>* streamer) {
                       return this->StreamedGetAttributesConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAttributesConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::GetAttributesConfigRequest,::google::cloud::retail::v2::AttributesConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAttributesConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAttributesConfig() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::UpdateAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::UpdateAttributesConfigRequest, ::google::cloud::retail::v2::AttributesConfig>* streamer) {
                       return this->StreamedUpdateAttributesConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAttributesConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAttributesConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateAttributesConfigRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAttributesConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::UpdateAttributesConfigRequest,::google::cloud::retail::v2::AttributesConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddCatalogAttribute() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::AddCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::AddCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* streamer) {
                       return this->StreamedAddCatalogAttribute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::AddCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddCatalogAttribute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::AddCatalogAttributeRequest,::google::cloud::retail::v2::AttributesConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RemoveCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RemoveCatalogAttribute() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::RemoveCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::RemoveCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* streamer) {
                       return this->StreamedRemoveCatalogAttribute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RemoveCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RemoveCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RemoveCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRemoveCatalogAttribute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::RemoveCatalogAttributeRequest,::google::cloud::retail::v2::AttributesConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReplaceCatalogAttribute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReplaceCatalogAttribute() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest, ::google::cloud::retail::v2::AttributesConfig>* streamer) {
                       return this->StreamedReplaceCatalogAttribute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReplaceCatalogAttribute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReplaceCatalogAttribute(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest* /*request*/, ::google::cloud::retail::v2::AttributesConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReplaceCatalogAttribute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ReplaceCatalogAttributeRequest,::google::cloud::retail::v2::AttributesConfig>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListCatalogs<WithStreamedUnaryMethod_UpdateCatalog<WithStreamedUnaryMethod_SetDefaultBranch<WithStreamedUnaryMethod_GetDefaultBranch<WithStreamedUnaryMethod_GetCompletionConfig<WithStreamedUnaryMethod_UpdateCompletionConfig<WithStreamedUnaryMethod_GetAttributesConfig<WithStreamedUnaryMethod_UpdateAttributesConfig<WithStreamedUnaryMethod_AddCatalogAttribute<WithStreamedUnaryMethod_RemoveCatalogAttribute<WithStreamedUnaryMethod_ReplaceCatalogAttribute<Service > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListCatalogs<WithStreamedUnaryMethod_UpdateCatalog<WithStreamedUnaryMethod_SetDefaultBranch<WithStreamedUnaryMethod_GetDefaultBranch<WithStreamedUnaryMethod_GetCompletionConfig<WithStreamedUnaryMethod_UpdateCompletionConfig<WithStreamedUnaryMethod_GetAttributesConfig<WithStreamedUnaryMethod_UpdateAttributesConfig<WithStreamedUnaryMethod_AddCatalogAttribute<WithStreamedUnaryMethod_RemoveCatalogAttribute<WithStreamedUnaryMethod_ReplaceCatalogAttribute<Service > > > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace retail
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fretail_2fv2_2fcatalog_5fservice_2eproto__INCLUDED
