// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/shell/v1/cloudshell.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fshell_2fv1_2fcloudshell_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fshell_2fv1_2fcloudshell_2eproto__INCLUDED

#include "google/cloud/shell/v1/cloudshell.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace shell {
namespace v1 {

// API for interacting with Google Cloud Shell. Each user of Cloud Shell has at
// least one environment, which has the ID "default". Environment consists of a
// Docker image defining what is installed on the environment and a home
// directory containing the user's data that will remain across sessions.
// Clients use this API to start and fetch information about their environment,
// which can then be used to connect to that environment via a separate SSH
// client.
class CloudShellService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.shell.v1.CloudShellService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets an environment. Returns NOT_FOUND if the environment does not exist.
    virtual ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::google::cloud::shell::v1::Environment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    // Starts an existing environment, allowing clients to connect to it. The
    // returned operation will contain an instance of StartEnvironmentMetadata in
    // its metadata field. Users can wait for the environment to start by polling
    // this operation via GetOperation. Once the environment has finished starting
    // and is ready to accept connections, the operation will contain a
    // StartEnvironmentResponse in its response field.
    virtual ::grpc::Status StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStartEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStartEnvironmentRaw(context, request, cq));
    }
    // Sends OAuth credentials to a running environment on behalf of a user. When
    // this completes, the environment will be authorized to run various Google
    // Cloud command line tools without requiring the user to manually
    // authenticate.
    virtual ::grpc::Status AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAuthorizeEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAuthorizeEnvironmentRaw(context, request, cq));
    }
    // Adds a public SSH key to an environment, allowing clients with the
    // corresponding private key to connect to that environment via SSH. If a key
    // with the same content already exists, this will error with ALREADY_EXISTS.
    virtual ::grpc::Status AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAddPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAddPublicKeyRaw(context, request, cq));
    }
    // Removes a public SSH key from an environment. Clients will no longer be
    // able to connect to the environment using the corresponding private key.
    // If a key with the same content is not present, this will error with
    // NOT_FOUND.
    virtual ::grpc::Status RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRemovePublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRemovePublicKeyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets an environment. Returns NOT_FOUND if the environment does not exist.
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts an existing environment, allowing clients to connect to it. The
      // returned operation will contain an instance of StartEnvironmentMetadata in
      // its metadata field. Users can wait for the environment to start by polling
      // this operation via GetOperation. Once the environment has finished starting
      // and is ready to accept connections, the operation will contain a
      // StartEnvironmentResponse in its response field.
      virtual void StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sends OAuth credentials to a running environment on behalf of a user. When
      // this completes, the environment will be authorized to run various Google
      // Cloud command line tools without requiring the user to manually
      // authenticate.
      virtual void AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds a public SSH key to an environment, allowing clients with the
      // corresponding private key to connect to that environment via SSH. If a key
      // with the same content already exists, this will error with ALREADY_EXISTS.
      virtual void AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes a public SSH key from an environment. Clients will no longer be
      // able to connect to the environment using the corresponding private key.
      // If a key with the same content is not present, this will error with
      // NOT_FOUND.
      virtual void RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::shell::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStartEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStartEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAuthorizeEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAuthorizeEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAddPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAddPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRemovePublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRemovePublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::google::cloud::shell::v1::Environment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStartEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStartEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAuthorizeEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAuthorizeEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAddPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAddPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRemovePublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRemovePublicKeyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response, std::function<void(::grpc::Status)>) override;
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AuthorizeEnvironment(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AddPublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RemovePublicKey(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::shell::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStartEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStartEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAuthorizeEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAuthorizeEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAddPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAddPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRemovePublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRemovePublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_StartEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_AuthorizeEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_AddPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_RemovePublicKey_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets an environment. Returns NOT_FOUND if the environment does not exist.
    virtual ::grpc::Status GetEnvironment(::grpc::ServerContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response);
    // Starts an existing environment, allowing clients to connect to it. The
    // returned operation will contain an instance of StartEnvironmentMetadata in
    // its metadata field. Users can wait for the environment to start by polling
    // this operation via GetOperation. Once the environment has finished starting
    // and is ready to accept connections, the operation will contain a
    // StartEnvironmentResponse in its response field.
    virtual ::grpc::Status StartEnvironment(::grpc::ServerContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Sends OAuth credentials to a running environment on behalf of a user. When
    // this completes, the environment will be authorized to run various Google
    // Cloud command line tools without requiring the user to manually
    // authenticate.
    virtual ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Adds a public SSH key to an environment, allowing clients with the
    // corresponding private key to connect to that environment via SSH. If a key
    // with the same content already exists, this will error with ALREADY_EXISTS.
    virtual ::grpc::Status AddPublicKey(::grpc::ServerContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response);
    // Removes a public SSH key from an environment. Clients will no longer be
    // able to connect to the environment using the corresponding private key.
    // If a key with the same content is not present, this will error with
    // NOT_FOUND.
    virtual ::grpc::Status RemovePublicKey(::grpc::ServerContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::shell::v1::Environment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartEnvironment(::grpc::ServerContext* context, ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAuthorizeEnvironment(::grpc::ServerContext* context, ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddPublicKey(::grpc::ServerContext* context, ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemovePublicKey(::grpc::ServerContext* context, ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetEnvironment<WithAsyncMethod_StartEnvironment<WithAsyncMethod_AuthorizeEnvironment<WithAsyncMethod_AddPublicKey<WithAsyncMethod_RemovePublicKey<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::GetEnvironmentRequest, ::google::cloud::shell::v1::Environment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::shell::v1::GetEnvironmentRequest* request, ::google::cloud::shell::v1::Environment* response) { return this->GetEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_GetEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::shell::v1::GetEnvironmentRequest, ::google::cloud::shell::v1::Environment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::GetEnvironmentRequest, ::google::cloud::shell::v1::Environment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::StartEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::shell::v1::StartEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->StartEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_StartEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::shell::v1::StartEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::StartEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::AuthorizeEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->AuthorizeEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_AuthorizeEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::shell::v1::AuthorizeEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::AuthorizeEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AuthorizeEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::AddPublicKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::shell::v1::AddPublicKeyRequest* request, ::google::longrunning::Operation* response) { return this->AddPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_AddPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::shell::v1::AddPublicKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::AddPublicKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::RemovePublicKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::shell::v1::RemovePublicKeyRequest* request, ::google::longrunning::Operation* response) { return this->RemovePublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_RemovePublicKey(
        ::grpc::MessageAllocator< ::google::cloud::shell::v1::RemovePublicKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::shell::v1::RemovePublicKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemovePublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetEnvironment<WithCallbackMethod_StartEnvironment<WithCallbackMethod_AuthorizeEnvironment<WithCallbackMethod_AddPublicKey<WithCallbackMethod_RemovePublicKey<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAuthorizeEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemovePublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AuthorizeEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AuthorizeEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RemovePublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemovePublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::shell::v1::GetEnvironmentRequest, ::google::cloud::shell::v1::Environment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::shell::v1::GetEnvironmentRequest, ::google::cloud::shell::v1::Environment>* streamer) {
                       return this->StreamedGetEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::shell::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::shell::v1::GetEnvironmentRequest,::google::cloud::shell::v1::Environment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartEnvironment() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::shell::v1::StartEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::shell::v1::StartEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStartEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::StartEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::shell::v1::StartEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AuthorizeEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AuthorizeEnvironment() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::shell::v1::AuthorizeEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::shell::v1::AuthorizeEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAuthorizeEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AuthorizeEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AuthorizeEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AuthorizeEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAuthorizeEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::shell::v1::AuthorizeEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddPublicKey() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::shell::v1::AddPublicKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::shell::v1::AddPublicKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAddPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::AddPublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::shell::v1::AddPublicKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RemovePublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RemovePublicKey() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::shell::v1::RemovePublicKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::shell::v1::RemovePublicKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRemovePublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RemovePublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RemovePublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::shell::v1::RemovePublicKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRemovePublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::shell::v1::RemovePublicKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_StartEnvironment<WithStreamedUnaryMethod_AuthorizeEnvironment<WithStreamedUnaryMethod_AddPublicKey<WithStreamedUnaryMethod_RemovePublicKey<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_StartEnvironment<WithStreamedUnaryMethod_AuthorizeEnvironment<WithStreamedUnaryMethod_AddPublicKey<WithStreamedUnaryMethod_RemovePublicKey<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace shell
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fshell_2fv1_2fcloudshell_2eproto__INCLUDED
