// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/talent/v4/event_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ftalent_2fv4_2fevent_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ftalent_2fv4_2fevent_5fservice_2eproto__INCLUDED

#include "google/cloud/talent/v4/event_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace talent {
namespace v4 {

// A service handles client event report.
class EventService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.talent.v4.EventService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Report events issued when end user interacts with customer's application
    // that uses Cloud Talent Solution. You may inspect the created events in
    // [self service
    // tools](https://console.cloud.google.com/talent-solution/overview).
    // [Learn
    // more](https://cloud.google.com/talent-solution/docs/management-tools)
    // about self service tools.
    virtual ::grpc::Status CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::google::cloud::talent::v4::ClientEvent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>> AsyncCreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>>(AsyncCreateClientEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>> PrepareAsyncCreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>>(PrepareAsyncCreateClientEventRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Report events issued when end user interacts with customer's application
      // that uses Cloud Talent Solution. You may inspect the created events in
      // [self service
      // tools](https://console.cloud.google.com/talent-solution/overview).
      // [Learn
      // more](https://cloud.google.com/talent-solution/docs/management-tools)
      // about self service tools.
      virtual void CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>* AsyncCreateClientEventRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ClientEvent>* PrepareAsyncCreateClientEventRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::google::cloud::talent::v4::ClientEvent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>> AsyncCreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>>(AsyncCreateClientEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>> PrepareAsyncCreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>>(PrepareAsyncCreateClientEventRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response, std::function<void(::grpc::Status)>) override;
      void CreateClientEvent(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>* AsyncCreateClientEventRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ClientEvent>* PrepareAsyncCreateClientEventRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateClientEvent_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Report events issued when end user interacts with customer's application
    // that uses Cloud Talent Solution. You may inspect the created events in
    // [self service
    // tools](https://console.cloud.google.com/talent-solution/overview).
    // [Learn
    // more](https://cloud.google.com/talent-solution/docs/management-tools)
    // about self service tools.
    virtual ::grpc::Status CreateClientEvent(::grpc::ServerContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClientEvent(::grpc::ServerContext* context, ::google::cloud::talent::v4::CreateClientEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::ClientEvent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateClientEvent<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::CreateClientEventRequest, ::google::cloud::talent::v4::ClientEvent>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::CreateClientEventRequest* request, ::google::cloud::talent::v4::ClientEvent* response) { return this->CreateClientEvent(context, request, response); }));}
    void SetMessageAllocatorFor_CreateClientEvent(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::CreateClientEventRequest, ::google::cloud::talent::v4::ClientEvent>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::CreateClientEventRequest, ::google::cloud::talent::v4::ClientEvent>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClientEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateClientEvent<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClientEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateClientEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClientEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateClientEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateClientEvent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::CreateClientEventRequest, ::google::cloud::talent::v4::ClientEvent>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::CreateClientEventRequest, ::google::cloud::talent::v4::ClientEvent>* streamer) {
                       return this->StreamedCreateClientEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateClientEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateClientEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateClientEventRequest* /*request*/, ::google::cloud::talent::v4::ClientEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateClientEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::CreateClientEventRequest,::google::cloud::talent::v4::ClientEvent>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateClientEvent<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateClientEvent<Service > StreamedService;
};

}  // namespace v4
}  // namespace talent
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2ftalent_2fv4_2fevent_5fservice_2eproto__INCLUDED
