// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/vision/v1/image_annotator.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvision_2fv1_2fimage_5fannotator_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvision_2fv1_2fimage_5fannotator_2eproto__INCLUDED

#include "google/cloud/vision/v1/image_annotator.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace vision {
namespace v1 {

// Service that performs Google Cloud Vision API detection tasks over client
// images, such as face, landmark, logo, label, and text detection. The
// ImageAnnotator service returns detected entities from the images.
class ImageAnnotator final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.vision.v1.ImageAnnotator";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Run image detection and annotation for a batch of images.
    virtual ::grpc::Status BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>> AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>>(AsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>> PrepareAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>>(PrepareAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    // Service that performs image detection and annotation for a batch of files.
    // Now only "application/pdf", "image/tiff" and "image/gif" are supported.
    //
    // This service will extract at most 5 (customers can specify which 5 in
    // AnnotateFileRequest.pages) frames (gif) or pages (pdf or tiff) from each
    // file provided and perform detection and annotation for each image
    // extracted.
    virtual ::grpc::Status BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>> AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>>(AsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>> PrepareAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>>(PrepareAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    // Run asynchronous image detection and annotation for a list of images.
    //
    // Progress and results can be retrieved through the
    // `google.longrunning.Operations` interface.
    // `Operation.metadata` contains `OperationMetadata` (metadata).
    // `Operation.response` contains `AsyncBatchAnnotateImagesResponse` (results).
    //
    // This service will write image annotation outputs to json files in customer
    // GCS bucket, each json file containing BatchAnnotateImagesResponse proto.
    virtual ::grpc::Status AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    // Run asynchronous image detection and annotation for a list of generic
    // files, such as PDF files, which may contain multiple pages and multiple
    // images per page. Progress and results can be retrieved through the
    // `google.longrunning.Operations` interface.
    // `Operation.metadata` contains `OperationMetadata` (metadata).
    // `Operation.response` contains `AsyncBatchAnnotateFilesResponse` (results).
    virtual ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Run image detection and annotation for a batch of images.
      virtual void BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Service that performs image detection and annotation for a batch of files.
      // Now only "application/pdf", "image/tiff" and "image/gif" are supported.
      //
      // This service will extract at most 5 (customers can specify which 5 in
      // AnnotateFileRequest.pages) frames (gif) or pages (pdf or tiff) from each
      // file provided and perform detection and annotation for each image
      // extracted.
      virtual void BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Run asynchronous image detection and annotation for a list of images.
      //
      // Progress and results can be retrieved through the
      // `google.longrunning.Operations` interface.
      // `Operation.metadata` contains `OperationMetadata` (metadata).
      // `Operation.response` contains `AsyncBatchAnnotateImagesResponse` (results).
      //
      // This service will write image annotation outputs to json files in customer
      // GCS bucket, each json file containing BatchAnnotateImagesResponse proto.
      virtual void AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Run asynchronous image detection and annotation for a list of generic
      // files, such as PDF files, which may contain multiple pages and multiple
      // images per page. Progress and results can be retrieved through the
      // `google.longrunning.Operations` interface.
      // `Operation.metadata` contains `OperationMetadata` (metadata).
      // `Operation.response` contains `AsyncBatchAnnotateFilesResponse` (results).
      virtual void AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* AsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* PrepareAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* AsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* PrepareAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>> AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>>(AsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>> PrepareAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>>(PrepareAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    ::grpc::Status BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>> AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>>(AsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>> PrepareAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>>(PrepareAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAsyncBatchAnnotateImagesRaw(context, request, cq));
    }
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAsyncBatchAnnotateFilesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AsyncBatchAnnotateImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AsyncBatchAnnotateFiles(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* AsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* PrepareAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* AsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* PrepareAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAsyncBatchAnnotateImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAsyncBatchAnnotateFilesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_BatchAnnotateImages_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchAnnotateFiles_;
    const ::grpc::internal::RpcMethod rpcmethod_AsyncBatchAnnotateImages_;
    const ::grpc::internal::RpcMethod rpcmethod_AsyncBatchAnnotateFiles_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Run image detection and annotation for a batch of images.
    virtual ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response);
    // Service that performs image detection and annotation for a batch of files.
    // Now only "application/pdf", "image/tiff" and "image/gif" are supported.
    //
    // This service will extract at most 5 (customers can specify which 5 in
    // AnnotateFileRequest.pages) frames (gif) or pages (pdf or tiff) from each
    // file provided and perform detection and annotation for each image
    // extracted.
    virtual ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response);
    // Run asynchronous image detection and annotation for a list of images.
    //
    // Progress and results can be retrieved through the
    // `google.longrunning.Operations` interface.
    // `Operation.metadata` contains `OperationMetadata` (metadata).
    // `Operation.response` contains `AsyncBatchAnnotateImagesResponse` (results).
    //
    // This service will write image annotation outputs to json files in customer
    // GCS bucket, each json file containing BatchAnnotateImagesResponse proto.
    virtual ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response);
    // Run asynchronous image detection and annotation for a list of generic
    // files, such as PDF files, which may contain multiple pages and multiple
    // images per page. Progress and results can be retrieved through the
    // `google.longrunning.Operations` interface.
    // `Operation.metadata` contains `OperationMetadata` (metadata).
    // `Operation.response` contains `AsyncBatchAnnotateFilesResponse` (results).
    virtual ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchAnnotateImages(::grpc::ServerContext* context, ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchAnnotateFiles(::grpc::ServerContext* context, ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsyncBatchAnnotateImages(::grpc::ServerContext* context, ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsyncBatchAnnotateFiles(::grpc::ServerContext* context, ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_BatchAnnotateImages<WithAsyncMethod_BatchAnnotateFiles<WithAsyncMethod_AsyncBatchAnnotateImages<WithAsyncMethod_AsyncBatchAnnotateFiles<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::BatchAnnotateImagesRequest, ::google::cloud::vision::v1::BatchAnnotateImagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* request, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* response) { return this->BatchAnnotateImages(context, request, response); }));}
    void SetMessageAllocatorFor_BatchAnnotateImages(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::BatchAnnotateImagesRequest, ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::BatchAnnotateImagesRequest, ::google::cloud::vision::v1::BatchAnnotateImagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchAnnotateImages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::BatchAnnotateFilesRequest, ::google::cloud::vision::v1::BatchAnnotateFilesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* request, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* response) { return this->BatchAnnotateFiles(context, request, response); }));}
    void SetMessageAllocatorFor_BatchAnnotateFiles(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::BatchAnnotateFilesRequest, ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::BatchAnnotateFilesRequest, ::google::cloud::vision::v1::BatchAnnotateFilesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchAnnotateFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* request, ::google::longrunning::Operation* response) { return this->AsyncBatchAnnotateImages(context, request, response); }));}
    void SetMessageAllocatorFor_AsyncBatchAnnotateImages(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsyncBatchAnnotateImages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* request, ::google::longrunning::Operation* response) { return this->AsyncBatchAnnotateFiles(context, request, response); }));}
    void SetMessageAllocatorFor_AsyncBatchAnnotateFiles(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsyncBatchAnnotateFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_BatchAnnotateImages<WithCallbackMethod_BatchAnnotateFiles<WithCallbackMethod_AsyncBatchAnnotateImages<WithCallbackMethod_AsyncBatchAnnotateFiles<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchAnnotateImages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchAnnotateFiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsyncBatchAnnotateImages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsyncBatchAnnotateFiles(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchAnnotateImages(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchAnnotateImages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchAnnotateFiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchAnnotateFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AsyncBatchAnnotateImages(context, request, response); }));
    }
    ~WithRawCallbackMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsyncBatchAnnotateImages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AsyncBatchAnnotateFiles(context, request, response); }));
    }
    ~WithRawCallbackMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsyncBatchAnnotateFiles(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchAnnotateImages() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::BatchAnnotateImagesRequest, ::google::cloud::vision::v1::BatchAnnotateImagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::BatchAnnotateImagesRequest, ::google::cloud::vision::v1::BatchAnnotateImagesResponse>* streamer) {
                       return this->StreamedBatchAnnotateImages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateImagesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchAnnotateImages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::BatchAnnotateImagesRequest,::google::cloud::vision::v1::BatchAnnotateImagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchAnnotateFiles() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::BatchAnnotateFilesRequest, ::google::cloud::vision::v1::BatchAnnotateFilesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::BatchAnnotateFilesRequest, ::google::cloud::vision::v1::BatchAnnotateFilesResponse>* streamer) {
                       return this->StreamedBatchAnnotateFiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::BatchAnnotateFilesRequest* /*request*/, ::google::cloud::vision::v1::BatchAnnotateFilesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchAnnotateFiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::BatchAnnotateFilesRequest,::google::cloud::vision::v1::BatchAnnotateFilesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AsyncBatchAnnotateImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AsyncBatchAnnotateImages() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAsyncBatchAnnotateImages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AsyncBatchAnnotateImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AsyncBatchAnnotateImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAsyncBatchAnnotateImages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::AsyncBatchAnnotateImagesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AsyncBatchAnnotateFiles : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AsyncBatchAnnotateFiles() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAsyncBatchAnnotateFiles(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AsyncBatchAnnotateFiles() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AsyncBatchAnnotateFiles(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAsyncBatchAnnotateFiles(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::AsyncBatchAnnotateFilesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_BatchAnnotateImages<WithStreamedUnaryMethod_BatchAnnotateFiles<WithStreamedUnaryMethod_AsyncBatchAnnotateImages<WithStreamedUnaryMethod_AsyncBatchAnnotateFiles<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_BatchAnnotateImages<WithStreamedUnaryMethod_BatchAnnotateFiles<WithStreamedUnaryMethod_AsyncBatchAnnotateImages<WithStreamedUnaryMethod_AsyncBatchAnnotateFiles<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace vision
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fvision_2fv1_2fimage_5fannotator_2eproto__INCLUDED
