// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/vpcaccess/v1/vpc_access.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvpcaccess_2fv1_2fvpc_5faccess_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvpcaccess_2fv1_2fvpc_5faccess_2eproto__INCLUDED

#include "google/cloud/vpcaccess/v1/vpc_access.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace vpcaccess {
namespace v1 {

// Serverless VPC Access API allows users to create and manage connectors for
// App Engine, Cloud Functions and Cloud Run to have internal connections to
// Virtual Private Cloud networks.
class VpcAccessService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.vpcaccess.v1.VpcAccessService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a Serverless VPC Access connector, returns an operation.
    virtual ::grpc::Status CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateConnectorRaw(context, request, cq));
    }
    // Gets a Serverless VPC Access connector. Returns NOT_FOUND if the resource
    // does not exist.
    virtual ::grpc::Status GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::google::cloud::vpcaccess::v1::Connector* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>> AsyncGetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>>(AsyncGetConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>> PrepareAsyncGetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>>(PrepareAsyncGetConnectorRaw(context, request, cq));
    }
    // Lists Serverless VPC Access connectors.
    virtual ::grpc::Status ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>> AsyncListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>>(AsyncListConnectorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>> PrepareAsyncListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>>(PrepareAsyncListConnectorsRaw(context, request, cq));
    }
    // Deletes a Serverless VPC Access connector. Returns NOT_FOUND if the
    // resource does not exist.
    virtual ::grpc::Status DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteConnectorRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a Serverless VPC Access connector, returns an operation.
      virtual void CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a Serverless VPC Access connector. Returns NOT_FOUND if the resource
      // does not exist.
      virtual void GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Serverless VPC Access connectors.
      virtual void ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Serverless VPC Access connector. Returns NOT_FOUND if the
      // resource does not exist.
      virtual void DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>* AsyncGetConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::Connector>* PrepareAsyncGetConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* AsyncListConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* PrepareAsyncListConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateConnectorRaw(context, request, cq));
    }
    ::grpc::Status GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::google::cloud::vpcaccess::v1::Connector* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>> AsyncGetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>>(AsyncGetConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>> PrepareAsyncGetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>>(PrepareAsyncGetConnectorRaw(context, request, cq));
    }
    ::grpc::Status ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>> AsyncListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>>(AsyncListConnectorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>> PrepareAsyncListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>>(PrepareAsyncListConnectorsRaw(context, request, cq));
    }
    ::grpc::Status DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteConnectorRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response, std::function<void(::grpc::Status)>) override;
      void GetConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConnectors(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteConnector(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>* AsyncGetConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::Connector>* PrepareAsyncGetConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* AsyncListConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* PrepareAsyncListConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_ListConnectors_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteConnector_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a Serverless VPC Access connector, returns an operation.
    virtual ::grpc::Status CreateConnector(::grpc::ServerContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response);
    // Gets a Serverless VPC Access connector. Returns NOT_FOUND if the resource
    // does not exist.
    virtual ::grpc::Status GetConnector(::grpc::ServerContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response);
    // Lists Serverless VPC Access connectors.
    virtual ::grpc::Status ListConnectors(::grpc::ServerContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response);
    // Deletes a Serverless VPC Access connector. Returns NOT_FOUND if the
    // resource does not exist.
    virtual ::grpc::Status DeleteConnector(::grpc::ServerContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateConnector() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnector(::grpc::ServerContext* context, ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConnector() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnector(::grpc::ServerContext* context, ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vpcaccess::v1::Connector>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConnectors() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnectors(::grpc::ServerContext* context, ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnector(::grpc::ServerContext* context, ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateConnector<WithAsyncMethod_GetConnector<WithAsyncMethod_ListConnectors<WithAsyncMethod_DeleteConnector<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateConnector() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::CreateConnectorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* request, ::google::longrunning::Operation* response) { return this->CreateConnector(context, request, response); }));}
    void SetMessageAllocatorFor_CreateConnector(
        ::grpc::MessageAllocator< ::google::cloud::vpcaccess::v1::CreateConnectorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::CreateConnectorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConnector() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::GetConnectorRequest, ::google::cloud::vpcaccess::v1::Connector>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* request, ::google::cloud::vpcaccess::v1::Connector* response) { return this->GetConnector(context, request, response); }));}
    void SetMessageAllocatorFor_GetConnector(
        ::grpc::MessageAllocator< ::google::cloud::vpcaccess::v1::GetConnectorRequest, ::google::cloud::vpcaccess::v1::Connector>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::GetConnectorRequest, ::google::cloud::vpcaccess::v1::Connector>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConnectors() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::ListConnectorsRequest, ::google::cloud::vpcaccess::v1::ListConnectorsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* request, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* response) { return this->ListConnectors(context, request, response); }));}
    void SetMessageAllocatorFor_ListConnectors(
        ::grpc::MessageAllocator< ::google::cloud::vpcaccess::v1::ListConnectorsRequest, ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::ListConnectorsRequest, ::google::cloud::vpcaccess::v1::ListConnectorsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnectors(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::DeleteConnectorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* request, ::google::longrunning::Operation* response) { return this->DeleteConnector(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteConnector(
        ::grpc::MessageAllocator< ::google::cloud::vpcaccess::v1::DeleteConnectorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vpcaccess::v1::DeleteConnectorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateConnector<WithCallbackMethod_GetConnector<WithCallbackMethod_ListConnectors<WithCallbackMethod_DeleteConnector<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateConnector() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConnector() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConnectors() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateConnector() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConnector() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConnectors() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnectors(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateConnector() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConnector() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConnectors() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConnectors(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnectors(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateConnector() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vpcaccess::v1::CreateConnectorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vpcaccess::v1::CreateConnectorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::CreateConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vpcaccess::v1::CreateConnectorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConnector() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vpcaccess::v1::GetConnectorRequest, ::google::cloud::vpcaccess::v1::Connector>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vpcaccess::v1::GetConnectorRequest, ::google::cloud::vpcaccess::v1::Connector>* streamer) {
                       return this->StreamedGetConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::GetConnectorRequest* /*request*/, ::google::cloud::vpcaccess::v1::Connector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vpcaccess::v1::GetConnectorRequest,::google::cloud::vpcaccess::v1::Connector>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConnectors() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vpcaccess::v1::ListConnectorsRequest, ::google::cloud::vpcaccess::v1::ListConnectorsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vpcaccess::v1::ListConnectorsRequest, ::google::cloud::vpcaccess::v1::ListConnectorsResponse>* streamer) {
                       return this->StreamedListConnectors(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::ListConnectorsRequest* /*request*/, ::google::cloud::vpcaccess::v1::ListConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConnectors(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vpcaccess::v1::ListConnectorsRequest,::google::cloud::vpcaccess::v1::ListConnectorsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteConnector() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vpcaccess::v1::DeleteConnectorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vpcaccess::v1::DeleteConnectorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::vpcaccess::v1::DeleteConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vpcaccess::v1::DeleteConnectorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateConnector<WithStreamedUnaryMethod_GetConnector<WithStreamedUnaryMethod_ListConnectors<WithStreamedUnaryMethod_DeleteConnector<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateConnector<WithStreamedUnaryMethod_GetConnector<WithStreamedUnaryMethod_ListConnectors<WithStreamedUnaryMethod_DeleteConnector<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace vpcaccess
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fvpcaccess_2fv1_2fvpc_5faccess_2eproto__INCLUDED
