// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/datacatalog/lineage/v1/lineage.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdatacatalog_2flineage_2fv1_2flineage_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdatacatalog_2flineage_2fv1_2flineage_2eproto__INCLUDED

#include "google/cloud/datacatalog/lineage/v1/lineage.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace datacatalog {
namespace lineage {
namespace v1 {

// Lineage is used to track data flows between assets over time. You can
// create [LineageEvents][google.cloud.datacatalog.lineage.v1.LineageEvent]
// to record lineage between multiple sources and a single target, for
// example, when table data is based on data from multiple tables.
class Lineage final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.datacatalog.lineage.v1.Lineage";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates new lineage events together with their parents: process and run.
    // Updates the process and run if they already exist.
    // Mapped from Open Lineage specification:
    // https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json.
    virtual ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>> AsyncProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>>(AsyncProcessOpenLineageRunEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>> PrepareAsyncProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>>(PrepareAsyncProcessOpenLineageRunEventRaw(context, request, cq));
    }
    // Creates a new process.
    virtual ::grpc::Status CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncCreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncCreateProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncCreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncCreateProcessRaw(context, request, cq));
    }
    // Updates a process.
    virtual ::grpc::Status UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncUpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncUpdateProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncUpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncUpdateProcessRaw(context, request, cq));
    }
    // Gets the details of the specified process.
    virtual ::grpc::Status GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncGetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncGetProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncGetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncGetProcessRaw(context, request, cq));
    }
    // List processes in the given project and location. List order is descending
    // by insertion time.
    virtual ::grpc::Status ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>> AsyncListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>>(AsyncListProcessesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>> PrepareAsyncListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>>(PrepareAsyncListProcessesRaw(context, request, cq));
    }
    // Deletes the process with the specified name.
    virtual ::grpc::Status DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessRaw(context, request, cq));
    }
    // Creates a new run.
    virtual ::grpc::Status CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncCreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncCreateRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncCreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncCreateRunRaw(context, request, cq));
    }
    // Updates a run.
    virtual ::grpc::Status UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncUpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncUpdateRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncUpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncUpdateRunRaw(context, request, cq));
    }
    // Gets the details of the specified run.
    virtual ::grpc::Status GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncGetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncGetRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncGetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncGetRunRaw(context, request, cq));
    }
    // Lists runs in the given project and location. List order is descending by
    // `start_time`.
    virtual ::grpc::Status ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>> AsyncListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>>(AsyncListRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>> PrepareAsyncListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>>(PrepareAsyncListRunsRaw(context, request, cq));
    }
    // Deletes the run with the specified name.
    virtual ::grpc::Status DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteRunRaw(context, request, cq));
    }
    // Creates a new lineage event.
    virtual ::grpc::Status CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> AsyncCreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(AsyncCreateLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> PrepareAsyncCreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(PrepareAsyncCreateLineageEventRaw(context, request, cq));
    }
    // Gets details of a specified lineage event.
    virtual ::grpc::Status GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> AsyncGetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(AsyncGetLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> PrepareAsyncGetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(PrepareAsyncGetLineageEventRaw(context, request, cq));
    }
    // Lists lineage events in the given project and location. The list order is
    // not defined.
    virtual ::grpc::Status ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>> AsyncListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>>(AsyncListLineageEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>> PrepareAsyncListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>>(PrepareAsyncListLineageEventsRaw(context, request, cq));
    }
    // Deletes the lineage event with the specified name.
    virtual ::grpc::Status DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteLineageEventRaw(context, request, cq));
    }
    // Retrieve a list of links connected to a specific asset.
    // Links represent the data flow between **source** (upstream)
    // and **target** (downstream) assets in transformation pipelines.
    // Links are stored in the same project as the Lineage Events that create
    // them.
    //
    // You can retrieve links in every project where you have the
    // `datalineage.events.get` permission. The project provided in the URL
    // is used for Billing and Quota.
    virtual ::grpc::Status SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>> AsyncSearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>>(AsyncSearchLinksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>> PrepareAsyncSearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>>(PrepareAsyncSearchLinksRaw(context, request, cq));
    }
    // Retrieve information about LineageProcesses associated with specific
    // links. LineageProcesses are transformation pipelines that result in data
    // flowing from **source** to **target** assets. Links between assets
    // represent this operation.
    //
    // If you have specific link names, you can use this method to
    // verify which LineageProcesses contribute to creating those links.
    // See the
    // [SearchLinks][google.cloud.datacatalog.lineage.v1.Lineage.SearchLinks]
    // method for more information on how to retrieve link name.
    //
    // You can retrieve the LineageProcess information in every project where you
    // have the `datalineage.events.get` permission. The project provided in the
    // URL is used for Billing and Quota.
    virtual ::grpc::Status BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>> AsyncBatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>>(AsyncBatchSearchLinkProcessesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>> PrepareAsyncBatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>>(PrepareAsyncBatchSearchLinkProcessesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates new lineage events together with their parents: process and run.
      // Updates the process and run if they already exist.
      // Mapped from Open Lineage specification:
      // https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json.
      virtual void ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new process.
      virtual void CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a process.
      virtual void UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of the specified process.
      virtual void GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List processes in the given project and location. List order is descending
      // by insertion time.
      virtual void ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the process with the specified name.
      virtual void DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new run.
      virtual void CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a run.
      virtual void UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of the specified run.
      virtual void GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists runs in the given project and location. List order is descending by
      // `start_time`.
      virtual void ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the run with the specified name.
      virtual void DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new lineage event.
      virtual void CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a specified lineage event.
      virtual void GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists lineage events in the given project and location. The list order is
      // not defined.
      virtual void ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the lineage event with the specified name.
      virtual void DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve a list of links connected to a specific asset.
      // Links represent the data flow between **source** (upstream)
      // and **target** (downstream) assets in transformation pipelines.
      // Links are stored in the same project as the Lineage Events that create
      // them.
      //
      // You can retrieve links in every project where you have the
      // `datalineage.events.get` permission. The project provided in the URL
      // is used for Billing and Quota.
      virtual void SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve information about LineageProcesses associated with specific
      // links. LineageProcesses are transformation pipelines that result in data
      // flowing from **source** to **target** assets. Links between assets
      // represent this operation.
      //
      // If you have specific link names, you can use this method to
      // verify which LineageProcesses contribute to creating those links.
      // See the
      // [SearchLinks][google.cloud.datacatalog.lineage.v1.Lineage.SearchLinks]
      // method for more information on how to retrieve link name.
      //
      // You can retrieve the LineageProcess information in every project where you
      // have the `datalineage.events.get` permission. The project provided in the
      // URL is used for Billing and Quota.
      virtual void BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* AsyncProcessOpenLineageRunEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* PrepareAsyncProcessOpenLineageRunEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncCreateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncCreateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncUpdateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncUpdateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncGetProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncGetProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* AsyncListProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* PrepareAsyncListProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncCreateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncCreateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncUpdateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncUpdateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncGetRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncGetRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* AsyncListRunsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* PrepareAsyncListRunsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* AsyncCreateLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* PrepareAsyncCreateLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* AsyncGetLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* PrepareAsyncGetLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* AsyncListLineageEventsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* PrepareAsyncListLineageEventsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* AsyncSearchLinksRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* PrepareAsyncSearchLinksRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* AsyncBatchSearchLinkProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* PrepareAsyncBatchSearchLinkProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>> AsyncProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>>(AsyncProcessOpenLineageRunEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>> PrepareAsyncProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>>(PrepareAsyncProcessOpenLineageRunEventRaw(context, request, cq));
    }
    ::grpc::Status CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncCreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncCreateProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncCreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncCreateProcessRaw(context, request, cq));
    }
    ::grpc::Status UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncUpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncUpdateProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncUpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncUpdateProcessRaw(context, request, cq));
    }
    ::grpc::Status GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::google::cloud::datacatalog::lineage::v1::Process* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> AsyncGetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(AsyncGetProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>> PrepareAsyncGetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>>(PrepareAsyncGetProcessRaw(context, request, cq));
    }
    ::grpc::Status ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>> AsyncListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>>(AsyncListProcessesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>> PrepareAsyncListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>>(PrepareAsyncListProcessesRaw(context, request, cq));
    }
    ::grpc::Status DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteProcessRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessRaw(context, request, cq));
    }
    ::grpc::Status CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncCreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncCreateRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncCreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncCreateRunRaw(context, request, cq));
    }
    ::grpc::Status UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncUpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncUpdateRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncUpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncUpdateRunRaw(context, request, cq));
    }
    ::grpc::Status GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::google::cloud::datacatalog::lineage::v1::Run* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> AsyncGetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(AsyncGetRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>> PrepareAsyncGetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>>(PrepareAsyncGetRunRaw(context, request, cq));
    }
    ::grpc::Status ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>> AsyncListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>>(AsyncListRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>> PrepareAsyncListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>>(PrepareAsyncListRunsRaw(context, request, cq));
    }
    ::grpc::Status DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteRunRaw(context, request, cq));
    }
    ::grpc::Status CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> AsyncCreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(AsyncCreateLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> PrepareAsyncCreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(PrepareAsyncCreateLineageEventRaw(context, request, cq));
    }
    ::grpc::Status GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> AsyncGetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(AsyncGetLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>> PrepareAsyncGetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>>(PrepareAsyncGetLineageEventRaw(context, request, cq));
    }
    ::grpc::Status ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>> AsyncListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>>(AsyncListLineageEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>> PrepareAsyncListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>>(PrepareAsyncListLineageEventsRaw(context, request, cq));
    }
    ::grpc::Status DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteLineageEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteLineageEventRaw(context, request, cq));
    }
    ::grpc::Status SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>> AsyncSearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>>(AsyncSearchLinksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>> PrepareAsyncSearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>>(PrepareAsyncSearchLinksRaw(context, request, cq));
    }
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>> AsyncBatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>>(AsyncBatchSearchLinkProcessesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>> PrepareAsyncBatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>>(PrepareAsyncBatchSearchLinkProcessesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response, std::function<void(::grpc::Status)>) override;
      void ProcessOpenLineageRunEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) override;
      void CreateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) override;
      void UpdateProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, std::function<void(::grpc::Status)>) override;
      void GetProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteProcess(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) override;
      void CreateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) override;
      void UpdateRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, std::function<void(::grpc::Status)>) override;
      void GetRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRuns(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteRun(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, std::function<void(::grpc::Status)>) override;
      void CreateLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, std::function<void(::grpc::Status)>) override;
      void GetLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLineageEvents(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteLineageEvent(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchLinks(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchSearchLinkProcesses(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* AsyncProcessOpenLineageRunEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* PrepareAsyncProcessOpenLineageRunEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncCreateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncCreateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncUpdateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncUpdateProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* AsyncGetProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Process>* PrepareAsyncGetProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* AsyncListProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* PrepareAsyncListProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncCreateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncCreateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncUpdateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncUpdateRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* AsyncGetRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::Run>* PrepareAsyncGetRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* AsyncListRunsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* PrepareAsyncListRunsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteRunRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* AsyncCreateLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* PrepareAsyncCreateLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* AsyncGetLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* PrepareAsyncGetLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* AsyncListLineageEventsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* PrepareAsyncListLineageEventsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteLineageEventRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* AsyncSearchLinksRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* PrepareAsyncSearchLinksRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* AsyncBatchSearchLinkProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* PrepareAsyncBatchSearchLinkProcessesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ProcessOpenLineageRunEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProcess_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProcess_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProcess_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProcesses_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProcess_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRun_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRun_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRun_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRuns_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRun_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLineageEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLineageEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLineageEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteLineageEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchLinks_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchSearchLinkProcesses_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates new lineage events together with their parents: process and run.
    // Updates the process and run if they already exist.
    // Mapped from Open Lineage specification:
    // https://github.com/OpenLineage/OpenLineage/blob/main/spec/OpenLineage.json.
    virtual ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response);
    // Creates a new process.
    virtual ::grpc::Status CreateProcess(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response);
    // Updates a process.
    virtual ::grpc::Status UpdateProcess(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response);
    // Gets the details of the specified process.
    virtual ::grpc::Status GetProcess(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response);
    // List processes in the given project and location. List order is descending
    // by insertion time.
    virtual ::grpc::Status ListProcesses(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response);
    // Deletes the process with the specified name.
    virtual ::grpc::Status DeleteProcess(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response);
    // Creates a new run.
    virtual ::grpc::Status CreateRun(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response);
    // Updates a run.
    virtual ::grpc::Status UpdateRun(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response);
    // Gets the details of the specified run.
    virtual ::grpc::Status GetRun(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response);
    // Lists runs in the given project and location. List order is descending by
    // `start_time`.
    virtual ::grpc::Status ListRuns(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response);
    // Deletes the run with the specified name.
    virtual ::grpc::Status DeleteRun(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response);
    // Creates a new lineage event.
    virtual ::grpc::Status CreateLineageEvent(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response);
    // Gets details of a specified lineage event.
    virtual ::grpc::Status GetLineageEvent(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response);
    // Lists lineage events in the given project and location. The list order is
    // not defined.
    virtual ::grpc::Status ListLineageEvents(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response);
    // Deletes the lineage event with the specified name.
    virtual ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response);
    // Retrieve a list of links connected to a specific asset.
    // Links represent the data flow between **source** (upstream)
    // and **target** (downstream) assets in transformation pipelines.
    // Links are stored in the same project as the Lineage Events that create
    // them.
    //
    // You can retrieve links in every project where you have the
    // `datalineage.events.get` permission. The project provided in the URL
    // is used for Billing and Quota.
    virtual ::grpc::Status SearchLinks(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response);
    // Retrieve information about LineageProcesses associated with specific
    // links. LineageProcesses are transformation pipelines that result in data
    // flowing from **source** to **target** assets. Links between assets
    // represent this operation.
    //
    // If you have specific link names, you can use this method to
    // verify which LineageProcesses contribute to creating those links.
    // See the
    // [SearchLinks][google.cloud.datacatalog.lineage.v1.Lineage.SearchLinks]
    // method for more information on how to retrieve link name.
    //
    // You can retrieve the LineageProcess information in every project where you
    // have the `datalineage.events.get` permission. The project provided in the
    // URL is used for Billing and Quota.
    virtual ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProcessOpenLineageRunEvent(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProcess() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProcess(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Process>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProcess(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Process>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProcess() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcess(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Process>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProcesses() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcesses(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcess(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRun() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRun(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Run>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRun() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRun(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Run>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRun() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRun(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::Run>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRuns() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuns(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRun() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRun(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLineageEvent(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLineageEvent(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::LineageEvent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLineageEvents(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLineageEvent(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchLinks() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchLinks(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchSearchLinkProcesses(::grpc::ServerContext* context, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ProcessOpenLineageRunEvent<WithAsyncMethod_CreateProcess<WithAsyncMethod_UpdateProcess<WithAsyncMethod_GetProcess<WithAsyncMethod_ListProcesses<WithAsyncMethod_DeleteProcess<WithAsyncMethod_CreateRun<WithAsyncMethod_UpdateRun<WithAsyncMethod_GetRun<WithAsyncMethod_ListRuns<WithAsyncMethod_DeleteRun<WithAsyncMethod_CreateLineageEvent<WithAsyncMethod_GetLineageEvent<WithAsyncMethod_ListLineageEvents<WithAsyncMethod_DeleteLineageEvent<WithAsyncMethod_SearchLinks<WithAsyncMethod_BatchSearchLinkProcesses<Service > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* request, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* response) { return this->ProcessOpenLineageRunEvent(context, request, response); }));}
    void SetMessageAllocatorFor_ProcessOpenLineageRunEvent(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProcessOpenLineageRunEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProcess() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response) { return this->CreateProcess(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProcess(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response) { return this->UpdateProcess(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProcess(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProcess() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* request, ::google::cloud::datacatalog::lineage::v1::Process* response) { return this->GetProcess(context, request, response); }));}
    void SetMessageAllocatorFor_GetProcess(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::GetProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProcesses() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* response) { return this->ListProcesses(context, request, response); }));}
    void SetMessageAllocatorFor_ListProcesses(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcesses(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* request, ::google::longrunning::Operation* response) { return this->DeleteProcess(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProcess(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRun() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response) { return this->CreateRun(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRun(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::CreateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRun() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response) { return this->UpdateRun(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRun(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRun() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* request, ::google::cloud::datacatalog::lineage::v1::Run* response) { return this->GetRun(context, request, response); }));}
    void SetMessageAllocatorFor_GetRun(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::GetRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRuns() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListRunsRequest, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* response) { return this->ListRuns(context, request, response); }));}
    void SetMessageAllocatorFor_ListRuns(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::ListRunsRequest, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListRunsRequest, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRun() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* request, ::google::longrunning::Operation* response) { return this->DeleteRun(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRun(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) { return this->CreateLineageEvent(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLineageEvent(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* request, ::google::cloud::datacatalog::lineage::v1::LineageEvent* response) { return this->GetLineageEvent(context, request, response); }));}
    void SetMessageAllocatorFor_GetLineageEvent(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* request, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* response) { return this->ListLineageEvents(context, request, response); }));}
    void SetMessageAllocatorFor_ListLineageEvents(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLineageEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* request, ::google::protobuf::Empty* response) { return this->DeleteLineageEvent(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteLineageEvent(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchLinks() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* request, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* response) { return this->SearchLinks(context, request, response); }));}
    void SetMessageAllocatorFor_SearchLinks(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchLinks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* request, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* response) { return this->BatchSearchLinkProcesses(context, request, response); }));}
    void SetMessageAllocatorFor_BatchSearchLinkProcesses(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchSearchLinkProcesses(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ProcessOpenLineageRunEvent<WithCallbackMethod_CreateProcess<WithCallbackMethod_UpdateProcess<WithCallbackMethod_GetProcess<WithCallbackMethod_ListProcesses<WithCallbackMethod_DeleteProcess<WithCallbackMethod_CreateRun<WithCallbackMethod_UpdateRun<WithCallbackMethod_GetRun<WithCallbackMethod_ListRuns<WithCallbackMethod_DeleteRun<WithCallbackMethod_CreateLineageEvent<WithCallbackMethod_GetLineageEvent<WithCallbackMethod_ListLineageEvents<WithCallbackMethod_DeleteLineageEvent<WithCallbackMethod_SearchLinks<WithCallbackMethod_BatchSearchLinkProcesses<Service > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProcess() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProcess() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProcesses() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRun() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRun() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRun() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRuns() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRun() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchLinks() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProcessOpenLineageRunEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProcess() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProcess(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProcess(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProcess() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcess(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProcesses() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcesses(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcess(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRun() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRun() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRun() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRuns() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuns(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRun() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLineageEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLineageEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLineageEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLineageEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchLinks() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchLinks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchSearchLinkProcesses(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ProcessOpenLineageRunEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProcessOpenLineageRunEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProcess() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProcess(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProcess(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProcess() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProcess(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProcesses() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProcesses(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcesses(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProcess(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcess(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRun() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRun() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRun() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRuns() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRuns(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRun() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLineageEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLineageEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLineageEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLineageEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteLineageEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLineageEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchLinks() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchLinks(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchLinks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchSearchLinkProcesses(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchSearchLinkProcesses(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ProcessOpenLineageRunEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ProcessOpenLineageRunEvent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* streamer) {
                       return this->StreamedProcessOpenLineageRunEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ProcessOpenLineageRunEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ProcessOpenLineageRunEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedProcessOpenLineageRunEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventRequest,::google::cloud::datacatalog::lineage::v1::ProcessOpenLineageRunEventResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProcess() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* streamer) {
                       return this->StreamedCreateProcess(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProcess(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::CreateProcessRequest,::google::cloud::datacatalog::lineage::v1::Process>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProcess() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* streamer) {
                       return this->StreamedUpdateProcess(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProcess(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::UpdateProcessRequest,::google::cloud::datacatalog::lineage::v1::Process>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProcess() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::GetProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::GetProcessRequest, ::google::cloud::datacatalog::lineage::v1::Process>* streamer) {
                       return this->StreamedGetProcess(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetProcessRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Process* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProcess(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::GetProcessRequest,::google::cloud::datacatalog::lineage::v1::Process>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProcesses() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* streamer) {
                       return this->StreamedListProcesses(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProcesses(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::ListProcessesRequest,::google::cloud::datacatalog::lineage::v1::ListProcessesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProcess : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProcess() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteProcess(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProcess() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProcess(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProcess(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::DeleteProcessRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRun() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::CreateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::CreateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* streamer) {
                       return this->StreamedCreateRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::CreateRunRequest,::google::cloud::datacatalog::lineage::v1::Run>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRun() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* streamer) {
                       return this->StreamedUpdateRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::UpdateRunRequest,::google::cloud::datacatalog::lineage::v1::Run>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRun() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::GetRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::GetRunRequest, ::google::cloud::datacatalog::lineage::v1::Run>* streamer) {
                       return this->StreamedGetRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetRunRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::Run* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::GetRunRequest,::google::cloud::datacatalog::lineage::v1::Run>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRuns() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::ListRunsRequest, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::ListRunsRequest, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* streamer) {
                       return this->StreamedListRuns(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListRunsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRuns(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::ListRunsRequest,::google::cloud::datacatalog::lineage::v1::ListRunsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRun() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRun(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::DeleteRunRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLineageEvent() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>* streamer) {
                       return this->StreamedCreateLineageEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLineageEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::CreateLineageEventRequest,::google::cloud::datacatalog::lineage::v1::LineageEvent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLineageEvent() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest, ::google::cloud::datacatalog::lineage::v1::LineageEvent>* streamer) {
                       return this->StreamedGetLineageEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::LineageEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLineageEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::GetLineageEventRequest,::google::cloud::datacatalog::lineage::v1::LineageEvent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLineageEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLineageEvents() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* streamer) {
                       return this->StreamedListLineageEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLineageEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLineageEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLineageEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::ListLineageEventsRequest,::google::cloud::datacatalog::lineage::v1::ListLineageEventsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteLineageEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteLineageEvent() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteLineageEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteLineageEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteLineageEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteLineageEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::DeleteLineageEventRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchLinks() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* streamer) {
                       return this->StreamedSearchLinks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::SearchLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchLinks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::SearchLinksRequest,::google::cloud::datacatalog::lineage::v1::SearchLinksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchSearchLinkProcesses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchSearchLinkProcesses() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* streamer) {
                       return this->StreamedBatchSearchLinkProcesses(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchSearchLinkProcesses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchSearchLinkProcesses(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest* /*request*/, ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchSearchLinkProcesses(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesRequest,::google::cloud::datacatalog::lineage::v1::BatchSearchLinkProcessesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ProcessOpenLineageRunEvent<WithStreamedUnaryMethod_CreateProcess<WithStreamedUnaryMethod_UpdateProcess<WithStreamedUnaryMethod_GetProcess<WithStreamedUnaryMethod_ListProcesses<WithStreamedUnaryMethod_DeleteProcess<WithStreamedUnaryMethod_CreateRun<WithStreamedUnaryMethod_UpdateRun<WithStreamedUnaryMethod_GetRun<WithStreamedUnaryMethod_ListRuns<WithStreamedUnaryMethod_DeleteRun<WithStreamedUnaryMethod_CreateLineageEvent<WithStreamedUnaryMethod_GetLineageEvent<WithStreamedUnaryMethod_ListLineageEvents<WithStreamedUnaryMethod_DeleteLineageEvent<WithStreamedUnaryMethod_SearchLinks<WithStreamedUnaryMethod_BatchSearchLinkProcesses<Service > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ProcessOpenLineageRunEvent<WithStreamedUnaryMethod_CreateProcess<WithStreamedUnaryMethod_UpdateProcess<WithStreamedUnaryMethod_GetProcess<WithStreamedUnaryMethod_ListProcesses<WithStreamedUnaryMethod_DeleteProcess<WithStreamedUnaryMethod_CreateRun<WithStreamedUnaryMethod_UpdateRun<WithStreamedUnaryMethod_GetRun<WithStreamedUnaryMethod_ListRuns<WithStreamedUnaryMethod_DeleteRun<WithStreamedUnaryMethod_CreateLineageEvent<WithStreamedUnaryMethod_GetLineageEvent<WithStreamedUnaryMethod_ListLineageEvents<WithStreamedUnaryMethod_DeleteLineageEvent<WithStreamedUnaryMethod_SearchLinks<WithStreamedUnaryMethod_BatchSearchLinkProcesses<Service > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace lineage
}  // namespace datacatalog
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdatacatalog_2flineage_2fv1_2flineage_2eproto__INCLUDED
