// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/sql/v1/cloud_sql_instances.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fsql_2fv1_2fcloud_5fsql_5finstances_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fsql_2fv1_2fcloud_5fsql_5finstances_2eproto__INCLUDED

#include "google/cloud/sql/v1/cloud_sql_instances.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace sql {
namespace v1 {

// Service to manage Cloud SQL instances.
class SqlInstancesService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.sql.v1.SqlInstancesService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Adds a new trusted Certificate Authority (CA) version for the specified
    // instance. Required to prepare for a certificate rotation. If a CA version
    // was previously added but never used in a certificate rotation, this
    // operation replaces that version. There cannot be more than one CA version
    // waiting to be rotated in. For instances that have enabled Certificate
    // Authority Service (CAS) based server CA, please use AddServerCertificate to
    // add a new server certificate.
    virtual ::grpc::Status AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncAddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncAddServerCaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncAddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncAddServerCaRaw(context, request, cq));
    }
    // Creates a Cloud SQL instance as a clone of the source instance. Using this
    // operation might cause your instance to restart.
    virtual ::grpc::Status Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncClone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncCloneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncClone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncCloneRaw(context, request, cq));
    }
    // Deletes a Cloud SQL instance.
    virtual ::grpc::Status Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncDelete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncDeleteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncDelete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDeleteRaw(context, request, cq));
    }
    // Demotes the stand-alone instance to be a Cloud SQL read replica for an
    // external database server.
    virtual ::grpc::Status DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncDemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncDemoteMasterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncDemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDemoteMasterRaw(context, request, cq));
    }
    // Demotes an existing standalone instance to be a Cloud SQL read replica
    // for an external database server.
    virtual ::grpc::Status Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncDemote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncDemoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncDemote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDemoteRaw(context, request, cq));
    }
    // Exports data from a Cloud SQL instance to a Cloud Storage bucket as a SQL
    // dump or CSV file.
    virtual ::grpc::Status Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncExport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncExportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncExport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncExportRaw(context, request, cq));
    }
    // Initiates a manual failover of a high availability (HA) primary instance
    // to a standby instance, which becomes the primary instance. Users are
    // then rerouted to the new primary. For more information, see the
    // [Overview of high
    // availability](https://cloud.google.com/sql/docs/mysql/high-availability)
    // page in the Cloud SQL documentation.
    // If using Legacy HA (MySQL only), this causes the instance to failover to
    // its failover replica instance.
    virtual ::grpc::Status Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncFailover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncFailoverRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncFailover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncFailoverRaw(context, request, cq));
    }
    // Reencrypt CMEK instance with latest key version.
    virtual ::grpc::Status Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncReencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncReencryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncReencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncReencryptRaw(context, request, cq));
    }
    // Retrieves a resource containing information about a Cloud SQL instance.
    virtual ::grpc::Status Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::google::cloud::sql::v1::DatabaseInstance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>> AsyncGet(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>>(AsyncGetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>> PrepareAsyncGet(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>>(PrepareAsyncGetRaw(context, request, cq));
    }
    // Imports data into a Cloud SQL instance from a SQL dump  or CSV file in
    // Cloud Storage.
    virtual ::grpc::Status Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncImport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncImport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncImportRaw(context, request, cq));
    }
    // Creates a new Cloud SQL instance.
    virtual ::grpc::Status Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncInsert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncInsertRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncInsert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncInsertRaw(context, request, cq));
    }
    // Lists instances under a given project.
    virtual ::grpc::Status List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::google::cloud::sql::v1::InstancesListResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>> AsyncList(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>>(AsyncListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>> PrepareAsyncList(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>>(PrepareAsyncListRaw(context, request, cq));
    }
    // Lists all of the trusted Certificate Authorities (CAs) for the specified
    // instance. There can be up to three CAs listed: the CA that was used to sign
    // the certificate that is currently in use, a CA that has been added but not
    // yet used to sign a certificate, and a CA used to sign a certificate that
    // has previously rotated out.
    virtual ::grpc::Status ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>> AsyncListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>>(AsyncListServerCasRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>> PrepareAsyncListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>>(PrepareAsyncListServerCasRaw(context, request, cq));
    }
    // Partially updates settings of a Cloud SQL instance by merging the request
    // with the current configuration. This method supports patch semantics.
    virtual ::grpc::Status Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncPatch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncPatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncPatch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPatchRaw(context, request, cq));
    }
    // Promotes the read replica instance to be an independent Cloud SQL
    // primary instance.
    // Using this operation might cause your instance to restart.
    virtual ::grpc::Status PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncPromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncPromoteReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncPromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPromoteReplicaRaw(context, request, cq));
    }
    // Switches over from the primary instance to the designated DR replica
    // instance.
    virtual ::grpc::Status Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncSwitchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncSwitchoverRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncSwitchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncSwitchoverRaw(context, request, cq));
    }
    // Deletes all client certificates and generates a new server SSL certificate
    // for the instance.
    virtual ::grpc::Status ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncResetSslConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncResetSslConfigRaw(context, request, cq));
    }
    // Restarts a Cloud SQL instance.
    virtual ::grpc::Status Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncRestart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncRestartRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncRestart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRestartRaw(context, request, cq));
    }
    // Restores a backup of a Cloud SQL instance. Using this operation might cause
    // your instance to restart.
    virtual ::grpc::Status RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncRestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncRestoreBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncRestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRestoreBackupRaw(context, request, cq));
    }
    // Rotates the server certificate to one signed by the Certificate Authority
    // (CA) version previously added with the addServerCA method. For instances
    // that have enabled Certificate Authority Service (CAS) based server CA,
    // please use RotateServerCertificate to rotate the server certificate.
    virtual ::grpc::Status RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncRotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncRotateServerCaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncRotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRotateServerCaRaw(context, request, cq));
    }
    // Starts the replication in the read replica instance.
    virtual ::grpc::Status StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncStartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncStartReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncStartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStartReplicaRaw(context, request, cq));
    }
    // Stops the replication in the read replica instance.
    virtual ::grpc::Status StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncStopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncStopReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncStopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStopReplicaRaw(context, request, cq));
    }
    // Truncate MySQL general and slow query log tables
    // MySQL only.
    virtual ::grpc::Status TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncTruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncTruncateLogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncTruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncTruncateLogRaw(context, request, cq));
    }
    // Updates settings of a Cloud SQL instance. Using this operation might cause
    // your instance to restart.
    virtual ::grpc::Status Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncUpdate(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncUpdateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncUpdate(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncUpdateRaw(context, request, cq));
    }
    // Generates a short-lived X509 certificate containing the provided public key
    // and signed by a private key specific to the target instance. Users may use
    // the certificate to authenticate as themselves when connecting to the
    // database.
    virtual ::grpc::Status CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::google::cloud::sql::v1::SslCert* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>> AsyncCreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>>(AsyncCreateEphemeralRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>> PrepareAsyncCreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>>(PrepareAsyncCreateEphemeralRaw(context, request, cq));
    }
    // Reschedules the maintenance on the given instance.
    virtual ::grpc::Status RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncRescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncRescheduleMaintenanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncRescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRescheduleMaintenanceRaw(context, request, cq));
    }
    // Verify External primary instance external sync settings.
    virtual ::grpc::Status VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>> AsyncVerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>>(AsyncVerifyExternalSyncSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>> PrepareAsyncVerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>>(PrepareAsyncVerifyExternalSyncSettingsRaw(context, request, cq));
    }
    // Start External primary instance migration.
    virtual ::grpc::Status StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncStartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncStartExternalSyncRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncStartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStartExternalSyncRaw(context, request, cq));
    }
    // Perform Disk Shrink on primary instance.
    virtual ::grpc::Status PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncPerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncPerformDiskShrinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncPerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPerformDiskShrinkRaw(context, request, cq));
    }
    // Get Disk Shrink Config for a given instance.
    virtual ::grpc::Status GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>> AsyncGetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>>(AsyncGetDiskShrinkConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>> PrepareAsyncGetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>>(PrepareAsyncGetDiskShrinkConfigRaw(context, request, cq));
    }
    // Reset Replica Size to primary instance disk size.
    virtual ::grpc::Status ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::google::cloud::sql::v1::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> AsyncResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(AsyncResetReplicaSizeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>> PrepareAsyncResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>>(PrepareAsyncResetReplicaSizeRaw(context, request, cq));
    }
    // Get Latest Recovery Time for a given instance.
    virtual ::grpc::Status GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>> AsyncGetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>>(AsyncGetLatestRecoveryTimeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>> PrepareAsyncGetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>>(PrepareAsyncGetLatestRecoveryTimeRaw(context, request, cq));
    }
    // Acquire a lease for the setup of SQL Server Reporting Services (SSRS).
    virtual ::grpc::Status AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>> AsyncAcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>>(AsyncAcquireSsrsLeaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>> PrepareAsyncAcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>>(PrepareAsyncAcquireSsrsLeaseRaw(context, request, cq));
    }
    // Release a lease for the setup of SQL Server Reporting Services (SSRS).
    virtual ::grpc::Status ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>> AsyncReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>>(AsyncReleaseSsrsLeaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>> PrepareAsyncReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>>(PrepareAsyncReleaseSsrsLeaseRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Adds a new trusted Certificate Authority (CA) version for the specified
      // instance. Required to prepare for a certificate rotation. If a CA version
      // was previously added but never used in a certificate rotation, this
      // operation replaces that version. There cannot be more than one CA version
      // waiting to be rotated in. For instances that have enabled Certificate
      // Authority Service (CAS) based server CA, please use AddServerCertificate to
      // add a new server certificate.
      virtual void AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Cloud SQL instance as a clone of the source instance. Using this
      // operation might cause your instance to restart.
      virtual void Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Cloud SQL instance.
      virtual void Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Demotes the stand-alone instance to be a Cloud SQL read replica for an
      // external database server.
      virtual void DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Demotes an existing standalone instance to be a Cloud SQL read replica
      // for an external database server.
      virtual void Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports data from a Cloud SQL instance to a Cloud Storage bucket as a SQL
      // dump or CSV file.
      virtual void Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Initiates a manual failover of a high availability (HA) primary instance
      // to a standby instance, which becomes the primary instance. Users are
      // then rerouted to the new primary. For more information, see the
      // [Overview of high
      // availability](https://cloud.google.com/sql/docs/mysql/high-availability)
      // page in the Cloud SQL documentation.
      // If using Legacy HA (MySQL only), this causes the instance to failover to
      // its failover replica instance.
      virtual void Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reencrypt CMEK instance with latest key version.
      virtual void Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a resource containing information about a Cloud SQL instance.
      virtual void Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports data into a Cloud SQL instance from a SQL dump  or CSV file in
      // Cloud Storage.
      virtual void Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Cloud SQL instance.
      virtual void Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists instances under a given project.
      virtual void List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all of the trusted Certificate Authorities (CAs) for the specified
      // instance. There can be up to three CAs listed: the CA that was used to sign
      // the certificate that is currently in use, a CA that has been added but not
      // yet used to sign a certificate, and a CA used to sign a certificate that
      // has previously rotated out.
      virtual void ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Partially updates settings of a Cloud SQL instance by merging the request
      // with the current configuration. This method supports patch semantics.
      virtual void Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Promotes the read replica instance to be an independent Cloud SQL
      // primary instance.
      // Using this operation might cause your instance to restart.
      virtual void PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Switches over from the primary instance to the designated DR replica
      // instance.
      virtual void Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes all client certificates and generates a new server SSL certificate
      // for the instance.
      virtual void ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restarts a Cloud SQL instance.
      virtual void Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores a backup of a Cloud SQL instance. Using this operation might cause
      // your instance to restart.
      virtual void RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rotates the server certificate to one signed by the Certificate Authority
      // (CA) version previously added with the addServerCA method. For instances
      // that have enabled Certificate Authority Service (CAS) based server CA,
      // please use RotateServerCertificate to rotate the server certificate.
      virtual void RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts the replication in the read replica instance.
      virtual void StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops the replication in the read replica instance.
      virtual void StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Truncate MySQL general and slow query log tables
      // MySQL only.
      virtual void TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates settings of a Cloud SQL instance. Using this operation might cause
      // your instance to restart.
      virtual void Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates a short-lived X509 certificate containing the provided public key
      // and signed by a private key specific to the target instance. Users may use
      // the certificate to authenticate as themselves when connecting to the
      // database.
      virtual void CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reschedules the maintenance on the given instance.
      virtual void RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Verify External primary instance external sync settings.
      virtual void VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Start External primary instance migration.
      virtual void StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Perform Disk Shrink on primary instance.
      virtual void PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get Disk Shrink Config for a given instance.
      virtual void GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reset Replica Size to primary instance disk size.
      virtual void ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get Latest Recovery Time for a given instance.
      virtual void GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Acquire a lease for the setup of SQL Server Reporting Services (SSRS).
      virtual void AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Release a lease for the setup of SQL Server Reporting Services (SSRS).
      virtual void ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncAddServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncAddServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncCloneRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncCloneRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncDeleteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncDeleteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncDemoteMasterRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncDemoteMasterRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncDemoteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncDemoteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncExportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncExportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncFailoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncFailoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncReencryptRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncReencryptRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>* AsyncGetRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::DatabaseInstance>* PrepareAsyncGetRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncImportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncImportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncInsertRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncInsertRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>* AsyncListRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListResponse>* PrepareAsyncListRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>* AsyncListServerCasRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::InstancesListServerCasResponse>* PrepareAsyncListServerCasRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncPatchRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncPatchRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncPromoteReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncPromoteReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncSwitchoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncSwitchoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncResetSslConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncResetSslConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncRestartRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncRestartRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncRestoreBackupRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncRestoreBackupRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncRotateServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncRotateServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncStartReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncStartReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncStopReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncStopReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncTruncateLogRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncTruncateLogRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncUpdateRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncUpdateRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>* AsyncCreateEphemeralRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SslCert>* PrepareAsyncCreateEphemeralRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncRescheduleMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncRescheduleMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* AsyncVerifyExternalSyncSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* PrepareAsyncVerifyExternalSyncSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncStartExternalSyncRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncStartExternalSyncRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncPerformDiskShrinkRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncPerformDiskShrinkRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* AsyncGetDiskShrinkConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* PrepareAsyncGetDiskShrinkConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* AsyncResetReplicaSizeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::Operation>* PrepareAsyncResetReplicaSizeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* AsyncGetLatestRecoveryTimeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* PrepareAsyncGetLatestRecoveryTimeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* AsyncAcquireSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* PrepareAsyncAcquireSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* AsyncReleaseSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* PrepareAsyncReleaseSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncAddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncAddServerCaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncAddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncAddServerCaRaw(context, request, cq));
    }
    ::grpc::Status Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncClone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncCloneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncClone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncCloneRaw(context, request, cq));
    }
    ::grpc::Status Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncDelete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncDeleteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncDelete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDeleteRaw(context, request, cq));
    }
    ::grpc::Status DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncDemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncDemoteMasterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncDemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDemoteMasterRaw(context, request, cq));
    }
    ::grpc::Status Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncDemote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncDemoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncDemote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncDemoteRaw(context, request, cq));
    }
    ::grpc::Status Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncExport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncExportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncExport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncExportRaw(context, request, cq));
    }
    ::grpc::Status Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncFailover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncFailoverRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncFailover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncFailoverRaw(context, request, cq));
    }
    ::grpc::Status Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncReencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncReencryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncReencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncReencryptRaw(context, request, cq));
    }
    ::grpc::Status Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::google::cloud::sql::v1::DatabaseInstance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>> AsyncGet(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>>(AsyncGetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>> PrepareAsyncGet(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>>(PrepareAsyncGetRaw(context, request, cq));
    }
    ::grpc::Status Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncImport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncImportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncImport(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncImportRaw(context, request, cq));
    }
    ::grpc::Status Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncInsert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncInsertRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncInsert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncInsertRaw(context, request, cq));
    }
    ::grpc::Status List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::google::cloud::sql::v1::InstancesListResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>> AsyncList(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>>(AsyncListRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>> PrepareAsyncList(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>>(PrepareAsyncListRaw(context, request, cq));
    }
    ::grpc::Status ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>> AsyncListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>>(AsyncListServerCasRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>> PrepareAsyncListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>>(PrepareAsyncListServerCasRaw(context, request, cq));
    }
    ::grpc::Status Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncPatch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncPatchRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncPatch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPatchRaw(context, request, cq));
    }
    ::grpc::Status PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncPromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncPromoteReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncPromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPromoteReplicaRaw(context, request, cq));
    }
    ::grpc::Status Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncSwitchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncSwitchoverRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncSwitchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncSwitchoverRaw(context, request, cq));
    }
    ::grpc::Status ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncResetSslConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncResetSslConfigRaw(context, request, cq));
    }
    ::grpc::Status Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncRestart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncRestartRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncRestart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRestartRaw(context, request, cq));
    }
    ::grpc::Status RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncRestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncRestoreBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncRestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRestoreBackupRaw(context, request, cq));
    }
    ::grpc::Status RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncRotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncRotateServerCaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncRotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRotateServerCaRaw(context, request, cq));
    }
    ::grpc::Status StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncStartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncStartReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncStartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStartReplicaRaw(context, request, cq));
    }
    ::grpc::Status StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncStopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncStopReplicaRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncStopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStopReplicaRaw(context, request, cq));
    }
    ::grpc::Status TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncTruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncTruncateLogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncTruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncTruncateLogRaw(context, request, cq));
    }
    ::grpc::Status Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncUpdate(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncUpdateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncUpdate(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncUpdateRaw(context, request, cq));
    }
    ::grpc::Status CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::google::cloud::sql::v1::SslCert* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>> AsyncCreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>>(AsyncCreateEphemeralRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>> PrepareAsyncCreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>>(PrepareAsyncCreateEphemeralRaw(context, request, cq));
    }
    ::grpc::Status RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncRescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncRescheduleMaintenanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncRescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncRescheduleMaintenanceRaw(context, request, cq));
    }
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>> AsyncVerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>>(AsyncVerifyExternalSyncSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>> PrepareAsyncVerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>>(PrepareAsyncVerifyExternalSyncSettingsRaw(context, request, cq));
    }
    ::grpc::Status StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncStartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncStartExternalSyncRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncStartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncStartExternalSyncRaw(context, request, cq));
    }
    ::grpc::Status PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncPerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncPerformDiskShrinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncPerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncPerformDiskShrinkRaw(context, request, cq));
    }
    ::grpc::Status GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>> AsyncGetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>>(AsyncGetDiskShrinkConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>> PrepareAsyncGetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>>(PrepareAsyncGetDiskShrinkConfigRaw(context, request, cq));
    }
    ::grpc::Status ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::google::cloud::sql::v1::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> AsyncResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(AsyncResetReplicaSizeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>> PrepareAsyncResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>>(PrepareAsyncResetReplicaSizeRaw(context, request, cq));
    }
    ::grpc::Status GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>> AsyncGetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>>(AsyncGetLatestRecoveryTimeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>> PrepareAsyncGetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>>(PrepareAsyncGetLatestRecoveryTimeRaw(context, request, cq));
    }
    ::grpc::Status AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>> AsyncAcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>>(AsyncAcquireSsrsLeaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>> PrepareAsyncAcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>>(PrepareAsyncAcquireSsrsLeaseRaw(context, request, cq));
    }
    ::grpc::Status ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>> AsyncReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>>(AsyncReleaseSsrsLeaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>> PrepareAsyncReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>>(PrepareAsyncReleaseSsrsLeaseRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void AddServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Clone(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Delete(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void DemoteMaster(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Demote(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Export(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Failover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Reencrypt(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response, std::function<void(::grpc::Status)>) override;
      void Get(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Import(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Insert(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response, std::function<void(::grpc::Status)>) override;
      void List(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServerCas(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Patch(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void PromoteReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Switchover(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetSslConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Restart(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void RestoreBackup(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void RotateServerCa(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void StopReplica(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void TruncateLog(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void Update(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response, std::function<void(::grpc::Status)>) override;
      void CreateEphemeral(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void RescheduleMaintenance(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response, std::function<void(::grpc::Status)>) override;
      void VerifyExternalSyncSettings(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartExternalSync(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void PerformDiskShrink(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response, std::function<void(::grpc::Status)>) override;
      void GetDiskShrinkConfig(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetReplicaSize(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response, std::function<void(::grpc::Status)>) override;
      void GetLatestRecoveryTime(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response, std::function<void(::grpc::Status)>) override;
      void AcquireSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response, std::function<void(::grpc::Status)>) override;
      void ReleaseSsrsLease(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncAddServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncAddServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncCloneRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncCloneRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncDeleteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncDeleteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncDemoteMasterRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncDemoteMasterRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncDemoteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncDemoteRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncExportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncExportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncFailoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncFailoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncReencryptRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncReencryptRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>* AsyncGetRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::DatabaseInstance>* PrepareAsyncGetRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncImportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncImportRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncInsertRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncInsertRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>* AsyncListRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListResponse>* PrepareAsyncListRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>* AsyncListServerCasRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::InstancesListServerCasResponse>* PrepareAsyncListServerCasRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncPatchRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncPatchRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncPromoteReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncPromoteReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncSwitchoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncSwitchoverRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncResetSslConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncResetSslConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncRestartRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncRestartRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncRestoreBackupRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncRestoreBackupRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncRotateServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncRotateServerCaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncStartReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncStartReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncStopReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncStopReplicaRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncTruncateLogRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncTruncateLogRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncUpdateRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncUpdateRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>* AsyncCreateEphemeralRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SslCert>* PrepareAsyncCreateEphemeralRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncRescheduleMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncRescheduleMaintenanceRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* AsyncVerifyExternalSyncSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* PrepareAsyncVerifyExternalSyncSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncStartExternalSyncRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncStartExternalSyncRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncPerformDiskShrinkRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncPerformDiskShrinkRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* AsyncGetDiskShrinkConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* PrepareAsyncGetDiskShrinkConfigRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* AsyncResetReplicaSizeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::Operation>* PrepareAsyncResetReplicaSizeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* AsyncGetLatestRecoveryTimeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* PrepareAsyncGetLatestRecoveryTimeRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* AsyncAcquireSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* PrepareAsyncAcquireSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* AsyncReleaseSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* PrepareAsyncReleaseSsrsLeaseRaw(::grpc::ClientContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_AddServerCa_;
    const ::grpc::internal::RpcMethod rpcmethod_Clone_;
    const ::grpc::internal::RpcMethod rpcmethod_Delete_;
    const ::grpc::internal::RpcMethod rpcmethod_DemoteMaster_;
    const ::grpc::internal::RpcMethod rpcmethod_Demote_;
    const ::grpc::internal::RpcMethod rpcmethod_Export_;
    const ::grpc::internal::RpcMethod rpcmethod_Failover_;
    const ::grpc::internal::RpcMethod rpcmethod_Reencrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_Get_;
    const ::grpc::internal::RpcMethod rpcmethod_Import_;
    const ::grpc::internal::RpcMethod rpcmethod_Insert_;
    const ::grpc::internal::RpcMethod rpcmethod_List_;
    const ::grpc::internal::RpcMethod rpcmethod_ListServerCas_;
    const ::grpc::internal::RpcMethod rpcmethod_Patch_;
    const ::grpc::internal::RpcMethod rpcmethod_PromoteReplica_;
    const ::grpc::internal::RpcMethod rpcmethod_Switchover_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetSslConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_Restart_;
    const ::grpc::internal::RpcMethod rpcmethod_RestoreBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_RotateServerCa_;
    const ::grpc::internal::RpcMethod rpcmethod_StartReplica_;
    const ::grpc::internal::RpcMethod rpcmethod_StopReplica_;
    const ::grpc::internal::RpcMethod rpcmethod_TruncateLog_;
    const ::grpc::internal::RpcMethod rpcmethod_Update_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEphemeral_;
    const ::grpc::internal::RpcMethod rpcmethod_RescheduleMaintenance_;
    const ::grpc::internal::RpcMethod rpcmethod_VerifyExternalSyncSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_StartExternalSync_;
    const ::grpc::internal::RpcMethod rpcmethod_PerformDiskShrink_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDiskShrinkConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetReplicaSize_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLatestRecoveryTime_;
    const ::grpc::internal::RpcMethod rpcmethod_AcquireSsrsLease_;
    const ::grpc::internal::RpcMethod rpcmethod_ReleaseSsrsLease_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Adds a new trusted Certificate Authority (CA) version for the specified
    // instance. Required to prepare for a certificate rotation. If a CA version
    // was previously added but never used in a certificate rotation, this
    // operation replaces that version. There cannot be more than one CA version
    // waiting to be rotated in. For instances that have enabled Certificate
    // Authority Service (CAS) based server CA, please use AddServerCertificate to
    // add a new server certificate.
    virtual ::grpc::Status AddServerCa(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Creates a Cloud SQL instance as a clone of the source instance. Using this
    // operation might cause your instance to restart.
    virtual ::grpc::Status Clone(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Deletes a Cloud SQL instance.
    virtual ::grpc::Status Delete(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Demotes the stand-alone instance to be a Cloud SQL read replica for an
    // external database server.
    virtual ::grpc::Status DemoteMaster(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Demotes an existing standalone instance to be a Cloud SQL read replica
    // for an external database server.
    virtual ::grpc::Status Demote(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Exports data from a Cloud SQL instance to a Cloud Storage bucket as a SQL
    // dump or CSV file.
    virtual ::grpc::Status Export(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Initiates a manual failover of a high availability (HA) primary instance
    // to a standby instance, which becomes the primary instance. Users are
    // then rerouted to the new primary. For more information, see the
    // [Overview of high
    // availability](https://cloud.google.com/sql/docs/mysql/high-availability)
    // page in the Cloud SQL documentation.
    // If using Legacy HA (MySQL only), this causes the instance to failover to
    // its failover replica instance.
    virtual ::grpc::Status Failover(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Reencrypt CMEK instance with latest key version.
    virtual ::grpc::Status Reencrypt(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Retrieves a resource containing information about a Cloud SQL instance.
    virtual ::grpc::Status Get(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response);
    // Imports data into a Cloud SQL instance from a SQL dump  or CSV file in
    // Cloud Storage.
    virtual ::grpc::Status Import(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Creates a new Cloud SQL instance.
    virtual ::grpc::Status Insert(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Lists instances under a given project.
    virtual ::grpc::Status List(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response);
    // Lists all of the trusted Certificate Authorities (CAs) for the specified
    // instance. There can be up to three CAs listed: the CA that was used to sign
    // the certificate that is currently in use, a CA that has been added but not
    // yet used to sign a certificate, and a CA used to sign a certificate that
    // has previously rotated out.
    virtual ::grpc::Status ListServerCas(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response);
    // Partially updates settings of a Cloud SQL instance by merging the request
    // with the current configuration. This method supports patch semantics.
    virtual ::grpc::Status Patch(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Promotes the read replica instance to be an independent Cloud SQL
    // primary instance.
    // Using this operation might cause your instance to restart.
    virtual ::grpc::Status PromoteReplica(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Switches over from the primary instance to the designated DR replica
    // instance.
    virtual ::grpc::Status Switchover(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Deletes all client certificates and generates a new server SSL certificate
    // for the instance.
    virtual ::grpc::Status ResetSslConfig(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Restarts a Cloud SQL instance.
    virtual ::grpc::Status Restart(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Restores a backup of a Cloud SQL instance. Using this operation might cause
    // your instance to restart.
    virtual ::grpc::Status RestoreBackup(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Rotates the server certificate to one signed by the Certificate Authority
    // (CA) version previously added with the addServerCA method. For instances
    // that have enabled Certificate Authority Service (CAS) based server CA,
    // please use RotateServerCertificate to rotate the server certificate.
    virtual ::grpc::Status RotateServerCa(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Starts the replication in the read replica instance.
    virtual ::grpc::Status StartReplica(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Stops the replication in the read replica instance.
    virtual ::grpc::Status StopReplica(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Truncate MySQL general and slow query log tables
    // MySQL only.
    virtual ::grpc::Status TruncateLog(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Updates settings of a Cloud SQL instance. Using this operation might cause
    // your instance to restart.
    virtual ::grpc::Status Update(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Generates a short-lived X509 certificate containing the provided public key
    // and signed by a private key specific to the target instance. Users may use
    // the certificate to authenticate as themselves when connecting to the
    // database.
    virtual ::grpc::Status CreateEphemeral(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response);
    // Reschedules the maintenance on the given instance.
    virtual ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Verify External primary instance external sync settings.
    virtual ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response);
    // Start External primary instance migration.
    virtual ::grpc::Status StartExternalSync(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Perform Disk Shrink on primary instance.
    virtual ::grpc::Status PerformDiskShrink(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Get Disk Shrink Config for a given instance.
    virtual ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response);
    // Reset Replica Size to primary instance disk size.
    virtual ::grpc::Status ResetReplicaSize(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response);
    // Get Latest Recovery Time for a given instance.
    virtual ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response);
    // Acquire a lease for the setup of SQL Server Reporting Services (SSRS).
    virtual ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response);
    // Release a lease for the setup of SQL Server Reporting Services (SSRS).
    virtual ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddServerCa() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddServerCa(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Clone() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestClone(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Delete() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDelete(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDemoteMaster(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Demote() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDemote(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Export() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExport(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Failover() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFailover(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Reencrypt() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReencrypt(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Get() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGet(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::DatabaseInstance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Import() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImport(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Insert() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsert(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_List() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestList(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::InstancesListResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServerCas() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServerCas(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::InstancesListServerCasResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Patch() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPatch(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPromoteReplica(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Switchover() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSwitchover(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetSslConfig(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Restart() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestart(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreBackup(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRotateServerCa(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartReplica() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartReplica(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StopReplica() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopReplica(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TruncateLog() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTruncateLog(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Update() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdate(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEphemeral(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SslCert>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRescheduleMaintenance(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestVerifyExternalSyncSettings(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartExternalSync(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPerformDiskShrink(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDiskShrinkConfig(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetReplicaSize(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLatestRecoveryTime(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcquireSsrsLease(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReleaseSsrsLease(::grpc::ServerContext* context, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_AddServerCa<WithAsyncMethod_Clone<WithAsyncMethod_Delete<WithAsyncMethod_DemoteMaster<WithAsyncMethod_Demote<WithAsyncMethod_Export<WithAsyncMethod_Failover<WithAsyncMethod_Reencrypt<WithAsyncMethod_Get<WithAsyncMethod_Import<WithAsyncMethod_Insert<WithAsyncMethod_List<WithAsyncMethod_ListServerCas<WithAsyncMethod_Patch<WithAsyncMethod_PromoteReplica<WithAsyncMethod_Switchover<WithAsyncMethod_ResetSslConfig<WithAsyncMethod_Restart<WithAsyncMethod_RestoreBackup<WithAsyncMethod_RotateServerCa<WithAsyncMethod_StartReplica<WithAsyncMethod_StopReplica<WithAsyncMethod_TruncateLog<WithAsyncMethod_Update<WithAsyncMethod_CreateEphemeral<WithAsyncMethod_RescheduleMaintenance<WithAsyncMethod_VerifyExternalSyncSettings<WithAsyncMethod_StartExternalSync<WithAsyncMethod_PerformDiskShrink<WithAsyncMethod_GetDiskShrinkConfig<WithAsyncMethod_ResetReplicaSize<WithAsyncMethod_GetLatestRecoveryTime<WithAsyncMethod_AcquireSsrsLease<WithAsyncMethod_ReleaseSsrsLease<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddServerCa() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->AddServerCa(context, request, response); }));}
    void SetMessageAllocatorFor_AddServerCa(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddServerCa(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Clone() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesCloneRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Clone(context, request, response); }));}
    void SetMessageAllocatorFor_Clone(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesCloneRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesCloneRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Clone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Delete() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDeleteRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Delete(context, request, response); }));}
    void SetMessageAllocatorFor_Delete(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesDeleteRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDeleteRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Delete(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->DemoteMaster(context, request, response); }));}
    void SetMessageAllocatorFor_DemoteMaster(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DemoteMaster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Demote() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDemoteRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Demote(context, request, response); }));}
    void SetMessageAllocatorFor_Demote(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesDemoteRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesDemoteRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Demote(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Export() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesExportRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesExportRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Export(context, request, response); }));}
    void SetMessageAllocatorFor_Export(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesExportRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesExportRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Export(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Failover() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesFailoverRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Failover(context, request, response); }));}
    void SetMessageAllocatorFor_Failover(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesFailoverRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesFailoverRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Failover(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Reencrypt() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesReencryptRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Reencrypt(context, request, response); }));}
    void SetMessageAllocatorFor_Reencrypt(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesReencryptRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesReencryptRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Reencrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Get() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetRequest, ::google::cloud::sql::v1::DatabaseInstance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetRequest* request, ::google::cloud::sql::v1::DatabaseInstance* response) { return this->Get(context, request, response); }));}
    void SetMessageAllocatorFor_Get(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesGetRequest, ::google::cloud::sql::v1::DatabaseInstance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetRequest, ::google::cloud::sql::v1::DatabaseInstance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Get(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Import() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesImportRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesImportRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Import(context, request, response); }));}
    void SetMessageAllocatorFor_Import(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesImportRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesImportRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Import(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Insert() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesInsertRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Insert(context, request, response); }));}
    void SetMessageAllocatorFor_Insert(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesInsertRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesInsertRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Insert(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_List() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesListRequest, ::google::cloud::sql::v1::InstancesListResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesListRequest* request, ::google::cloud::sql::v1::InstancesListResponse* response) { return this->List(context, request, response); }));}
    void SetMessageAllocatorFor_List(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesListRequest, ::google::cloud::sql::v1::InstancesListResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesListRequest, ::google::cloud::sql::v1::InstancesListResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* List(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServerCas() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesListServerCasRequest, ::google::cloud::sql::v1::InstancesListServerCasResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* request, ::google::cloud::sql::v1::InstancesListServerCasResponse* response) { return this->ListServerCas(context, request, response); }));}
    void SetMessageAllocatorFor_ListServerCas(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesListServerCasRequest, ::google::cloud::sql::v1::InstancesListServerCasResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesListServerCasRequest, ::google::cloud::sql::v1::InstancesListServerCasResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServerCas(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Patch() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPatchRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Patch(context, request, response); }));}
    void SetMessageAllocatorFor_Patch(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesPatchRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPatchRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Patch(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->PromoteReplica(context, request, response); }));}
    void SetMessageAllocatorFor_PromoteReplica(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PromoteReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Switchover() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Switchover(context, request, response); }));}
    void SetMessageAllocatorFor_Switchover(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Switchover(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->ResetSslConfig(context, request, response); }));}
    void SetMessageAllocatorFor_ResetSslConfig(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetSslConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Restart() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRestartRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Restart(context, request, response); }));}
    void SetMessageAllocatorFor_Restart(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesRestartRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRestartRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Restart(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->RestoreBackup(context, request, response); }));}
    void SetMessageAllocatorFor_RestoreBackup(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->RotateServerCa(context, request, response); }));}
    void SetMessageAllocatorFor_RotateServerCa(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RotateServerCa(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartReplica() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->StartReplica(context, request, response); }));}
    void SetMessageAllocatorFor_StartReplica(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StopReplica() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->StopReplica(context, request, response); }));}
    void SetMessageAllocatorFor_StopReplica(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TruncateLog() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->TruncateLog(context, request, response); }));}
    void SetMessageAllocatorFor_TruncateLog(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TruncateLog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Update() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesUpdateRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->Update(context, request, response); }));}
    void SetMessageAllocatorFor_Update(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesUpdateRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesUpdateRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Update(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest, ::google::cloud::sql::v1::SslCert>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* request, ::google::cloud::sql::v1::SslCert* response) { return this->CreateEphemeral(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEphemeral(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest, ::google::cloud::sql::v1::SslCert>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest, ::google::cloud::sql::v1::SslCert>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEphemeral(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->RescheduleMaintenance(context, request, response); }));}
    void SetMessageAllocatorFor_RescheduleMaintenance(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RescheduleMaintenance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* request, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* response) { return this->VerifyExternalSyncSettings(context, request, response); }));}
    void SetMessageAllocatorFor_VerifyExternalSyncSettings(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* VerifyExternalSyncSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->StartExternalSync(context, request, response); }));}
    void SetMessageAllocatorFor_StartExternalSync(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartExternalSync(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->PerformDiskShrink(context, request, response); }));}
    void SetMessageAllocatorFor_PerformDiskShrink(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PerformDiskShrink(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* request, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* response) { return this->GetDiskShrinkConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetDiskShrinkConfig(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDiskShrinkConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest, ::google::cloud::sql::v1::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* request, ::google::cloud::sql::v1::Operation* response) { return this->ResetReplicaSize(context, request, response); }));}
    void SetMessageAllocatorFor_ResetReplicaSize(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest, ::google::cloud::sql::v1::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest, ::google::cloud::sql::v1::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetReplicaSize(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* request, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* response) { return this->GetLatestRecoveryTime(context, request, response); }));}
    void SetMessageAllocatorFor_GetLatestRecoveryTime(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLatestRecoveryTime(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* response) { return this->AcquireSsrsLease(context, request, response); }));}
    void SetMessageAllocatorFor_AcquireSsrsLease(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcquireSsrsLease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* request, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* response) { return this->ReleaseSsrsLease(context, request, response); }));}
    void SetMessageAllocatorFor_ReleaseSsrsLease(
        ::grpc::MessageAllocator< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReleaseSsrsLease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_AddServerCa<WithCallbackMethod_Clone<WithCallbackMethod_Delete<WithCallbackMethod_DemoteMaster<WithCallbackMethod_Demote<WithCallbackMethod_Export<WithCallbackMethod_Failover<WithCallbackMethod_Reencrypt<WithCallbackMethod_Get<WithCallbackMethod_Import<WithCallbackMethod_Insert<WithCallbackMethod_List<WithCallbackMethod_ListServerCas<WithCallbackMethod_Patch<WithCallbackMethod_PromoteReplica<WithCallbackMethod_Switchover<WithCallbackMethod_ResetSslConfig<WithCallbackMethod_Restart<WithCallbackMethod_RestoreBackup<WithCallbackMethod_RotateServerCa<WithCallbackMethod_StartReplica<WithCallbackMethod_StopReplica<WithCallbackMethod_TruncateLog<WithCallbackMethod_Update<WithCallbackMethod_CreateEphemeral<WithCallbackMethod_RescheduleMaintenance<WithCallbackMethod_VerifyExternalSyncSettings<WithCallbackMethod_StartExternalSync<WithCallbackMethod_PerformDiskShrink<WithCallbackMethod_GetDiskShrinkConfig<WithCallbackMethod_ResetReplicaSize<WithCallbackMethod_GetLatestRecoveryTime<WithCallbackMethod_AcquireSsrsLease<WithCallbackMethod_ReleaseSsrsLease<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddServerCa() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Clone() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Delete() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Demote() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Export() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Failover() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Reencrypt() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Get() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Import() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Insert() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_List() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServerCas() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Patch() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Switchover() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Restart() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartReplica() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StopReplica() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TruncateLog() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Update() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddServerCa() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddServerCa(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Clone() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestClone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Delete() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDelete(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDemoteMaster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Demote() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDemote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Export() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Failover() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFailover(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Reencrypt() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReencrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Get() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Import() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Insert() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsert(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_List() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestList(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServerCas() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServerCas(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Patch() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPatch(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPromoteReplica(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Switchover() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSwitchover(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetSslConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Restart() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestart(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRotateServerCa(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartReplica() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartReplica(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StopReplica() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopReplica(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TruncateLog() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTruncateLog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Update() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEphemeral(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRescheduleMaintenance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestVerifyExternalSyncSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartExternalSync(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPerformDiskShrink(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDiskShrinkConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetReplicaSize(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLatestRecoveryTime(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcquireSsrsLease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReleaseSsrsLease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddServerCa() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddServerCa(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddServerCa(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Clone() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Clone(context, request, response); }));
    }
    ~WithRawCallbackMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Clone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Delete() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Delete(context, request, response); }));
    }
    ~WithRawCallbackMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Delete(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DemoteMaster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DemoteMaster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Demote() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Demote(context, request, response); }));
    }
    ~WithRawCallbackMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Demote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Export() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Export(context, request, response); }));
    }
    ~WithRawCallbackMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Export(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Failover() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Failover(context, request, response); }));
    }
    ~WithRawCallbackMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Failover(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Reencrypt() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Reencrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Reencrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Get() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Get(context, request, response); }));
    }
    ~WithRawCallbackMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Get(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Import() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Import(context, request, response); }));
    }
    ~WithRawCallbackMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Import(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Insert() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Insert(context, request, response); }));
    }
    ~WithRawCallbackMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Insert(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_List() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->List(context, request, response); }));
    }
    ~WithRawCallbackMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* List(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServerCas() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServerCas(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServerCas(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Patch() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Patch(context, request, response); }));
    }
    ~WithRawCallbackMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Patch(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PromoteReplica(context, request, response); }));
    }
    ~WithRawCallbackMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PromoteReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Switchover() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Switchover(context, request, response); }));
    }
    ~WithRawCallbackMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Switchover(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetSslConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetSslConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Restart() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Restart(context, request, response); }));
    }
    ~WithRawCallbackMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Restart(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RestoreBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RotateServerCa(context, request, response); }));
    }
    ~WithRawCallbackMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RotateServerCa(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartReplica() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartReplica(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StopReplica() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StopReplica(context, request, response); }));
    }
    ~WithRawCallbackMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopReplica(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TruncateLog() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TruncateLog(context, request, response); }));
    }
    ~WithRawCallbackMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TruncateLog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Update() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Update(context, request, response); }));
    }
    ~WithRawCallbackMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Update(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEphemeral(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEphemeral(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RescheduleMaintenance(context, request, response); }));
    }
    ~WithRawCallbackMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RescheduleMaintenance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->VerifyExternalSyncSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* VerifyExternalSyncSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartExternalSync(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartExternalSync(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PerformDiskShrink(context, request, response); }));
    }
    ~WithRawCallbackMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PerformDiskShrink(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDiskShrinkConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDiskShrinkConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetReplicaSize(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetReplicaSize(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLatestRecoveryTime(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLatestRecoveryTime(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AcquireSsrsLease(context, request, response); }));
    }
    ~WithRawCallbackMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcquireSsrsLease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReleaseSsrsLease(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReleaseSsrsLease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddServerCa() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedAddServerCa(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddServerCa(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesAddServerCaRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Clone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Clone() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesCloneRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesCloneRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedClone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Clone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Clone(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCloneRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedClone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesCloneRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Delete : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Delete() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesDeleteRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesDeleteRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedDelete(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Delete() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Delete(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDeleteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDelete(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesDeleteRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DemoteMaster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DemoteMaster() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedDemoteMaster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DemoteMaster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DemoteMaster(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDemoteMaster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesDemoteMasterRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Demote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Demote() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesDemoteRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesDemoteRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedDemote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Demote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Demote(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesDemoteRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDemote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesDemoteRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Export : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Export() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesExportRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesExportRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedExport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Export() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Export(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesExportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesExportRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Failover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Failover() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesFailoverRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesFailoverRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedFailover(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Failover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Failover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesFailoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFailover(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesFailoverRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Reencrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Reencrypt() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesReencryptRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesReencryptRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedReencrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Reencrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Reencrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReencryptRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReencrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesReencryptRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Get : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Get() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesGetRequest, ::google::cloud::sql::v1::DatabaseInstance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesGetRequest, ::google::cloud::sql::v1::DatabaseInstance>* streamer) {
                       return this->StreamedGet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Get() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Get(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetRequest* /*request*/, ::google::cloud::sql::v1::DatabaseInstance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesGetRequest,::google::cloud::sql::v1::DatabaseInstance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Import : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Import() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesImportRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesImportRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedImport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Import() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Import(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesImportRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesImportRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Insert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Insert() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesInsertRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesInsertRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedInsert(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Insert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Insert(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesInsertRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInsert(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesInsertRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_List : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_List() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesListRequest, ::google::cloud::sql::v1::InstancesListResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesListRequest, ::google::cloud::sql::v1::InstancesListResponse>* streamer) {
                       return this->StreamedList(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_List() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status List(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListRequest* /*request*/, ::google::cloud::sql::v1::InstancesListResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedList(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesListRequest,::google::cloud::sql::v1::InstancesListResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServerCas : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServerCas() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesListServerCasRequest, ::google::cloud::sql::v1::InstancesListServerCasResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesListServerCasRequest, ::google::cloud::sql::v1::InstancesListServerCasResponse>* streamer) {
                       return this->StreamedListServerCas(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServerCas() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServerCas(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesListServerCasRequest* /*request*/, ::google::cloud::sql::v1::InstancesListServerCasResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServerCas(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesListServerCasRequest,::google::cloud::sql::v1::InstancesListServerCasResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Patch : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Patch() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesPatchRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesPatchRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedPatch(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Patch() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Patch(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPatchRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPatch(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesPatchRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PromoteReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PromoteReplica() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedPromoteReplica(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PromoteReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PromoteReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPromoteReplica(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesPromoteReplicaRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Switchover : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Switchover() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedSwitchover(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Switchover() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Switchover(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSwitchover(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesSwitchoverRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetSslConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetSslConfig() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedResetSslConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetSslConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetSslConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetSslConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesResetSslConfigRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Restart : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Restart() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesRestartRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesRestartRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedRestart(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Restart() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Restart(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestartRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestart(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesRestartRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestoreBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestoreBackup() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedRestoreBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RestoreBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestoreBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestoreBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesRestoreBackupRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RotateServerCa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RotateServerCa() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedRotateServerCa(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RotateServerCa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RotateServerCa(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRotateServerCa(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesRotateServerCaRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartReplica() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedStartReplica(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartReplica(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesStartReplicaRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StopReplica : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StopReplica() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedStopReplica(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StopReplica() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StopReplica(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStopReplica(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesStopReplicaRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TruncateLog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TruncateLog() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedTruncateLog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TruncateLog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TruncateLog(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTruncateLog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesTruncateLogRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Update() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesUpdateRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesUpdateRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedUpdate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesUpdateRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesUpdateRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEphemeral : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEphemeral() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest, ::google::cloud::sql::v1::SslCert>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest, ::google::cloud::sql::v1::SslCert>* streamer) {
                       return this->StreamedCreateEphemeral(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEphemeral() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEphemeral(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest* /*request*/, ::google::cloud::sql::v1::SslCert* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEphemeral(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesCreateEphemeralCertRequest,::google::cloud::sql::v1::SslCert>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RescheduleMaintenance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RescheduleMaintenance() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedRescheduleMaintenance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RescheduleMaintenance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RescheduleMaintenance(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRescheduleMaintenance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesRescheduleMaintenanceRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_VerifyExternalSyncSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_VerifyExternalSyncSettings() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* streamer) {
                       return this->StreamedVerifyExternalSyncSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_VerifyExternalSyncSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status VerifyExternalSyncSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedVerifyExternalSyncSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsRequest,::google::cloud::sql::v1::SqlInstancesVerifyExternalSyncSettingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartExternalSync : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartExternalSync() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedStartExternalSync(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartExternalSync() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartExternalSync(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartExternalSync(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesStartExternalSyncRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PerformDiskShrink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PerformDiskShrink() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedPerformDiskShrink(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PerformDiskShrink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PerformDiskShrink(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPerformDiskShrink(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesPerformDiskShrinkRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDiskShrinkConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDiskShrinkConfig() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* streamer) {
                       return this->StreamedGetDiskShrinkConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDiskShrinkConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDiskShrinkConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDiskShrinkConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigRequest,::google::cloud::sql::v1::SqlInstancesGetDiskShrinkConfigResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetReplicaSize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetReplicaSize() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest, ::google::cloud::sql::v1::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest, ::google::cloud::sql::v1::Operation>* streamer) {
                       return this->StreamedResetReplicaSize(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetReplicaSize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetReplicaSize(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest* /*request*/, ::google::cloud::sql::v1::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetReplicaSize(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesResetReplicaSizeRequest,::google::cloud::sql::v1::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLatestRecoveryTime : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLatestRecoveryTime() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* streamer) {
                       return this->StreamedGetLatestRecoveryTime(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLatestRecoveryTime() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLatestRecoveryTime(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLatestRecoveryTime(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeRequest,::google::cloud::sql::v1::SqlInstancesGetLatestRecoveryTimeResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AcquireSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AcquireSsrsLease() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* streamer) {
                       return this->StreamedAcquireSsrsLease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AcquireSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AcquireSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAcquireSsrsLease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseRequest,::google::cloud::sql::v1::SqlInstancesAcquireSsrsLeaseResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReleaseSsrsLease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReleaseSsrsLease() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* streamer) {
                       return this->StreamedReleaseSsrsLease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReleaseSsrsLease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReleaseSsrsLease(::grpc::ServerContext* /*context*/, const ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest* /*request*/, ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReleaseSsrsLease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseRequest,::google::cloud::sql::v1::SqlInstancesReleaseSsrsLeaseResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_AddServerCa<WithStreamedUnaryMethod_Clone<WithStreamedUnaryMethod_Delete<WithStreamedUnaryMethod_DemoteMaster<WithStreamedUnaryMethod_Demote<WithStreamedUnaryMethod_Export<WithStreamedUnaryMethod_Failover<WithStreamedUnaryMethod_Reencrypt<WithStreamedUnaryMethod_Get<WithStreamedUnaryMethod_Import<WithStreamedUnaryMethod_Insert<WithStreamedUnaryMethod_List<WithStreamedUnaryMethod_ListServerCas<WithStreamedUnaryMethod_Patch<WithStreamedUnaryMethod_PromoteReplica<WithStreamedUnaryMethod_Switchover<WithStreamedUnaryMethod_ResetSslConfig<WithStreamedUnaryMethod_Restart<WithStreamedUnaryMethod_RestoreBackup<WithStreamedUnaryMethod_RotateServerCa<WithStreamedUnaryMethod_StartReplica<WithStreamedUnaryMethod_StopReplica<WithStreamedUnaryMethod_TruncateLog<WithStreamedUnaryMethod_Update<WithStreamedUnaryMethod_CreateEphemeral<WithStreamedUnaryMethod_RescheduleMaintenance<WithStreamedUnaryMethod_VerifyExternalSyncSettings<WithStreamedUnaryMethod_StartExternalSync<WithStreamedUnaryMethod_PerformDiskShrink<WithStreamedUnaryMethod_GetDiskShrinkConfig<WithStreamedUnaryMethod_ResetReplicaSize<WithStreamedUnaryMethod_GetLatestRecoveryTime<WithStreamedUnaryMethod_AcquireSsrsLease<WithStreamedUnaryMethod_ReleaseSsrsLease<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_AddServerCa<WithStreamedUnaryMethod_Clone<WithStreamedUnaryMethod_Delete<WithStreamedUnaryMethod_DemoteMaster<WithStreamedUnaryMethod_Demote<WithStreamedUnaryMethod_Export<WithStreamedUnaryMethod_Failover<WithStreamedUnaryMethod_Reencrypt<WithStreamedUnaryMethod_Get<WithStreamedUnaryMethod_Import<WithStreamedUnaryMethod_Insert<WithStreamedUnaryMethod_List<WithStreamedUnaryMethod_ListServerCas<WithStreamedUnaryMethod_Patch<WithStreamedUnaryMethod_PromoteReplica<WithStreamedUnaryMethod_Switchover<WithStreamedUnaryMethod_ResetSslConfig<WithStreamedUnaryMethod_Restart<WithStreamedUnaryMethod_RestoreBackup<WithStreamedUnaryMethod_RotateServerCa<WithStreamedUnaryMethod_StartReplica<WithStreamedUnaryMethod_StopReplica<WithStreamedUnaryMethod_TruncateLog<WithStreamedUnaryMethod_Update<WithStreamedUnaryMethod_CreateEphemeral<WithStreamedUnaryMethod_RescheduleMaintenance<WithStreamedUnaryMethod_VerifyExternalSyncSettings<WithStreamedUnaryMethod_StartExternalSync<WithStreamedUnaryMethod_PerformDiskShrink<WithStreamedUnaryMethod_GetDiskShrinkConfig<WithStreamedUnaryMethod_ResetReplicaSize<WithStreamedUnaryMethod_GetLatestRecoveryTime<WithStreamedUnaryMethod_AcquireSsrsLease<WithStreamedUnaryMethod_ReleaseSsrsLease<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace sql
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fsql_2fv1_2fcloud_5fsql_5finstances_2eproto__INCLUDED
